
    |font codeFont titleFont installWebTools|
    
installWebTools := false.
Preferences disable: #showDeprecationWarnings.

[ Gofer gofer load ]
  on: Error
  do: [ :err | err retry ].
Gofer gofer recompile.

Gofer new
	squeaksource: 'RoelTyper';
	package: 'RoelTyper';
	load.

Gofer new
	squeaksource: 'NewInspector';
	package: 'NewInspector'; "no override in version NewInspector-PF.34"
	load.

Gofer new
	squeaksource: 'shout';
	package: 'Shout'; "no override in version 73"
	package: 'ShoutWorkspace.1'; "no override in version 4"
	load.

Gofer new
	squeaksource: 'rb';
	package: 'AST-Core';
	package: 'Refactoring-Core';
	package: 'Refactoring-Spelling';
	load.

Gofer new
	wiresong: 'ob';
	package: 'OmniBrowser';
	package: 'OB-Morphic';
	package: 'OB-Standard';
	package: 'OB-Refactory';
	package: 'OB-Regex';
	package: 'OB-SUnitIntegration';
	package: 'OB-Shout';
	load.

Gofer new
	squeaksource: 'EnhancedOB';
	package: 'OmniBrowser2';
	package: 'O2-Standard';
	package: 'O2-Morphic';
	package: 'O2-Enhancements';
	package: 'OCForO2';
	package: 'O2-Refactory';
	load.

[Gofer new
	squeaksource: 'OCompletion';
	package: 'Ocompletion';
	package: 'OCForOB';
	load.
] valueSupplyingAnswers: {{ 'list of packages'. 'Kernel* Collection*' }}.

Gofer new
	squeaksource: 'Nile';
	package: 'Nile-All';
	load.

Gofer new
	squeaksource: 'autoMethodCat';
	package: 'AutomaticMethodCategorizer';
	package: 'AutomaticMethodCategorizerOB';
	load.

Gofer new
	squeaksource: 'PharoMorphicExtras';
	package: 'MorphExamplesAndDemos';
	package: 'LED';
	load.

Gofer new
	squeaksource: 'PharoSound';
	package: 'Sound';
	package: 'SoundMorphicUserInterface';
	load.

installWebTools ifTrue: [

	Gofer new
		squeaksource: 'KomHttpServer';
		package: 'DynamicBindings';
		package: 'KomServices';
		package: 'KomHttpServer';
		load.
	
	[Gofer new
		squeaksource: 'Seaside';
		package: 'Seaside2.8a1';
		package: 'Scriptaculous';
		load.] valueSupplyingAnswers: {
		       			 {'.*username.*' . 'admin'} .
					 {'.*password.*' . 'seaside'}}.

 	Gofer new
		renggli: 'slime';
		package: 'Slime';
		load.

	Gofer new
		squeaksource: 'rsrss';
		package: 'RSRSS2';
		load.

	Gofer new
		renggli: 'magritte';
		package: 'Magritte-All';
		load.

	[Gofer new
		renggli: 'pier';
 		package: 'Pier-All';
		package: 'Pier-Squeak-Persistency';
		load] valueSupplyingAnswers: {
			{  'Would you like.*' . true}.
			{  '.*name of your Pier kernel.*' . 'Pier'}.
 			{  '.*entry point.*' . 'pier'}.
 			{  '.*port number.*' . '8080'}}.

	[Gofer new
		renggli: 'pieraddons';
		package: 'Pier-Design';
		package: 'Pier-Documents';
		package: 'Pier-EditorEnh';
		package: 'Pier-Google';
		package: 'Pier-LightBox';
		package: 'Pier-Links';
		package: 'Pier-Randomizer';
		package: 'Pier-Setup';
		package: 'Pier-SyntaxHighlighter';
		package: 'Pier-TagCloud';
		package: 'Pier-Titles';
		package: 'Pier-Twitter';
		package: 'Sitemap';
		load] valueSupplyingAnswers: {{ '.*SlideShare.*' . ''}}.

	Gofer new
		renggli: 'unsorted';
		package: 'RFB';
		load.

	(Smalltalk classNamed: #PRDistribution) new register.
].

"
   FreeTypeFontProvider current updateFromSystem.
   		
   font := LogicalFont familyName: 'DejaVu Sans' pointSize: 10.
   codeFont := LogicalFont familyName: 'DejaVu Sans Mono' pointSize: 9.
   titleFont := LogicalFont familyName: 'DejaVu Sans' pointSize: 11.

   Preferences
   	setListFontTo: font;
   	setMenuFontTo: font;
   	setCodeFontTo: codeFont;
   	setButtonFontTo: font;
   	setSystemFontTo: font;
   	setWindowTitleFontTo: titleFont.
"
Preferences
	disable: #annotationPanes;
	disable: #allwaysShowVScrollBar;
	enable: #alternativeButtonsInScrollBars;
	disable: #fadedBackgroundWindows;
	disable: #fastDragWindowForMorphic;
	disable: #fullScreenLeavesDeskMargins;
	enable: #generalizedYellowButtonMenu;
	enable: #mouseClickForKeyboardFocus;	
	enable: #noWindowAnimationForClosing;
	disable: #scrollBarsNarrow;
	disable: #scrollBarsWithoutMenuButton;
	disable: #showSplitterHandles;
	disable: #syntaxHighlightingAsYouTypeAnsiAssignment;
	enable: #showTextEditingState;
	disable: #windowAnimation;
	setPreference: #GlyphContrast toValue: 55;
	disable: #roundedWindowCorners;
	disable: #roundedMenuCorners.

UIThemeStandardSqueak beCurrent.
UIThemeWatery2 beCurrent.
	
Gofer new
	squeaksource: 'ImageForDevelopers';
	package: 'ImageForDevelopers-pharo';
	load.

(Smalltalk classNamed: #DEVImageCreator) default install.

SystemBrowser default: (Smalltalk classNamed: #OBSystemBrowserAdaptor).

Preferences enable: #showDeprecationWarnings.

SmalltalkImage current snapshot: true andQuit: true.
