package ch.ige.adr.client;

import javax.swing.table.AbstractTableModel;

import ch.ige.adr.vo.BlandAVO;

/**
 * Table Model für Auswahl des BLandes
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: BlandTableModel.java,v 1.8 2006/12/11 15:17:28 nydegger Exp $
 */
public class BlandTableModel extends AbstractTableModel
{
  final String[] columnNames = new String[]
   { "Land", "Bezeichnung" };
  BlandAVO[] tableData = new BlandAVO[]{};

  /**
   * aus AbstractTableModel
   * @return Anzahl Spalten
   */
  public int getColumnCount() { return columnNames.length; }

  /**
   * aus AbstractTableModel
   * @return Anzahl Zeilen
   */
  public int getRowCount() { return tableData.length; }

  /**
   * aus AbstractTableModel
   * @param column Spalte
   * @return Spaltenname
   */
  public String getColumnName(int column) { return columnNames[column]; }

  /**
   * aus AbstractTableModel
   * @param row Zeile
   * @param col Spalte
   * @return Wert
   */
  public Object getValueAt(int row, int col)
  {
    switch (col)
    {
      case 0 : return tableData[row].blandCd;
      case 1 : return tableData[row].landBezD;
    }
    return null;
  }

  /**
   * Daten übergeben
   * @param data Daten
   */
  public void setData(BlandAVO[] data)
  {
    tableData = data;
    fireTableDataChanged();
  }

  /**
   * Daten in TableModel löschen
   */
  public void clear()
  {
    tableData = new BlandAVO[]{};
    fireTableDataChanged();
  }
}
