package ch.ige.adr.client;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.RepaintManager;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;
import javax.swing.table.JTableHeader;
import javax.swing.text.JTextComponent;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adr.vo.BlandAVO;
import ch.ige.adrhelp.HelpUtil;
import ch.ige.main.client.GlassComponent;
import ch.ige.main.client.IGEJToolBar;
import ch.ige.main.client.XxMessage;
import ch.ige.util.client.IgeImage;
import ch.ige.util.client.IgeTable;
import ch.ige.util.client.LimitedDocument;
import ch.ige.util.client.SwingWorker;
import ch.ige.util.client.TableSorterView;

/**
 * Dialog für die Auwahl eines Landes
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: DlgBland.java,v 1.31 2008/04/28 15:32:34 galli Exp $
 */
public class DlgBland extends JDialog implements Printable
{
  // Logging
  private static final Logger LOG = Logger.getLogger( DlgBland.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  //Frame konstruieren
  // Menu
  protected JMenuBar menuBar = new JMenuBar();

  protected JMenu menFile = new JMenu();

  protected JMenuItem mnuFind = new JMenuItem();

  protected JMenuItem mnuOk = new JMenuItem();

  protected JMenuItem mnuCancel = new JMenuItem();

  protected JMenuItem mnuPrint = new JMenuItem();

  protected JMenuItem mnuClose = new JMenuItem();

  protected JMenu menEdit = new JMenu();

  protected JMenuItem mnuUndo = new JMenuItem();

  protected JMenuItem mnuCopy = new JMenuItem();

  protected JMenuItem mnuPaste = new JMenuItem();

  protected JMenuItem mnuCut = new JMenuItem();

  protected JMenu menHelp = new JMenu();

  protected JMenuItem mnuHelp = new JMenuItem();

  protected JMenuItem mnuInfo = new JMenuItem();

  // Popup-Menu
  protected JPopupMenu popPopup = new JPopupMenu();

  protected JMenuItem mnuFindPopup = new JMenuItem();

  protected JMenuItem mnuOkPopup = new JMenuItem();

  protected JMenuItem mnuCancelPopup = new JMenuItem();

  // ToolBar
  protected JToolBar toolBar = new IGEJToolBar();

  protected JButton btnFind = new JButton();

  protected JButton btnUndo = new JButton();

  protected JButton btnOk = new JButton();

  protected JButton btnCancel = new JButton();

  protected JButton btnPrint = new JButton();

  protected JButton btnCut = new JButton();

  protected JButton btnCopy = new JButton();

  protected JButton btnPaste = new JButton();

  protected JButton btnHelp = new JButton();

  // Images
  protected ImageIcon imgFind = IgeImage.imgFind;

  protected ImageIcon imgUndo = IgeImage.imgUndo;

  protected ImageIcon imgOk = IgeImage.imgOk;

  protected ImageIcon imgCancel = IgeImage.imgDelete;

  protected ImageIcon ImgPrint = IgeImage.imgPrint;

  protected ImageIcon imgCut = IgeImage.imgCut;

  protected ImageIcon imgCopy = IgeImage.imgCopy;

  protected ImageIcon imgPaste = IgeImage.imgPaste;

  protected ImageIcon imgHelp = IgeImage.imgHelp;

  protected JLabel statusBar = new JLabel();

  protected JPanel centerPanel = new JPanel(); //  @jve:decl-index=0:visual-constraint="9,121"

  protected BorderLayout centerPanelBorderLayout = new BorderLayout();

  protected BorderLayout contentPaneBorderLayout = new BorderLayout(); //  @jve:decl-index=0:

  protected JSeparator separator = new JSeparator( SwingConstants.VERTICAL );

  protected JPanel mainPanel = new JPanel();

  protected JPanel selKrit = new JPanel();

  protected JPanel selTablePanel = new JPanel();

  protected JScrollPane selTableScrollPane = new JScrollPane();

  protected BorderLayout borderLayout22 = new BorderLayout();

  //protected BoxLayout2 boxLayout21 = new BoxLayout2();

  // BLand Tabelle
  protected BlandTableModel tableModel = new BlandTableModel();

  protected TableSorterView tableSorterView = new TableSorterView( tableModel );

  protected IgeTable selTable = new IgeTable( tableSorterView );

  protected JLabel lblLandBezD = new JLabel();

  protected JTextField txfLandBezD = new JTextField();

  protected JTextField txfBlandCd = new JTextField();

  protected JLabel lblBlandCd = new JLabel();

  protected LimitedDocument ldoLandCd = new LimitedDocument();

  protected LimitedDocument ldoName = new LimitedDocument();

  protected String blandCd = "";

  /**
   * Dialog erstellen
   * @param owner Aufrufender Dialog
   */
  public DlgBland( Dialog owner )
  {
    super( owner );
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      pack();
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( this, ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Dialog erstellen
   */
  public DlgBland()
  {
    this( (Dialog) null );
    //  initHelp();
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  void jbInit() throws Exception
  {
    //********** Menus *****************************************************

    // Menu Datei
    centerPanel.setSize( new Dimension( 677, 153 ) );
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    gridBagConstraints3.fill = GridBagConstraints.NONE;
    gridBagConstraints3.gridx = 1;
    gridBagConstraints3.gridy = 1;
    gridBagConstraints3.ipadx = 261;
    gridBagConstraints3.weightx = 1.0;
    gridBagConstraints3.anchor = GridBagConstraints.WEST;
    gridBagConstraints3.insets = new Insets( 3, 3, 16, 31 );
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.insets = new Insets( 16, 55, 3, 5 );
    gridBagConstraints2.gridy = 0;
    gridBagConstraints2.anchor = GridBagConstraints.EAST;
    gridBagConstraints2.gridx = 0;
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    gridBagConstraints1.fill = GridBagConstraints.NONE;
    gridBagConstraints1.gridx = 1;
    gridBagConstraints1.gridy = 0;
    gridBagConstraints1.ipadx = 31;
    gridBagConstraints1.weightx = 1.0;
    gridBagConstraints1.anchor = GridBagConstraints.WEST;
    gridBagConstraints1.insets = new Insets( 13, 3, 2, 0 );
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.insets = new Insets( 6, 12, 17, 3 );
    gridBagConstraints.gridy = 1;
    gridBagConstraints.anchor = GridBagConstraints.EAST;
    gridBagConstraints.gridx = 0;
    menFile.setText( "Datei" );
    menFile.setMnemonic( 'D' );
    mnuFind.setText( "Suchen" );
    mnuFind.setMnemonic( 'S' );
    mnuFind.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_F, ActionEvent.CTRL_MASK ) );
    mnuFind.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuFind_actionPerformed( e );
      }
    } );
    mnuOk.setText( "Ok" );
    mnuOk.setMnemonic( 'O' );
    mnuOk.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_O, ActionEvent.CTRL_MASK ) );
    mnuOk.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuOk_actionPerformed( e );
      }
    } );
    mnuCancel.setText( "Abbrechen" );
    mnuCancel.setMnemonic( 'A' );
    mnuCancel.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_Q, ActionEvent.CTRL_MASK ) );
    mnuCancel.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCancel_actionPerformed( e );
      }
    } );
    mnuPrint.setText( "Drucken..." );
    mnuPrint.setMnemonic( 'D' );
    mnuPrint.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_P, ActionEvent.CTRL_MASK ) );
    mnuPrint.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuPrint_actionPerformed( e );
      }
    } );
    mnuClose.setText( "Schliessen" );
    mnuClose.setMnemonic( 'C' );
    mnuClose.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_F4, ActionEvent.ALT_MASK ) );
    mnuClose.addActionListener( new ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuClose_actionPerformed( e );
      }
    } );

    // Menu Bearbeiten
    menEdit.setText( "Bearbeiten" );
    menEdit.setMnemonic( 'B' );
    mnuUndo.setText( "Suchfelder löschen" );
    mnuUndo.setMnemonic( 'S' );
    mnuUndo.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_Z, ActionEvent.CTRL_MASK ) );
    mnuUndo.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuUndo_actionPerformed( e );
      }
    } );
    mnuCut.setText( "Ausschneiden" );
    mnuCut.setMnemonic( 'A' );
    mnuCut.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_X, ActionEvent.CTRL_MASK ) );
    mnuCut.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCut_actionPerformed( e );
      }
    } );
    mnuCopy.setText( "Kopieren" );
    mnuCopy.setMnemonic( 'K' );
    mnuCopy.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_C, ActionEvent.CTRL_MASK ) );
    mnuCopy.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCopy_actionPerformed( e );
      }
    } );

    mnuPaste.setText( "Einfügen" );
    mnuPaste.setMnemonic( 'E' );
    mnuPaste.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_V, ActionEvent.CTRL_MASK ) );
    mnuPaste.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuPaste_actionPerformed( e );
      }
    } );

    // Menu Hilfe
    menHelp.setText( "Hilfe" );
    menHelp.setMnemonic( 'H' );
    mnuHelp.setText( "Hilfethemen" );
    mnuHelp.setMnemonic( 'H' );
    mnuHelp.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_F1, 0 ) );
    mnuHelp.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuHelp_actionPerformed( e );
      }
    } );
    mnuInfo.setText( "Info" );
    mnuInfo.setMnemonic( 'I' );
    mnuInfo.addActionListener( new ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuInfo_actionPerformed( e );
      }
    } );

    //********** Popup Menu *************************************************
    mnuFindPopup.setText( "Suchen" );
    mnuFindPopup.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_F, ActionEvent.CTRL_MASK ) );
    mnuFindPopup.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuFind_actionPerformed( e );
      }
    } );
    mnuOkPopup.setText( "Ok" );
    mnuOkPopup.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_O, ActionEvent.CTRL_MASK ) );
    mnuOkPopup.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuOk_actionPerformed( e );
      }
    } );
    mnuCancelPopup.setText( "Abbrechen" );
    mnuCancelPopup.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_Q, ActionEvent.CTRL_MASK ) );
    mnuCancelPopup.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCancel_actionPerformed( e );
      }
    } );

    //********** Buttons ***************************************************
    btnFind.setIcon( imgFind );
    btnFind.setToolTipText( "Suchen" );
    btnFind.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuFind_actionPerformed( e );
      }
    } );
    btnUndo.setIcon( imgUndo );
    btnUndo.setToolTipText( "Suchfelder löschen" );
    btnUndo.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuUndo_actionPerformed( e );
      }
    } );
    btnOk.setIcon( imgOk );
    btnOk.setToolTipText( "Ok" );
    btnOk.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuOk_actionPerformed( e );
      }
    } );
    btnCancel.setIcon( imgCancel );
    btnCancel.setToolTipText( "Abbrechen" );
    btnCancel.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCancel_actionPerformed( e );
      }
    } );
    btnPrint.setIcon( ImgPrint );
    btnPrint.setActionCommand( "" );
    btnPrint.setToolTipText( "Drucken" );
    btnPrint.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuPrint_actionPerformed( e );
      }
    } );
    btnCut.setIcon( imgCut );
    btnCut.setRequestFocusEnabled( false );
    btnCut.setToolTipText( "Auschneiden" );
    btnCut.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCut_actionPerformed( e );
      }
    } );
    btnCopy.setIcon( imgCopy );
    btnCopy.setRequestFocusEnabled( false );
    btnCopy.setToolTipText( "Kopieren" );
    btnCopy.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCopy_actionPerformed( e );
      }
    } );
    btnPaste.setIcon( imgPaste );
    btnPaste.setRequestFocusEnabled( false );
    btnPaste.setToolTipText( "Einfügen" );
    btnPaste.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuPaste_actionPerformed( e );
      }
    } );
    btnHelp.setIcon( imgHelp );
    btnHelp.setToolTipText( "Hilfe" );
    btnHelp.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuHelp_actionPerformed( e );
      }
    } );

//    setStateNotFound();
    mnuOk.setEnabled( false );
    btnOk.setEnabled( false );
    getRootPane().setDefaultButton( btnFind );

    statusBar.setText( " " );
    this.getContentPane().setLayout( contentPaneBorderLayout );

    // Toolbar zusammensetzen
    lblBlandCd.setToolTipText( "" );
    toolBar.add( btnFind );
    toolBar.add( btnUndo );
    toolBar.addSeparator();
    toolBar.add( btnOk );
    toolBar.add( btnCancel );
    toolBar.addSeparator();
    toolBar.add( btnPrint );
    toolBar.addSeparator();
    toolBar.add( btnCut );
    toolBar.add( btnCopy );
    toolBar.add( btnPaste );
    toolBar.addSeparator();
    toolBar.add( btnHelp );
    toolBar.setRequestFocusEnabled( false );
    toolBar.setFloatable( false );

    // Menüs zusammensetzen
    menFile.add( mnuFind );
    menFile.addSeparator();
    menFile.add( mnuOk );
    menFile.add( mnuCancel );
    menFile.addSeparator();
    menFile.add( mnuPrint );
    menFile.addSeparator();
    menFile.add( mnuClose );

    menEdit.add( mnuUndo );
    menEdit.addSeparator();
    menEdit.add( mnuCut );
    menEdit.add( mnuCopy );
    menEdit.add( mnuPaste );

    menHelp.add( mnuHelp );
    menHelp.addSeparator();
    menHelp.add( mnuInfo );

    menuBar.add( menFile );
    menuBar.add( menEdit );
    menuBar.add( menHelp );

    this.setJMenuBar( menuBar );

    // Popup-Menu auslösen
    centerPanel.addMouseListener( new java.awt.event.MouseAdapter()
    {
      public void mouseReleased( MouseEvent e )
      {
        centerPanel_mouseReleased( e );
      }
    } );

    centerPanel.setLayout( centerPanelBorderLayout );

    // ContentPane zusammensetzen
    this.getContentPane().add( toolBar, BorderLayout.NORTH );
    this.getContentPane().add( new JScrollPane( centerPanel ), BorderLayout.CENTER );
    this.getContentPane().add( statusBar, BorderLayout.SOUTH );
    // >>> Ende aus SelectionPane

    this.setTitle( "Auswahl Land" );
    this.setModal( true );

    mainPanel.setLayout( new BorderLayout() );
    //boxLayout21.setAxis(BoxLayout.Y_AXIS);

    selKrit.setMaximumSize( new Dimension( 2147483647, 100 ) );
    selKrit.setMinimumSize( new Dimension( 200, 100 ) );
    selKrit.setPreferredSize( new Dimension( 400, 100 ) );
    selKrit.setLayout( new GridBagLayout() );

    selTable.setPreferredScrollableViewportSize( new Dimension( 350, 100 ) );

    selTablePanel.setLayout( borderLayout22 );
    lblLandBezD.setText( "Bezeichnung:" );
    lblBlandCd.setText( "Land:" );
    txfLandBezD.setDocument( ldoName );
    txfBlandCd.setDocument( ldoLandCd );
    centerPanel.add( mainPanel, BorderLayout.CENTER );
    selKrit.setBorder( new TitledBorder( "Selektionskriterien" ) );
    mainPanel.add( selKrit, BorderLayout.NORTH );
    mainPanel.add( selTablePanel, BorderLayout.CENTER );
    selTablePanel.setBorder( new TitledBorder( "Länder" ) );

    selTablePanel.add( selTableScrollPane, BorderLayout.CENTER );
    selKrit.add( lblLandBezD, gridBagConstraints );
    selKrit.add( txfBlandCd, gridBagConstraints1 );
    selKrit.add( lblBlandCd, gridBagConstraints2 );
    selKrit.add( txfLandBezD, gridBagConstraints3 );
    selTableScrollPane.getViewport().add( selTable );
    // Tabelle
    tableSorterView.addMouseListenerToHeaderInTable( selTable );

    JTableHeader header = selTable.getTableHeader();
    header.addMouseListener( new MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        header_MouseListener( e );
      }
    } );

    // Spaltenbreite der Tabelle
    selTable.getColumnModel().getColumn( 0 ).setPreferredWidth( 50 );
    selTable.getColumnModel().getColumn( 1 ).setPreferredWidth( 200 );

    selTable.addMouseListener( new MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        selTable_MouseListener( e );
      }
    } );
    selTable.addFocusListener( new java.awt.event.FocusAdapter()
    {
      public void focusGained( FocusEvent e )
      {
        selTable_focusGained( e );
      }
    } );
    selTable.addFocusListener( new java.awt.event.FocusAdapter()
    {
      public void focusLost( FocusEvent e )
      {
        selTable_focusLost( e );
      }
    } );
    selTable.addKeyListener( new java.awt.event.KeyAdapter()
    {
      public void keyPressed( KeyEvent e )
      {
        selTable_keyPressed( e );
      }
    } );

    ldoName.setMaxLength( 30 );
    ldoLandCd.setMaxLength( 3 );
    ldoLandCd.setUpperCase( true );

    setGlassPane( new GlassComponent() );

  }

  /**
   * Länder lesen
   */
  void read()
  {
    tableModel.clear();
    // Bitte warten...
    String message = xxMessage.getMessage( 1 );
    statusBar.setText( message );
    getGlassPane().setVisible( true );
    final JDialog dialog = this;
    // Daten lesen
    final SwingWorker worker = new SwingWorker()
    {
      public Object construct()
      {
        ArrayList al;
        try
        {
          AdresseDelegate ad = AdresseDelegate.getInstance();
          al = ad.findBland( txfBlandCd.getText(), txfLandBezD.getText() );
        }
        catch ( Exception ex )
        {
          mnuOk.setEnabled( false );
          btnOk.setEnabled( false );
          getRootPane().setDefaultButton( btnFind );
          // Keine Datensätze gefunden !
          String message = xxMessage.getMessage( 17 );
          statusBar.setText( message );
          LOG.error( ex );
          message = xxMessage.getMessage( ex );
          JOptionPane.showMessageDialog( dialog, message, "Fehler", JOptionPane.ERROR_MESSAGE );
          return null;
        }
        BlandAVO[] blandAVO = new BlandAVO[al.size()];
        al.toArray( blandAVO );
        tableModel.setData( blandAVO );
        return null;
      }

      public void finished()
      {
        if ( tableModel.getRowCount() > 0 )
        {
          //setStateFound();
          getRootPane().setDefaultButton( btnOk );
          mnuOk.setEnabled( true );
          btnOk.setEnabled( true );
          selTable.setRowSelectionInterval( 0, 0 );
          selTable.requestFocus();
          // Es wurden !P1 Datensätze gelesen !
          String message = xxMessage.getMessage( 19, "" + tableModel.getRowCount() );
          statusBar.setText( message );
        }
        else
        {
          //setStateNotFound();
          mnuOk.setEnabled( false );
          btnOk.setEnabled( false );
          getRootPane().setDefaultButton( btnFind );
          // Keine Datensätze gefunden !
          String message = xxMessage.getMessage( 17 );
          statusBar.setText( message );
        }
        getGlassPane().setVisible( false );
      }
    }; // SwingWorker

    worker.start();
  }

  /**
   * BLand-Dialog anzeigen.
   * @param owner Aufrufender Dialog
   * @param blandCd optionaler Land-Code als Selektionskriterium
   * @return String - gewählter Land-Code, "" wenn kein Land gewählt
   */
  public static String showBland( Dialog owner, String blandCd )
  {
    // Assertion
    if ( blandCd == null )
    {
      throw new IllegalArgumentException( "blandCd darf nicht null sein." );
    }
    DlgBland frame = new DlgBland( owner );
    if ( !blandCd.equals( "" ) )
    {
      frame.txfBlandCd.setText( blandCd );
      frame.read();
    }
    // Focus setzen
    if ( frame.tableModel.getRowCount() > 0 )
    {
      frame.selTable.requestFocus();
      frame.selTable.dispatchEvent( new FocusEvent( frame.selTable, FocusEvent.FOCUS_GAINED, false ) );
    }
    else
    {
      frame.txfBlandCd.requestFocus();
      frame.txfBlandCd.dispatchEvent( new FocusEvent( frame.txfBlandCd, FocusEvent.FOCUS_GAINED, false ) );
    }
    frame.pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    frame.setLocation( ( screenSize.width - frameSize.width ) / 2, ( screenSize.height - frameSize.height ) / 2 );
    frame.setVisible( true );
    return frame.blandCd;
  }

  /**
   * Abbrechen wurde geklickt.
   * @param e Auslösendes Event
   */
  void mnuCancel_actionPerformed( ActionEvent e )
  {
    blandCd = "";
    this.setVisible( false );
    this.dispose();
  }

  /**
   * OK wurde geklickt.
   * @param e Auslösendes Event
   */
  void mnuOk_actionPerformed( ActionEvent e )
  {
    int row = selTable.getSelectedRows()[0];
    blandCd = (String) tableSorterView.getValueAt( row, 0 );
    this.setVisible( false );
    this.dispose();
  }

  //********** Pane-spezifische Methoden ***********************************

  /**
   * Maus wurde geklickt.
   * @param e Auslösendes Event
   */
  void selTable_MouseListener( MouseEvent e )
  {
    mnuOk.setEnabled( true );
    btnOk.setEnabled( true );
    // bei Doppelclick OK
    if ( e.getClickCount() == 2 )
    {
      mnuOk_actionPerformed( null );
    }
  }

  void mnuFind_actionPerformed( ActionEvent e )
  {
    read();
  }

  void mnuPrint_actionPerformed( ActionEvent e )
  {
    printFrameDialog();
  }

  void mnuClose_actionPerformed( ActionEvent e )
  {
    mnuCancel_actionPerformed( e );
  }

  /**
   * Suchfelder löschen
   * @param e auslösendes Ereignis
   */
  void mnuUndo_actionPerformed( ActionEvent e )
  {
    txfBlandCd.setText( "" );
    txfLandBezD.setText( "" );
    txfBlandCd.requestFocus();
    tableModel.clear();
    getRootPane().setDefaultButton( btnFind );
//    setStateNotFound();
    mnuOk.setEnabled( false );
    btnOk.setEnabled( false );
  }

  /**
   * Falls Focus nicht mehr in der Tabelle ist, wird der Suchenknopf der Default.
   * @param e FocusEvent
   */
  protected void selTable_focusLost( FocusEvent e )
  {
    if ( !e.isTemporary() )
    {
      getRootPane().setDefaultButton( btnFind );
    }
  }

  /**
   * Falls der Focus wieder auf der Tabelle ist, wird der Detailknopf der Default.
   * @param e FocusEvent
   */
  protected void selTable_focusGained( FocusEvent e )
  {
    getRootPane().setDefaultButton( btnOk );
  }

  /**
   * Enter-Taste in der Tabelle löst den DefaultButton aus.
   * @param e KeyEvent
   */
  protected void selTable_keyPressed( KeyEvent e )
  {
    if ( e.getKeyCode() == KeyEvent.VK_ENTER )
    {
      getRootPane().getDefaultButton().doClick();
      e.consume();
    }
  }

  /**
   * Setzt Menus und Buttons in den Initialzustand zurück
   * @param e Mousevent
   */
  protected void header_MouseListener( MouseEvent e )
  {
//		setStateNotFound();
    mnuOk.setEnabled( false );
    btnOk.setEnabled( false );
  }

  /**
   * markierter Text ausschneiden und ins Clipboard kopieren
   * @param e auslösendes Ereignis
   */
  void mnuCut_actionPerformed( ActionEvent e )
  {
    Component c = getFocusOwner();
    if ( c instanceof JTextComponent )
    {
      ( (JTextComponent) c ).cut();
    }
    else if ( c instanceof JTable )
    {
      copyCellToClipboard( (JTable) c );
    }
  }

  /**
   * markierter Text ins Clipboard kopieren
   * @param e auslösendes Ereignis
   */
  void mnuCopy_actionPerformed( ActionEvent e )
  {
    Component c = getFocusOwner();
    if ( c instanceof JTextComponent )
    {
      ( (JTextComponent) c ).copy();
    }
    else if ( c instanceof JTable )
    {
      copyCellToClipboard( (JTable) c );
    }
  }

  /**
   * Text vom Clipboard einfügen
   * @param e auslösendes Ereignis
   */
  void mnuPaste_actionPerformed( ActionEvent e )
  {
    Component c = getFocusOwner();
    if ( c instanceof JTextComponent )
    {
      ( (JTextComponent) c ).paste();
    }
  }

  void mnuHelp_actionPerformed( ActionEvent e )
  {
    /** nothing yet */
  }

  void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.getOwner(), true ).setVisible( true );
  }

  void centerPanel_mouseReleased( MouseEvent e )
  {
    /** nothing yet */
  }

  // Kopiert die selektierte Zelle einer Tabelle ins SystemClipboard
  private void copyCellToClipboard( JTable table )
  {
    String s = table.getValueAt( table.getSelectedRow(), table.getSelectedColumn() ).toString();
    StringSelection ss = new StringSelection( s );
    getToolkit().getSystemClipboard().setContents( ss, ss );
  }

  /**
   * Fenster mit Druck-Dialog drucken
   */
  public void printFrameDialog()
  {
    PrinterJob printJob = PrinterJob.getPrinterJob();
    PageFormat pageFormat = printJob.defaultPage();
    pageFormat.setOrientation( PageFormat.LANDSCAPE );
    printJob.setPrintable( this, pageFormat );
    if ( printJob.printDialog() )
    {
      try
      {
        RepaintManager.currentManager( this ).setDoubleBufferingEnabled( false );
        printJob.print();
        RepaintManager.currentManager( this ).setDoubleBufferingEnabled( true );
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        JOptionPane.showMessageDialog( this, message, "Fehler", JOptionPane.ERROR_MESSAGE );
      }
    }
  }

  /**
   * Implementation des Interfaces Printable
   * @param g - the context into which the page is drawn
   * @param pf - the size and orientation of the page being drawnpageIndex
   * @param pi - the zero based index of the page to be drawnReturns
   * @return PAGE_EXISTS if the page is rendered successfully or NO_SUCH_PAGE if pageIndex specifies a non-existent page.
   * @throws PrinterException - thrown when the print job is terminated.
   */
  public int print( Graphics g, PageFormat pf, int pi ) throws PrinterException
  {
    if ( pi >= 1 )
    {
      return Printable.NO_SUCH_PAGE;
    }
    Graphics2D g2 = (Graphics2D) g;
    g2.translate( pf.getImageableX(), pf.getImageableY() );
    double scale = pf.getImageableHeight() / getHeight();
    g2.scale( scale, scale );
    paint( g2 );
    return Printable.PAGE_EXISTS;
  }

  /**
   * initialisiert Javahelp
   */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "adrErfassen.auswahlland" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "adrErfassen.auswahlland" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "adrErfassen.auswahlland" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menuBar, "auswahlmenues" );
    HelpUtil.getInstance().enableHelp( selTable, "adrErfassen.auswahlland" );
    HelpUtil.getInstance().enableHelp( txfLandBezD, "adrErfassen.auswahlland" );
    HelpUtil.getInstance().enableHelp( txfBlandCd, "adrErfassen.auswahlland" );
  }
}
