package ch.ige.adr.client;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SwingUtilities;

import org.apache.log4j.Logger;

import ch.ige.adrhelp.HelpUtil;
import ch.ige.main.client.XxMessage;

/**
 * Auswahl Modus Normal oder Ortsabgleich
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: OrtsabgleichPanel.java,v 1.13 2008/04/28 15:32:34 galli Exp $
 */
public class OrtsabgleichPanel extends JPanel
{
  // Logging
  private static final Logger LOG = Logger.getLogger( OrtsabgleichPanel.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  protected FlowLayout flowLayout = new FlowLayout();

  protected JRadioButton rbnNormal = new JRadioButton();

  protected JLabel lblModus = new JLabel();

  protected ButtonGroup buttonGroup = new ButtonGroup();

  protected JRadioButton rbnOrtsabgleich = new JRadioButton();

  /**
   * constructor
   */
  public OrtsabgleichPanel()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      initHelp();

    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( SwingUtilities.getWindowAncestor( this ), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  void jbInit() throws Exception
  {
    lblModus.setForeground( Color.black );
    lblModus.setPreferredSize( new Dimension( 50, 12 ) );
    lblModus.setText( "Modus:" );
    rbnNormal.setBorder( null );
    rbnNormal.setSelected( true );
    rbnNormal.setText( "Normal" );
    rbnNormal.setPreferredSize( new Dimension( 70, 12 ) );
    rbnOrtsabgleich.setBorder( null );
    rbnOrtsabgleich.setText( "Ortsabgleich" );
    rbnOrtsabgleich.setPreferredSize( new Dimension( 100, 12 ) );
    buttonGroup.add( rbnNormal );
    buttonGroup.add( rbnOrtsabgleich );
    this.add( lblModus, null );
    this.setLayout( flowLayout );
    this.add( rbnNormal, null );
    this.add( rbnOrtsabgleich, null );
  }

  /**
   * initialisiert javahelp
   */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelp( rbnNormal, "adrSuchen.einstellmodi" );
    HelpUtil.getInstance().enableHelp( rbnOrtsabgleich, "adrSuchen.einstellmodi" );
  }
}
