package ch.ige.adr.client;

import javax.swing.JComponent;

import ch.ige.main.client.PnlWizard;
import ch.ige.util.client.CharsetVerifier;

/**
 * Provides some methods which are used by more than one panel class.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   galli
 * @version  $Id: PnlAbstract.java,v 1.1 2007/12/13 10:13:24 galli Exp $
 */
public class PnlAbstract extends PnlWizard
{
  /**
   * Adds a {@link CharsetVerifier} to the given Component. Shows a message dialog if one or more 
   * chars are not from the ISO-8859-15 encoding and higlights the wrong chars.
   * @param component the component which is checked
   */
  protected void addCharsetVerifier( JComponent component )
  {
    CharsetVerifier cv = new CharsetVerifier();
    cv.showMessageDialog( true );
    cv.enableHighlighting( true );
    cv.shouldYieldFocus( component );
    component.setInputVerifier( cv );
  }
}
