package ch.ige.adr.client;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adrhelp.HelpUtil;
import ch.ige.authz.gui.AuthzJButton;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.DeleteDialog;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MainRootPane;
import ch.ige.main.client.XxMessage;
import ch.ige.util.vo.RegadrVO;

/**
 * Detail der Registeradressen
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: RegadrDtl.java,v 1.42 2008/04/28 15:32:34 galli Exp $
 */
public class RegadrDtl extends ch.ige.main.client.DetailPane
{
  // Logging
  private static final Logger LOG = Logger.getLogger( RegadrDtl.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  // Schlüssel
  protected Integer regadrNr = null;

  protected RegadrVO regadrVO = null;

  //Frame konstruieren
  protected JPanel mainPanel = new JPanel();

  protected JLabel lblRegadrNr = new JLabel();

  protected JLabel lblRegOrt = new JLabel();

  protected JLabel lblLandCd = new JLabel();

  protected JLabel lblRegName = new JLabel();

  protected JTextField txfRegadrNr = new JTextField();

  protected JTextField txfLandCd = new JTextField();

  protected JLabel lblRegStrasse = new JLabel();

  protected JTextArea txaRegStrasse = new JTextArea();

  protected JTextArea txaRegOrt = new JTextArea();

  protected JLabel lblAdrNr = new JLabel();

  protected JTextField txfAdrNr = new JTextField();

  protected JLabel lblUpVerzName = new JLabel();

  protected JTextArea txaUpVerzName = new JTextArea();

  protected JLabel lblGesperrt = new JLabel();

  protected JCheckBox ckbGesperrt = new JCheckBox();

  protected JScrollPane scpRegName = new JScrollPane();

  protected JTextArea txaRegName = new JTextArea();

  protected JScrollPane scpRegStrasse = new JScrollPane();

  protected JScrollPane jScrollPane1 = new JScrollPane();

  protected JScrollPane scpUpVerzName = new JScrollPane();

  /**
   * adressenummer
   */
  public JButton btnAdrNr = new AuthzJButton();

  GridBagLayout gridBagLayout1 = new GridBagLayout();

  /**
   * Konstruktor
   */
  public RegadrDtl()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Konstuktor
   * @param mainController Hauptsteuerung
   * @param mode Modus MainRootPane.SEARCH oder MainRootPane.SEARCH_LOOKUP
   */
  public RegadrDtl( MainController mainController, int mode )
  {
    super( mainController, mode );
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  private void jbInit() throws Exception
  {

    //********** Menus ******************************************************
    lblRegName.setToolTipText( "" );
    lblRegName.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegName.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegName.setText( "Registername:" );
    lblLandCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblLandCd.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblLandCd.setText( "Land:" );
    lblRegOrt.setToolTipText( "" );
    lblRegOrt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegOrt.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegOrt.setText( "Registerort:" );
    lblRegadrNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegadrNr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegadrNr.setText( "Registeradress-Nr:" );

    mainPanel.setLayout( gridBagLayout1 );
    mainPanel.setBorder( new TitledBorder( "Registeradresse" ) );

    txfRegadrNr.setEditable( false );
    txfLandCd.setEditable( false );
    lblRegStrasse.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegStrasse.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegStrasse.setText( "Registerstrasse:" );
    lblAdrNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblAdrNr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblAdrNr.setText( "Versandadress-Nr:" );
    txaRegOrt.setEditable( false );
    txaRegStrasse.setEditable( false );
    txfAdrNr.setEditable( false );
    lblUpVerzName.setHorizontalAlignment( SwingConstants.RIGHT );
    lblUpVerzName.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblUpVerzName.setText( "Sortiername:" );
    lblGesperrt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblGesperrt.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblGesperrt.setText( "gesperrt:" );
    txaUpVerzName.setEditable( false );
    ckbGesperrt.setEnabled( false );
    txaRegName.setEditable( false );
    scpRegName.setVerticalScrollBarPolicy( ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS );
    scpRegStrasse.setVerticalScrollBarPolicy( ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS );
    jScrollPane1.setVerticalScrollBarPolicy( ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS );
    scpUpVerzName.setVerticalScrollBarPolicy( ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS );
    btnAdrNr.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        btnAdrNr_actionPerformed( e );
      }
    } );
    btnAdrNr.setText( "..." );
    centerPanel.add( mainPanel, BorderLayout.CENTER );

    mainPanel.add( lblRegadrNr, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 12, 21, 0, 0 ), 17,
        6 ) );
    mainPanel.add( lblLandCd, new GridBagConstraints( 0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 1, 0, 1, 0 ), 0, 0 ) );
    mainPanel.add( lblRegStrasse, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 38, 50, 36, 0 ),
        0, 0 ) );
    mainPanel.add( lblAdrNr, new GridBagConstraints( 0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 1, 36, 1, 0 ), 0, 0 ) );
    mainPanel.add( lblUpVerzName, new GridBagConstraints( 0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 22, 69, 15, 0 ),
        0, 0 ) );
    mainPanel.add( lblGesperrt, new GridBagConstraints( 0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 6, 86, 34, 0 ), 0,
        0 ) );
    mainPanel.add( lblRegOrt,
        new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 18, 74, 14, 0 ), 0, 0 ) );
    mainPanel.add( scpRegName, new GridBagConstraints( 1, 1, 2, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 1, 18, 1, 13 ),
        333, 33 ) );
    mainPanel.add( scpRegStrasse, new GridBagConstraints( 1, 2, 2, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 1, 18, 1, 13 ),
        333, 64 ) );
    mainPanel.add( txfRegadrNr, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
        new Insets( 12, 18, 0, 0 ), 70, 0 ) );
    mainPanel.add( jScrollPane1, new GridBagConstraints( 1, 3, 2, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 1, 19, 1, 13 ),
        333, 21 ) );
    mainPanel.add( txfLandCd, new GridBagConstraints( 1, 4, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets( 1, 18, 1, 30 ),
        40, 0 ) );
    mainPanel.add( txfAdrNr, new GridBagConstraints( 1, 5, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets( 1, 18, 1, 0 ),
        70, 0 ) );
    mainPanel.add( scpUpVerzName, new GridBagConstraints( 1, 6, 2, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 1, 18, 1, 13 ),
        332, 23 ) );
    mainPanel.add( btnAdrNr, new GridBagConstraints( 2, 5, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 1, 0, 1, 265 ), -22,
        -4 ) );
    mainPanel.add( lblRegName, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 23, 61, 20, 0 ), 0,
        0 ) );
    mainPanel.add( ckbGesperrt, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE,
        new Insets( 4, 17, 30, 36 ), 0, 0 ) );
    scpUpVerzName.getViewport().add( txaUpVerzName, null );
    jScrollPane1.getViewport().add( txaRegOrt, null );
    scpRegStrasse.getViewport().add( txaRegStrasse, null );
    scpRegName.getViewport().add( txaRegName, null );

  } // jbInit

  //********** Öffentliche Standard-Methoden *******************************

  /**
   * Gibt den Titel für das Frame zurück
   * @return Titel
   */
  public String getTitle()
  {
    return "Registeradresse Detail";
  }

  /**
   * setzt den Schlüssel
   * @param regadrNr Registeradressnummer
   */
  public void setKey( Integer regadrNr )
  {
    this.regadrNr = regadrNr;
  }

  //********** Lokale Standard-Methoden **********************************

  //********** Ereignisbehandlung zu Menus *******************************

  /**
   * Das Löschen-Menü wurde gewählt.
   * @param e ActionEvent
   */
  protected void mnuDelete_actionPerformed( ActionEvent e )
  {

    if ( DeleteDialog.showDeleteDialog( mainController.getWindow() ) )
    {
      // Ja, Daten löschen
      try
      {
        AdresseDelegate.getInstance().removeRegadr( regadrNr.intValue() );
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
        return;
      }
      mainController.back();
    }
  }

  /**
   * Liest die Daten von der Datenbank.
   */
  public void read()
  {
    // Daten lesen
    try
    {
      regadrVO = AdresseDelegate.getInstance().getRegadr( regadrNr.intValue() );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      return;
    }

    txfRegadrNr.setText( "" + regadrVO.getRegadrNr() );
    txaRegName.setText( regadrVO.getRegNameOrEmptyString() );
    txaRegStrasse.setText( regadrVO.getRegStrasseOrEmptyString() );
    txaRegOrt.setText( regadrVO.getRegOrtOrEmptyString() );
    txfLandCd.setText( regadrVO.getBlandCdOrEmptyString() );
    txfAdrNr.setText( "" + regadrVO.getAdrNr() );
    txaUpVerzName.setText( regadrVO.getUpVerzNameOrEmptyString() );
    ckbGesperrt.setSelected( regadrVO.getGesperrt() != 0 );
    btnAdrNr.setEnabled( regadrVO.getAdrNr() != 0 );
    // Daten gelesen !
    String message = xxMessage.getMessage( 21 );
    setStatusBar( message );

    // Tooltip setzen, mit '#' anstelle der Leerzeichen,
    // um die Leerzeichen sichtbar zu machen.
    txaRegName.setToolTipText( regadrVO.getRegNameOrEmptyString().replace( ' ', '#' ) );
    txaRegStrasse.setToolTipText( regadrVO.getRegStrasseOrEmptyString().replace( ' ', '#' ) );
    txaRegOrt.setToolTipText( regadrVO.getRegOrtOrEmptyString().replace( ' ', '#' ) );
    txfLandCd.setToolTipText( regadrVO.getBlandCdOrEmptyString().replace( ' ', '#' ) );
    txaUpVerzName.setToolTipText( regadrVO.getUpVerzNameOrEmptyString().replace( ' ', '#' ) );

  } // read

  //********** Menu Hilfe **************************************************

  /**
   * Das Info-Menü wurde gewählt.
   * @param e ActionEvent
   */
  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  //********** Popup-Menu **************************************************

  //********** Pane-spezifische Methoden ***********************************

  /**
   * Das Neu-Menü wurde gewählt.
   * Erfassungswizard anzeigen.
   * @param e ActionEvent
   */
  protected void mnuNew_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( " " );
    RegadrWizard rw = new RegadrWizard( (Frame) mainController.getWindow() );
    Integer regadrNr;
    try
    {
      regadrNr = rw.newRegadr();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
      return;
    }
    if ( regadrNr == null )
    {
      // Erfassen wurde abgebrochen
      String message = xxMessage.getMessage( 1033 );
      statusBar.setText( message );
    }
    else
    {
      setKey( regadrNr );
      read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      setStatusBar( message );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Das Mutieren-Menü wurde gewählt.
   * Erfassungswizard anzeigen.
   * @param e ActionEvent
   */
  protected void mnuEdit_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( " " );
    RegadrWizard rw = new RegadrWizard( (Frame) mainController.getWindow() );
    boolean edit = false;
    try
    {
      edit = rw.editRegadr( regadrNr.intValue() );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      return;
    }
    if ( edit )
    {
      read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      setStatusBar( message );
    }
    else
    {
      // Mutieren wurde abgebrochen.
      String message = xxMessage.getMessage( 1034 );
      statusBar.setText( message );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Das Aktualisieren-Menü wurde gewählt.
   * @param e ActionEvent
   */
  protected void mnuRefresh_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    read();
    // Daten gelesen !
    String message = xxMessage.getMessage( 21 );
    statusBar.setText( message );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Statuszeile setzen
   * @param text Meldungstext
   */
  public void setStatusBar( String text )
  {
    statusBar.setText( text );
  }

  /**
   * Der Adressnummer-Knopf wurde gewählt.
   * @param e ActionEvent
   */
  protected void btnAdrNr_actionPerformed( ActionEvent e )
  {
    setForwardEnabled( true );
    AdresseDtl adresseDtl = new AdresseDtl( mainController, MainRootPane.DETAIL );
    adresseDtl.setKey( new Integer( regadrVO.getAdrNr() ) );
    adresseDtl.read();
    mainController.next( adresseDtl );
  }

  //********** Authorization ***************************************************

  /**
   * @return Authorization
   */
  public static String[] getAuthzSpecifications()
  {
    return new String[] { "*New    = Schreiben/RegisterAdressen", "*Edit   = Schreiben/RegisterAdressen", "*Delete = Schreiben/RegisterAdressen" };
  }

  /**
  * initialisiert javehelp
  */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "allgHilfe" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "allgHilfe" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "allgHilfe" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menuBar, "auswahlmenues" );
  }

} // RegadrDtl
