package ch.ige.adr.client;

import javax.swing.table.AbstractTableModel;

import ch.ige.adr.vo.RegadrAVO;
import ch.ige.util.StringUtil;

/**
 *  Table Model für Auswahl der Registeradresse
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: RegadrTableModel.java,v 1.16 2006/12/11 16:27:00 nydegger Exp $
 */
public class RegadrTableModel extends AbstractTableModel
{
  final String[] columnNames = new String[]
   { "Reg.-Adr.-Nr.", "Sortiername", "Name", "Strasse", "Ort", "Ld", "Vers.-Adr.-Nr." };
  RegadrAVO[] tableData = new RegadrAVO[]{};

  /**
   * aus AbstractTableModel
   */
  public int getColumnCount() { return columnNames.length; }

  /**
   * aus AbstractTableModel
   */
  public int getRowCount() { return tableData.length; }

  /**
   * aus AbstractTableModel
   */
  public String getColumnName(int column) { return columnNames[column]; }

  /**
   * aus AbstractTableModel
   */
  public Class getColumnClass(int column)
  {
    if (column == 0)
    {
      return Integer.class;
    }
    else
    {
      return Object.class;
    }
  }

  /**
   * aus AbstractTableModel
   */
  public Object getValueAt(int row, int col)
  {
    switch (col)
    {
      case 0 : return new Integer(tableData[row].getRegadrNr());
      case 1 : return tableData[row].getUpVerzNameOrEmptyString();
      case 2 : return StringUtil.replaceNewLine(tableData[row].getRegNameOrEmptyString());
      case 3 : return StringUtil.replaceNewLine(tableData[row].getRegStrasseOrEmptyString());
      case 4 : return StringUtil.replaceNewLine(tableData[row].getRegOrtOrEmptyString());
      case 5 : return tableData[row].getBlandCdOrEmptyString();
      case 6 : if (tableData[row].getAdrNr() == 0)
        {
          // 0 nicht anzeigen
          return "";
        }
        else
        {
          return "" + tableData[row].getAdrNr();
        }
    }
    return null;
  }

  /**
   * Daten übergeben
   * @param data RegadrAVO
   */
  public void setData(RegadrAVO[] data) {
    tableData = data;
    fireTableDataChanged();
  }

  /**
   * Daten in TableModel löschen
   */
  public void clear() {
    tableData = new RegadrAVO[]{};
    fireTableDataChanged();
  }
}
