package ch.ige.adr.vo;

import java.io.Serializable;

/**
 * Value Object mit den Selektionskriterien für die Auswahl Adresse.
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: AdresseSelKritVO.java,v 1.7 2007/07/03 15:20:54 nydegger Exp $
 */
public class AdresseSelKritVO implements Serializable
{
  // Konstanten für Suchmodi
  /**
   * Suchmodus Index
   */
  public static final String SUCHMODUS_INDEX = "INDEX";
  
  /**
   * Suchmodus Volltext
   */
  public static final String SUCHMODUS_VOLLTEXT = "VOLLTEXT";
  /**
   * Konstanten für Sperrung und Deponentkonto
   */
  public static final String ALLE = "ALLE";
  /**
   * Konstante für Sperrung, nur gültige
   */
  public static final String NUR_GUELTIGE = "GUELTIGE";
  /**
   * Konstante für Sperrung, nur gesperrte
   */
  public static final String NUR_GESPERRTE = "GESPERRTE";
  /**
   * Konstanten Deponentkonto nur mit Deponentenkonto
   */
  public static final String NUR_MIT = "MIT";
  /**
   * Konstanten Deponentkonto, ohne Deponentenkonto
   */
  public static final String NUR_OHNE = "OHNE";
  // Suchkriterien
  /**
   * Suchkriterium adrNr
   */
  public int adrNr = 0;

  /**
   * Suchkriterium suchbegr
   */
  public String suchbegr = "";

  /**
   * Suchkriterium name
   */
  public String name = "";

  /**
   * Suchkriterium strasse
   */
  public String strasse = "";

  /**
   * Suchkriterium plz
   */
  public String plz = "";

  /**
   * Suchkriterium ort
   */
  public String ort = "";

  /**
   * Suchkriterium landCd
   */
  public String landCd = "";

  /**
   * Suchkriterium nurOrtsabgleich
   */
  public boolean nurOrtsabgleich = false; // nur Adressen mit Pendenzen aus Ortsabgleich

  /**
   * Suchkriterium suchmodusName
   */
  public String suchmodusName = SUCHMODUS_INDEX; // INDEX oder VOLLTEXT

  /**
   * Suchkriterium suchmodusOrt
   */
  public String suchmodusOrt = SUCHMODUS_INDEX; // INDEX, SOUNDEX oder VOLLTEXT

  /**
   * Suchkriterium gesperrt
   */
  public String gesperrt = ALLE; // ALLE, NUR_GUELTIGE, NUR_GESPERRTE

  /**
   * Suchkriterium depKto
   */
  public String depKto = ALLE; // ALLE, NUR_MIT, NUR_OHNE
}
