package ch.ige.art.client.art;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableCellRenderer;

import org.apache.log4j.Logger;

import ch.ige.art.client.CustomDlgInfo;
import ch.ige.art.client.DlgArtikelTexte;
import ch.ige.art.client.resources.BasedataConstants;
import ch.ige.art.client.util.ComboBoxObject;
import ch.ige.art.client.util.UserMessage;
import ch.ige.art.server.ArtikelDelegate;
import ch.ige.art.util.PublicationChapter;
import ch.ige.art.util.StatistikDelegate;
import ch.ige.art.util.XxDomain;
import ch.ige.art.util.XxDomainFactory;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.xml.ArtStammblatt;
import ch.ige.arthelp.HelpUtil;
import ch.ige.authz.client.AuthMain;
import ch.ige.authz.client.AuthorizationProxy;
import ch.ige.authz.gui.AuthzJMenuItem;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.DetailPane;
import ch.ige.main.client.MainController;
import ch.ige.statistikartikel.util.ArticleStatisticInfoVO;
import ch.ige.util.client.TableSorterModel;
import ch.ige.util.client.TableSorterView;

/**
 * <p>Überschrift: Artikel Detail</p>
 * <p>Beschreibung: Detailansicht der Artikeldaten</p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Anita Rueegsegger
 * @version $Id: ArtDtl.java,v 1.44 2008/07/03 13:19:21 heinzer Exp $
 */

public class ArtDtl extends DetailPane
{
  // Logging
  private static final Logger LOG = Logger.getLogger( ArtDtl.class );

  private UserMessage userMessage = new UserMessage();

  private DlgArtikelTexte editor = new DlgArtikelTexte();

  // Schlüssel
  private String artNr = null;

  private boolean isStatisticRelevant = false;

  private ArtikelGuiAVO artikelGuiAVO;

  // Tabellen
  private AtmArtPreise atmArtPreise;

  private AtmArtTexte atmArtTexte;

  private AtmArtFolge atmArtFolge;

  private AtmStatistik atmStatistik;

  private TableSorterView sorterPreise;

  private TableSorterView sorterFolge;

  private TableSorterModel sorterTexte;

  private TableSorterView sorterStatistik;

  private JTable tblPreise;

  private JTable tblTexte;

  private JTable tblFolge;

  private JTable tblStatistik;

  // Artikel-Stammblatt
  private ArtStammblatt artStammblatt = null;

  //Frame konstruieren
  public JMenuItem mnuDuplicate = new AuthzJMenuItem();

  private JPanel mainPanel = new JPanel();

  private JPanel pnlGrunddaten = new JPanel();

  private JPanel pnlBagis1 = new JPanel();

  private JPanel pnlBagis2 = new JPanel();

  private JPanel pnlTexte = new JPanel();

  private JPanel pnlSouth = new JPanel();

  private JPanel pnlStatistk = new JPanel();

  private JScrollPane scpTexte = new JScrollPane();

  private JScrollPane scpPreise = new JScrollPane();

  private JScrollPane scpFolge = new JScrollPane();

  private JScrollPane scpStatistik = new JScrollPane();

  private JTabbedPane tbpDetail = new JTabbedPane();

  private BorderLayout lytMainPanel = new BorderLayout();

  private BorderLayout lytTexte = new BorderLayout();

  private BorderLayout lytSouth = new BorderLayout();

  private BorderLayout lytStatistik = new BorderLayout();

  private GridBagLayout gridBagLayout1 = new GridBagLayout();

  private GridBagLayout gridBagLayout2 = new GridBagLayout();

  private GridBagLayout gridBagLayout3 = new GridBagLayout();

  private JLabel lblKondartCd = new JLabel();

  private JLabel lblOptBestMenge = new JLabel();

  private JLabel lblArtNr = new JLabel();

  private JLabel lblBezArt = new JLabel();

  private JLabel lblMinverkMenge = new JLabel();

  private JLabel lblProcessNr = new JLabel();

  private JLabel lblErfassProc = new JLabel();

  private JLabel lblFormartCd = new JLabel();

  private JLabel lblDruckModus = new JLabel();

  private JLabel lblAnzKopie = new JLabel();

  private JLabel lblEinzFaktpos = new JLabel();

  private JLabel lblStatcd2 = new JLabel();

  private JLabel lblStatcd1 = new JLabel();

  private JLabel lblProcessModus = new JLabel();

  private JLabel lblLageinh = new JLabel();

  private JLabel lblRegauszGrp = new JLabel();

  private JLabel lblPublPflicht = new JLabel();

  private JLabel lblStatcd3 = new JLabel();

  private JLabel lblFristDauer = new JLabel();

  private JLabel lblFristEinh = new JLabel();

  private JLabel lblFristArt = new JLabel();

  private JLabel lblKzMetnot = new JLabel();

  private JLabel lblBonusCd = new JLabel();

  private JLabel lblKzUntschr = new JLabel();

  private JLabel lblSuchbegrArt = new JLabel();

  private JTextField txfKondartCd = new JTextField();

  private JTextField txfArtNr = new JTextField();

  private JTextField txfOptBestMenge = new JTextField();

  private JTextField txfBezArt = new JTextField();

  private JTextField txfMinverkMenge = new JTextField();

  private JTextField txfProzessNr = new JTextField();

  private JTextField txfEinzFaktpos = new JTextField();

  private JTextField txfErfassProc = new JTextField();

  private JTextField txfFormartCd = new JTextField();

  private JTextField txfAnzKopie = new JTextField();

  private JTextField txfStatcd2 = new JTextField();

  private JTextField txfStatcd1 = new JTextField();

  private JTextField txfDruckModus = new JTextField();

  private JTextField txfProcessModus = new JTextField();

  private JTextField txfFristDauer = new JTextField();

  private JTextField txfFristEinh = new JTextField();

  private JTextField txfLageinh = new JTextField();

  private JTextField txfPublPflicht = new JTextField();

  private JTextField txfFristArt = new JTextField();

  private JTextField txfStatcd3 = new JTextField();

  private JTextField txfRegausGrp = new JTextField();

  private JTextField txfBonusCd = new JTextField();

  private JTextField txfKzMetnot = new JTextField();

  private JTextField txfKzUntschr = new JTextField();

  private JTextField txfSuchbegrArt = new JTextField();

  private JCheckBox ckbAltNrCd = new JCheckBox();

  private JCheckBox ckbKzGratis = new JCheckBox();

  private JCheckBox ckbKzEinschr = new JCheckBox();

  private JCheckBox ckbKzBesch = new JCheckBox();

  private JCheckBox ckbSperrCd = new JCheckBox();

  private JCheckBox ckbKzHistDesign = new JCheckBox();

  /**
   * parameterloser Konstruktor
   */
  /*  public ArtDtl()
    {
      try
      {
        jbInit();
        initHelp();
        GUIAuthorizer.authorizeFieldsIn( this );
      }
      catch ( Exception ex )
      {
        LOG.info( ex.getClass() + " " + ex.getMessage() );
        String message = userMessage.getUserMessage( ex );
        JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
      }
    }
  -*
    /**
     * Konstruktor mit Parameter für Hauptfenster und Suchmodus
     * @param mainController Hauptfenster, zuständig für Panelsteuerung
     * @param mode Suchmodus<br>
     *    0 - Suche in Auswahl<br>
     *    1 - Suche für Lookup
     *
     */
  public ArtDtl( MainController mainController, int mode )
  {
    super( mainController, mode );
    try
    {
      jbInit();
      initHelp();
      GUIAuthorizer.authorizeFieldsIn( this );
    }
    catch ( Exception ex )
    {
      LOG.info( ex.getClass() + " " + ex.getMessage() );
      String message = userMessage.getUserMessage( ex );
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @exception Exception
   */
  private void jbInit() throws Exception
  {

    atmArtPreise = new AtmArtPreise();
    atmArtTexte = new AtmArtTexte();
    atmArtFolge = new AtmArtFolge();
    atmStatistik = new AtmStatistik();

    sorterPreise = new TableSorterView( atmArtPreise );
    sorterFolge = new TableSorterView( atmArtFolge );
    sorterTexte = new TableSorterModel( atmArtTexte );
    sorterStatistik = new TableSorterView( atmStatistik );

    tblPreise = new JTable( sorterPreise );
    tblTexte = new JTable( sorterTexte );
    tblFolge = new JTable( sorterFolge );
    tblStatistik = new JTable( sorterStatistik );

    mainPanel.setLayout( lytMainPanel );
    mainPanel.setBorder( new TitledBorder( "Artikel" ) );
    pnlGrunddaten.setPreferredSize( new Dimension( 400, 300 ) );
    pnlGrunddaten.setLayout( gridBagLayout1 );
    pnlBagis1.setLayout( gridBagLayout2 );
    pnlBagis1.setPreferredSize( new Dimension( 400, 300 ) );
    pnlBagis2.setLayout( gridBagLayout3 );
    pnlBagis2.setPreferredSize( new Dimension( 400, 300 ) );
    pnlTexte.setLayout( lytTexte );
    pnlTexte.setPreferredSize( new Dimension( 400, 300 ) );
    pnlSouth.setLayout( lytSouth );
    pnlStatistk.setPreferredSize( new Dimension( 400, 300 ) );
    pnlStatistk.setLayout( lytStatistik );

    scpTexte.setBorder( new TitledBorder( "Texte" ) );
    scpTexte.setOpaque( false );
    scpPreise.setBorder( new TitledBorder( "Preise" ) );
    scpPreise.setOpaque( false );
    scpPreise.setPreferredSize( new Dimension( 300, 120 ) );
    scpFolge.setBorder( new TitledBorder( "Folgeartikel" ) );
    scpFolge.setOpaque( false );
    scpFolge.setPreferredSize( new Dimension( 300, 120 ) );

    txfArtNr.setMaximumSize( new Dimension( 80, 20 ) );
    txfArtNr.setMinimumSize( new Dimension( 80, 20 ) );
    txfArtNr.setPreferredSize( new Dimension( 80, 20 ) );
    txfBezArt.setMaximumSize( new Dimension( 500, 20 ) );
    txfBezArt.setMinimumSize( new Dimension( 500, 20 ) );
    txfBezArt.setPreferredSize( new Dimension( 500, 20 ) );
    txfSuchbegrArt.setMaximumSize( new Dimension( 500, 20 ) );
    txfSuchbegrArt.setMinimumSize( new Dimension( 500, 20 ) );
    txfSuchbegrArt.setPreferredSize( new Dimension( 500, 20 ) );
    txfKondartCd.setMaximumSize( new Dimension( 500, 20 ) );
    txfKondartCd.setMinimumSize( new Dimension( 500, 20 ) );
    txfKondartCd.setPreferredSize( new Dimension( 500, 20 ) );
    txfKondartCd.setMargin( new Insets( 1, 1, 1, 1 ) );
    txfMinverkMenge.setMaximumSize( new Dimension( 80, 20 ) );
    txfMinverkMenge.setMinimumSize( new Dimension( 80, 20 ) );
    txfMinverkMenge.setPreferredSize( new Dimension( 80, 20 ) );
    txfOptBestMenge.setMaximumSize( new Dimension( 80, 20 ) );
    txfOptBestMenge.setMinimumSize( new Dimension( 80, 20 ) );
    txfOptBestMenge.setPreferredSize( new Dimension( 80, 20 ) );
    ckbSperrCd.setMaximumSize( new Dimension( 110, 22 ) );
    ckbSperrCd.setMinimumSize( new Dimension( 110, 22 ) );
    ckbSperrCd.setPreferredSize( new Dimension( 110, 22 ) );
    ckbAltNrCd.setMaximumSize( new Dimension( 160, 22 ) );
    ckbAltNrCd.setMinimumSize( new Dimension( 160, 22 ) );
    ckbAltNrCd.setPreferredSize( new Dimension( 160, 22 ) );
    ckbKzHistDesign.setMaximumSize( new Dimension( 193, 20 ) );
    ckbKzHistDesign.setMinimumSize( new Dimension( 193, 20 ) );
    ckbKzHistDesign.setPreferredSize( new Dimension( 193, 20 ) );

    centerPanel.add( mainPanel, BorderLayout.CENTER );
    mainPanel.add( tbpDetail, BorderLayout.CENTER );

    tbpDetail.add( pnlGrunddaten, BasedataConstants.NAME );
    tbpDetail.add( pnlBagis1, "Bagisdaten 1" );
    tbpDetail.add( pnlBagis2, "Bagisdaten 2" );
    tbpDetail.add( pnlTexte, "Texte Preise Folgeartikel" );

    pnlTexte.add( scpTexte, BorderLayout.CENTER );
    scpTexte.getViewport().add( tblTexte, null );
    pnlTexte.add( pnlSouth, BorderLayout.SOUTH );
    pnlSouth.add( scpFolge, BorderLayout.SOUTH );
    scpFolge.getViewport().add( tblFolge, null );
    pnlSouth.add( scpPreise, BorderLayout.CENTER );
    scpPreise.getViewport().add( tblPreise, null );
    pnlStatistk.add( scpStatistik, BorderLayout.CENTER );
    scpStatistik.getViewport().add( tblStatistik, null );

    sorterPreise.addMouseListenerToHeaderInTable( tblPreise );
    sorterTexte.addMouseListenerToHeaderInTable( tblTexte );
    sorterFolge.addMouseListenerToHeaderInTable( tblFolge );
    sorterStatistik.addMouseListenerToHeaderInTable( tblStatistik );

    BasedataConstants.SEARCH_TERM.setupComponent( lblSuchbegrArt, true );
    BasedataConstants.NUMBER.setupComponent( lblArtNr, true );
    BasedataConstants.SUPER_GROUP.setupComponent( lblKondartCd, true );
    BasedataConstants.MAX_NUMBER.setupComponent( lblOptBestMenge, true );
    BasedataConstants.MIN_NUMBER.setupComponent( lblMinverkMenge, true );
    BasedataConstants.TERM.setupComponent( lblBezArt, true );

    lblProcessNr.setToolTipText( "process_nr" );
    lblProcessNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblProcessNr.setText( "Prozessnummer:" );
    lblErfassProc.setToolTipText( "erfass_proc" );
    lblErfassProc.setHorizontalAlignment( SwingConstants.RIGHT );
    lblErfassProc.setText( "Erfassungsprozess:" );
    lblFormartCd.setText( "Formular:" );
    lblFormartCd.setToolTipText( "formart_cd" );
    lblFormartCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblDruckModus.setToolTipText( "druck_modus" );
    lblDruckModus.setHorizontalAlignment( SwingConstants.RIGHT );
    lblDruckModus.setText( "Druckmodus:" );
    lblAnzKopie.setToolTipText( "anz_kopie" );
    lblAnzKopie.setHorizontalAlignment( SwingConstants.RIGHT );
    lblAnzKopie.setText( "Anzahl Kopien:" );
    lblKzUntschr.setText( "Unterschrift erforderlich:" );
    lblKzUntschr.setToolTipText( "kz_untschr" );
    lblKzUntschr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblEinzFaktpos.setText( "Einzelfakturaposition:" );
    lblEinzFaktpos.setToolTipText( "einz_faktpos" );
    lblEinzFaktpos.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd2.setText( "Löschregel Ereignis:" );
    lblStatcd2.setToolTipText( "statcd_2" );
    lblStatcd2.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd1.setToolTipText( "statcd_1" );
    lblStatcd1.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd1.setText( "Listentyp EP-Jahresgebühren:" );
    lblProcessModus.setText( "Prozessmodus:" );
    lblProcessModus.setToolTipText( "process_modus" );
    lblProcessModus.setHorizontalAlignment( SwingConstants.RIGHT );
    lblLageinh.setToolTipText( "lageinh" );
    lblLageinh.setHorizontalAlignment( SwingConstants.RIGHT );
    lblLageinh.setText( "Lagereinheit:" );
    lblRegauszGrp.setToolTipText( "regausz_grp" );
    lblRegauszGrp.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegauszGrp.setText( "Registerauszugsgruppe:" );
    lblPublPflicht.setText( "Publikationspflicht:" );
    lblPublPflicht.setToolTipText( "publ_pflicht" );
    lblPublPflicht.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd3.setToolTipText( "statcd_3" );
    lblStatcd3.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd3.setText( "Unterabschnitt Publikation:" );
    lblFristDauer.setText( "Frist Dauer:" );
    lblFristDauer.setHorizontalAlignment( SwingConstants.RIGHT );
    lblFristDauer.setToolTipText( "frist_dauer" );
    lblFristEinh.setText( "Frist Einheit:" );
    lblFristEinh.setHorizontalAlignment( SwingConstants.RIGHT );
    lblFristEinh.setToolTipText( "frist_einh" );
    lblFristArt.setText( "Frist Art:" );
    lblFristArt.setToolTipText( "frist_art" );
    lblFristArt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblKzMetnot.setToolTipText( "kz_metnot" );
    lblKzMetnot.setHorizontalAlignment( SwingConstants.RIGHT );
    lblKzMetnot.setText( "MARNA3-Auftrag:" );
    lblBonusCd.setToolTipText( "bonus_cd" );
    lblBonusCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblBonusCd.setText( "Bonus Code:" );

    txfArtNr.setEditable( false );
    txfBezArt.setEditable( false );
    txfKondartCd.setEditable( false );
    txfMinverkMenge.setEditable( false );
    txfOptBestMenge.setEditable( false );
    txfAnzKopie.setEditable( false );
    txfDruckModus.setEditable( false );
    txfEinzFaktpos.setEditable( false );
    txfFormartCd.setEditable( false );
    txfErfassProc.setEditable( false );
    txfProcessModus.setEditable( false );
    txfProzessNr.setEditable( false );
    txfStatcd1.setEditable( false );
    txfStatcd2.setEditable( false );
    txfFristDauer.setEditable( false );
    txfFristEinh.setEditable( false );
    txfLageinh.setEditable( false );
    txfPublPflicht.setEditable( false );
    txfFristArt.setEditable( false );
    txfStatcd3.setEditable( false );
    txfRegausGrp.setEditable( false );
    txfBonusCd.setEditable( false );
    txfKzMetnot.setEditable( false );
    txfKzUntschr.setEditable( false );
    txfSuchbegrArt.setEditable( false );
    txfSuchbegrArt.setEditable( false );

    BasedataConstants.LOCKED.setupComponent( ckbSperrCd );
    BasedataConstants.NOT_LAST.setupComponent( ckbAltNrCd );
    BasedataConstants.FREE.setupComponent( ckbKzGratis );
    BasedataConstants.HISTORY_DESIGN.setupComponent( ckbKzHistDesign );

    ckbKzEinschr.setText( "Einschreiben erforderlich" );
    ckbKzEinschr.setToolTipText( "kz_einschr" );
    ckbKzBesch.setText( "Bescheinigung erforderlich" );
    ckbKzBesch.setToolTipText( "kz_besch" );

    ckbSperrCd.setEnabled( false );
    ckbAltNrCd.setEnabled( false );
    ckbKzGratis.setEnabled( false );
    ckbKzEinschr.setEnabled( false );
    ckbKzBesch.setEnabled( false );
    ckbKzHistDesign.setEnabled( false );

    txfAnzKopie.setMaximumSize( new Dimension( 80, 20 ) );
    txfAnzKopie.setMinimumSize( new Dimension( 80, 20 ) );
    txfAnzKopie.setPreferredSize( new Dimension( 80, 20 ) );
    txfDruckModus.setMaximumSize( new Dimension( 500, 20 ) );
    txfDruckModus.setMinimumSize( new Dimension( 500, 20 ) );
    txfDruckModus.setPreferredSize( new Dimension( 500, 20 ) );
    txfEinzFaktpos.setMaximumSize( new Dimension( 500, 20 ) );
    txfEinzFaktpos.setMinimumSize( new Dimension( 500, 20 ) );
    txfEinzFaktpos.setPreferredSize( new Dimension( 500, 20 ) );
    txfFormartCd.setMaximumSize( new Dimension( 80, 20 ) );
    txfFormartCd.setMinimumSize( new Dimension( 80, 20 ) );
    txfFormartCd.setPreferredSize( new Dimension( 80, 20 ) );
    ckbKzEinschr.setMaximumSize( new Dimension( 164, 22 ) );
    ckbKzEinschr.setMinimumSize( new Dimension( 164, 22 ) );
    ckbKzEinschr.setPreferredSize( new Dimension( 164, 22 ) );
    txfKzUntschr.setMaximumSize( new Dimension( 500, 20 ) );
    txfKzUntschr.setMinimumSize( new Dimension( 500, 20 ) );
    txfKzUntschr.setPreferredSize( new Dimension( 500, 20 ) );
    txfErfassProc.setMaximumSize( new Dimension( 500, 20 ) );
    txfErfassProc.setMinimumSize( new Dimension( 500, 20 ) );
    txfErfassProc.setPreferredSize( new Dimension( 500, 20 ) );
    txfProcessModus.setMaximumSize( new Dimension( 500, 20 ) );
    txfProcessModus.setMinimumSize( new Dimension( 500, 20 ) );
    txfProcessModus.setPreferredSize( new Dimension( 500, 20 ) );
    txfStatcd1.setMaximumSize( new Dimension( 500, 20 ) );
    txfStatcd1.setMinimumSize( new Dimension( 500, 20 ) );
    txfStatcd1.setPreferredSize( new Dimension( 500, 20 ) );
    txfStatcd2.setMaximumSize( new Dimension( 500, 20 ) );
    txfStatcd2.setMinimumSize( new Dimension( 500, 20 ) );
    txfStatcd2.setPreferredSize( new Dimension( 500, 20 ) );
    txfProzessNr.setMaximumSize( new Dimension( 80, 20 ) );
    txfProzessNr.setMinimumSize( new Dimension( 80, 20 ) );
    txfProzessNr.setPreferredSize( new Dimension( 80, 20 ) );
    ckbKzBesch.setMaximumSize( new Dimension( 174, 22 ) );
    ckbKzBesch.setMinimumSize( new Dimension( 174, 22 ) );
    ckbKzBesch.setPreferredSize( new Dimension( 174, 22 ) );

    txfFristEinh.setMaximumSize( new Dimension( 500, 20 ) );
    txfFristEinh.setMinimumSize( new Dimension( 500, 20 ) );
    txfFristEinh.setPreferredSize( new Dimension( 500, 20 ) );
    txfFristDauer.setMaximumSize( new Dimension( 80, 20 ) );
    txfFristDauer.setMinimumSize( new Dimension( 80, 20 ) );
    txfFristDauer.setPreferredSize( new Dimension( 80, 20 ) );
    txfFristArt.setMaximumSize( new Dimension( 500, 20 ) );
    txfFristArt.setMinimumSize( new Dimension( 500, 20 ) );
    txfFristArt.setPreferredSize( new Dimension( 500, 20 ) );
    txfLageinh.setMaximumSize( new Dimension( 500, 20 ) );
    txfLageinh.setMinimumSize( new Dimension( 500, 20 ) );
    txfLageinh.setPreferredSize( new Dimension( 500, 20 ) );
    txfStatcd3.setMaximumSize( new Dimension( 500, 20 ) );
    txfStatcd3.setMinimumSize( new Dimension( 500, 20 ) );
    txfStatcd3.setPreferredSize( new Dimension( 500, 20 ) );
    txfPublPflicht.setMaximumSize( new Dimension( 500, 20 ) );
    txfPublPflicht.setMinimumSize( new Dimension( 500, 20 ) );
    txfPublPflicht.setPreferredSize( new Dimension( 500, 20 ) );
    txfRegausGrp.setMaximumSize( new Dimension( 500, 20 ) );
    txfRegausGrp.setMinimumSize( new Dimension( 500, 20 ) );
    txfRegausGrp.setPreferredSize( new Dimension( 500, 20 ) );
    txfBonusCd.setMaximumSize( new Dimension( 500, 20 ) );
    txfBonusCd.setMinimumSize( new Dimension( 500, 20 ) );
    txfBonusCd.setPreferredSize( new Dimension( 500, 20 ) );
    txfKzMetnot.setMaximumSize( new Dimension( 500, 20 ) );
    txfKzMetnot.setMinimumSize( new Dimension( 500, 20 ) );
    txfKzMetnot.setPreferredSize( new Dimension( 500, 20 ) );

    pnlGrunddaten.add( lblArtNr, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 6, 0, 0 ),
        139, 5 ) );
    pnlGrunddaten.add( txfArtNr, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 10, 4, 0 ), 0,
        0 ) );
    pnlGrunddaten.add( txfBezArt, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0,
        0 ) );
    pnlGrunddaten.add( lblBezArt, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 82,
        5 ) );
    pnlGrunddaten.add( txfSuchbegrArt, new GridBagConstraints( 1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlGrunddaten.add( txfKondartCd, new GridBagConstraints( 1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlGrunddaten.add( lblKondartCd, new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        33, 5 ) );

    pnlGrunddaten.add( lblMinverkMenge, new GridBagConstraints( 0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets( 0, 6, 0, 0 ), 100, 5 ) );
    pnlGrunddaten.add( lblOptBestMenge, new GridBagConstraints( 0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets( 0, 6, 0, 0 ), 98, 5 ) );
    pnlGrunddaten.add( ckbSperrCd, new GridBagConstraints( 1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlGrunddaten.add( ckbAltNrCd, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlGrunddaten.add( txfOptBestMenge, new GridBagConstraints( 1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlGrunddaten.add( txfMinverkMenge, new GridBagConstraints( 1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlGrunddaten.add( lblSuchbegrArt, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets( 0, 6, 0, 0 ), 127, 5 ) );

    pnlBagis1.add( lblAnzKopie, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 6, 0, 0 ), 111,
        5 ) );
    pnlBagis1.add( txfAnzKopie, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1.add( lblDruckModus, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        118, 5 ) );
    pnlBagis1.add( txfDruckModus, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1.add( lblEinzFaktpos, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        75, 5 ) );
    pnlBagis1.add( txfEinzFaktpos, new GridBagConstraints( 1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ),
        0, 0 ) );
    pnlBagis1.add( lblFormartCd, new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 139,
        5 ) );
    pnlBagis1.add( txfFormartCd, new GridBagConstraints( 1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1.add( ckbKzEinschr, new GridBagConstraints( 1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1
        .add( ckbKzBesch, new GridBagConstraints( 1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0, 0 ) );
    pnlBagis1.add( lblKzUntschr, new GridBagConstraints( 0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 61,
        5 ) );
    pnlBagis1.add( txfKzUntschr, new GridBagConstraints( 1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1.add( lblErfassProc, new GridBagConstraints( 0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 81,
        5 ) );
    pnlBagis1.add( txfErfassProc, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1.add( lblProcessModus, new GridBagConstraints( 0, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        105, 5 ) );
    pnlBagis1.add( txfProcessModus, new GridBagConstraints( 1, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ),
        0, 0 ) );
    pnlBagis1.add( lblProcessNr, new GridBagConstraints( 0, 9, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 97,
        5 ) );
    pnlBagis1.add( txfStatcd1,
        new GridBagConstraints( 1, 10, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0, 0 ) );
    pnlBagis1.add( lblStatcd2, new GridBagConstraints( 0, 11, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        78, 5 ) );
    pnlBagis1.add( txfStatcd2, new GridBagConstraints( 1, 11, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ),
        0, 0 ) );
    pnlBagis1.add( txfProzessNr, new GridBagConstraints( 1, 9, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlBagis1.add( lblStatcd1,
        new GridBagConstraints( 0, 10, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 26, 5 ) );

    pnlBagis2.add( lblFristEinh, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 6, 0, 0 ),
        124, 5 ) );
    pnlBagis2.add( lblFristDauer, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        128, 5 ) );
    pnlBagis2.add( lblFristArt, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 148,
        5 ) );
    pnlBagis2.add( lblLageinh,
        new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 120, 5 ) );
    pnlBagis2
        .add( lblStatcd3, new GridBagConstraints( 0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 45, 5 ) );
    pnlBagis2.add( lblRegauszGrp, new GridBagConstraints( 0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 56,
        5 ) );
    pnlBagis2.add( lblPublPflicht, new GridBagConstraints( 0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        89, 5 ) );
    pnlBagis2.add( txfFristEinh, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 10, 4, 0 ), 0,
        0 ) );
    pnlBagis2.add( txfFristDauer, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0,
        0 ) );
    pnlBagis2.add( txfFristArt,
        new GridBagConstraints( 1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlBagis2.add( lblBonusCd,
        new GridBagConstraints( 0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 120, 5 ) );
    pnlBagis2.add( lblKzMetnot, new GridBagConstraints( 0, 8, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 6, 0, 0 ),
        99, 5 ) );
    pnlBagis2.add( txfPublPflicht, new GridBagConstraints( 1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlBagis2
        .add( txfLageinh, new GridBagConstraints( 1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlBagis2
        .add( txfStatcd3, new GridBagConstraints( 1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlBagis2
        .add( txfBonusCd, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlBagis2.add( txfKzMetnot, new GridBagConstraints( 1, 8, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlBagis2.add( txfRegausGrp, new GridBagConstraints( 1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0,
        0 ) );

    //********** Tabellen ******************************************************
    // Spaltenbreite setzten
    tblPreise.getColumnModel().getColumn( 0 ).setPreferredWidth( 200 );
    tblPreise.getColumnModel().getColumn( 1 ).setPreferredWidth( 60 );
    tblPreise.getColumnModel().getColumn( 2 ).setPreferredWidth( 60 );
    tblPreise.getColumnModel().getColumn( 3 ).setPreferredWidth( 20 );

    tblTexte.getColumnModel().getColumn( 0 ).setPreferredWidth( 250 );
    tblTexte.getColumnModel().getColumn( 0 ).setMinWidth( 200 );
    tblTexte.getColumnModel().getColumn( 0 ).setMaxWidth( 300 );

    tblTexte.getColumnModel().getColumn( 1 ).setMinWidth( 60 );
    tblTexte.getColumnModel().getColumn( 1 ).setMaxWidth( 60 );

    tblStatistik.getColumnModel().getColumn( 0 ).setPreferredWidth( 250 );
    tblStatistik.getColumnModel().getColumn( 0 ).setMinWidth( 200 );
    tblStatistik.getColumnModel().getColumn( 0 ).setMaxWidth( 300 );

    tblPreise.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
    tblTexte.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
    tblFolge.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
    tblStatistik.setSelectionMode( ListSelectionModel.MULTIPLE_INTERVAL_SELECTION );

    // Spaltenausrichtung setzen
    DefaultTableCellRenderer rendererRigth = new DefaultTableCellRenderer();
    rendererRigth.setHorizontalAlignment( SwingConstants.RIGHT );
    DefaultTableCellRenderer rendererCenter = new DefaultTableCellRenderer();
    rendererCenter.setHorizontalAlignment( SwingConstants.CENTER );
    DefaultTableCellRenderer rendererLeft = new DefaultTableCellRenderer();
    rendererLeft.setHorizontalAlignment( SwingConstants.LEFT );

    tblPreise.getColumnModel().getColumn( 1 ).setCellRenderer( rendererRigth );
    tblPreise.getColumnModel().getColumn( 2 ).setCellRenderer( rendererRigth );
    tblPreise.getColumnModel().getColumn( 3 ).setCellRenderer( rendererRigth );
    tblTexte.getColumnModel().getColumn( 1 ).setCellRenderer( rendererCenter );
    tblFolge.getColumnModel().getColumn( 0 ).setCellRenderer( rendererLeft );
    tblStatistik.getColumnModel().getColumn( 0 ).setCellRenderer( rendererLeft );
    tblStatistik.getColumnModel().getColumn( 1 ).setCellRenderer( rendererLeft );

    // Tabellen Listener
    tblTexte.addMouseListener( new java.awt.event.MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        tblTexte_mouseClicked( e );
      }
    } );

    //********** Menus *********************************************************

    mnuDuplicate.setText( "Duplizieren" );
    mnuDuplicate.setMnemonic( 'U' );
    menFile.insert( mnuDuplicate, 2 );

    menFile.remove( mnuDelete );
    toolBar.remove( btnDelete );
    btnHelp.setEnabled( true );
    mnuHelp.setEnabled( true );

    //********** Menu-Funktionen*********************************************
    mnuDuplicate.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuDuplicate_actionPerformed( e );
      }
    } );
  } // jbInit

  //********** Öffentliche Standard-Methoden *******************************

  /**
   * Gibt den Titel zurück
   * @return  Titel
   */
  public String getTitle()
  {
    return "Artikel Detail";
  }

  /**
   * Setzt den Schlüssel
   * @param artNr String Schlüssel Artikeldaten
   */
  public void setKey( String artNr )
  {
    this.artNr = artNr;
  }

  public void setStatisticRelevant( boolean isStatisticRelevant )
  {
    this.isStatisticRelevant = isStatisticRelevant;
  }

  /**
   * gibt Text in der Statusbar aus
   * @param text  Text
   */
  public void setStatusBar( String text )
  {
    statusBar.setText( text );
  }

  //********** Lokale Standard-Methoden **********************************

  /**
   * aktualisiert die Daten
   */
  private void refresh()
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    read();
    statusBar.setText( "Daten gelesen !" );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Liest die Daten von der Datenbank
   */
  public void read()
  {
    try
    {
      artikelGuiAVO = ArtikelDelegate.getInstance().getArtikel( artNr.toString() );
    }
    catch ( Exception ex )
    {
      LOG.info( ex.getMessage() );
      String message = userMessage.getUserMessage( ex );
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
      statusBar.setText( " " );
      return;
    }

    setData( artikelGuiAVO );

    if ( isStatisticRelevant )
    {
      loadStatistik();
    }

  } // read

  /**
   * Füllt Controls mit den Werten des artikelGuiAVO
   * @param artikelGuiAVO ValueObject mit Daten eines Artikels
   */
  private void setData( ArtikelGuiAVO artikelGuiAVO )
  {
    //ckbKzHist should be shown only for design articles
    pnlGrunddaten.remove( ckbKzGratis );
    pnlGrunddaten.remove( ckbKzHistDesign );

    if ( XxDomainFactory.PUBL_KAP_DES.equals( PublicationChapter.getCorrespondingDomainValue( artikelGuiAVO.artNr ) ) )
    {
      pnlGrunddaten.add( ckbKzGratis, new GridBagConstraints( 1, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets( 4, 10, 4, 0 ), 0, 0 ) );
      pnlGrunddaten.add( ckbKzHistDesign, new GridBagConstraints( 1, 9, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4,
          10, 0, 0 ), 0, 0 ) );
      ckbKzHistDesign.setSelected( artikelGuiAVO.kzHistDesign != null && artikelGuiAVO.kzHistDesign.equals( "1" ) );
    }
    else
    {
      pnlGrunddaten.add( ckbKzGratis, new GridBagConstraints( 1, 8, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 10,
          0, 0 ), 0, 0 ) );
    }

    // CheckBoxen füllen
    ckbSperrCd.setSelected( artikelGuiAVO.sperrCd != null && artikelGuiAVO.sperrCd.equals( "9" ) );
    ckbAltNrCd.setSelected( artikelGuiAVO.altNrCd != null && artikelGuiAVO.altNrCd.equals( "1" ) );
    ckbKzGratis.setSelected( artikelGuiAVO.kzGratis != null && artikelGuiAVO.kzGratis.equals( "1" ) );
    ckbKzEinschr.setSelected( artikelGuiAVO.kzEinschr != null && artikelGuiAVO.kzEinschr.equals( "1" ) );
    ckbKzBesch.setSelected( artikelGuiAVO.kzBesch != null && artikelGuiAVO.kzBesch.equals( "1" ) );

    // Tabellen Preise, Texte und Folgeartikel füllen
    atmArtTexte.setData( artikelGuiAVO.artextVO );
    atmArtPreise.setData( artikelGuiAVO.artpreisVO );
    atmArtFolge.setData( artikelGuiAVO.altArtVO );

    // Auffüllen von Feldern deren Werte als String gespeichert sind
    txfArtNr.setText( artikelGuiAVO.artNr );
    txfBezArt.setText( artikelGuiAVO.bezArt );
    txfSuchbegrArt.setText( artikelGuiAVO.suchbegrArt );
    txfFormartCd.setText( artikelGuiAVO.formartCd );

    // Auffüllen von Feldern deren Werte als Integer gespeichert sind
    txfAnzKopie.setText( artikelGuiAVO.anzKopie == null ? "" : artikelGuiAVO.anzKopie.toString() );
    txfProzessNr.setText( artikelGuiAVO.processNr == null ? "" : artikelGuiAVO.processNr.toString() );
    txfFristDauer.setText( artikelGuiAVO.fristDauer == null ? "" : artikelGuiAVO.fristDauer.toString() );

    // Auffüllen von Feldern deren Werte als BigDecimal gespeichert sind
    txfMinverkMenge.setText( artikelGuiAVO.minverkMenge == null ? "" : artikelGuiAVO.minverkMenge.toString() );
    txfOptBestMenge.setText( artikelGuiAVO.optBestMenge == null ? "" : artikelGuiAVO.optBestMenge.toString() );

    // Auffüllen von Feldern deren Werte in xxDomain gespeichert sind

    // Kondart Code
    String bezKondartCd = XxDomain.getBez( artikelGuiAVO.kondartCd, XxDomainFactory.KONDART_CD );
    txfKondartCd.setText( new ComboBoxObject( artikelGuiAVO.kondartCd, bezKondartCd ).toString() );

    // Druckmodus
    if ( artikelGuiAVO.druckModus == null || artikelGuiAVO.druckModus.equals( "" ) )
    {
      txfDruckModus.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezDruckModus = XxDomain.getBez( new Integer( artikelGuiAVO.druckModus ).intValue(), XxDomainFactory.DRUCK_MODUS );
      txfDruckModus.setText( new ComboBoxObject( artikelGuiAVO.druckModus, bezDruckModus ).toString() );
    }

    // Einzelfaktur Position
    if ( artikelGuiAVO.einzFaktpos == null || artikelGuiAVO.einzFaktpos.equals( "" ) )
    {
      txfEinzFaktpos.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezEinzFaktpos = XxDomain.getBez( new Integer( artikelGuiAVO.einzFaktpos ).intValue(), XxDomainFactory.EINZ_FAKTPOS );
      txfEinzFaktpos.setText( new ComboBoxObject( artikelGuiAVO.einzFaktpos, bezEinzFaktpos ).toString() );
    }

    // Prozessmodus
    if ( artikelGuiAVO.processModus == null || artikelGuiAVO.processModus.equals( "" ) )
    {
      txfProcessModus.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String kbezProcessModus = XxDomain.getKbez( XxDomainFactory.PROCESS_MODUS, new Integer( artikelGuiAVO.processModus ).intValue() );
      txfProcessModus.setText( new ComboBoxObject( artikelGuiAVO.processModus, kbezProcessModus ).toString() );

      String bezProcessModus = XxDomain.getBez( new Integer( artikelGuiAVO.processModus ).intValue(), XxDomainFactory.PROCESS_MODUS );
      if ( bezProcessModus != null )
        txfProcessModus.setToolTipText( bezProcessModus );
    }

    // Statcd 1
    if ( artikelGuiAVO.statcd1 == null || artikelGuiAVO.statcd1.equals( "" ) )
    {
      txfStatcd1.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String kbezStatcd1 = XxDomain.getKbez( XxDomainFactory.STATCD_1, new Integer( artikelGuiAVO.statcd1 ).intValue() );
      txfStatcd1.setText( new ComboBoxObject( artikelGuiAVO.statcd1, kbezStatcd1 ).toString() );
      String bezStatcd1 = XxDomain.getBez( new Integer( artikelGuiAVO.statcd1 ).intValue(), XxDomainFactory.STATCD_1 );
      if ( bezStatcd1 != null )
        txfStatcd1.setToolTipText( bezStatcd1 );
    }

    // Statcd 2
    if ( artikelGuiAVO.statcd2 == null || artikelGuiAVO.statcd2.equals( "" ) )
    {
      txfStatcd2.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezStatcd2 = XxDomain.getKbez( XxDomainFactory.STATCD_2, new Integer( artikelGuiAVO.statcd2 ).intValue() );
      txfStatcd2.setText( new ComboBoxObject( artikelGuiAVO.statcd2, bezStatcd2 ).toString() );
    }

    // Frist Art
    if ( artikelGuiAVO.fristArt == null || artikelGuiAVO.fristArt.equals( "" ) )
    {
      txfFristArt.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezFristArt = XxDomain.getBez( artikelGuiAVO.fristArt, XxDomainFactory.FRIST_ART );
      txfFristArt.setText( new ComboBoxObject( artikelGuiAVO.fristArt, bezFristArt ).toString() );
    }

    // Frist Einheit
    if ( artikelGuiAVO.fristEinh == null || artikelGuiAVO.fristEinh.equals( "" ) )
    {
      txfFristEinh.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezFristEinh = XxDomain.getBez( new Integer( artikelGuiAVO.fristEinh ).intValue(), XxDomainFactory.FRIST_EINH );
      txfFristEinh.setText( new ComboBoxObject( artikelGuiAVO.fristEinh, bezFristEinh ).toString() );
    }

    // Lagereinheit (Wert in Kurzbezeichnung gespeichert)
    String bezLageinh = XxDomain.getBez( artikelGuiAVO.lageinh, XxDomainFactory.LAGEINH );
    txfLageinh.setText( new ComboBoxObject( artikelGuiAVO.lageinh, bezLageinh ).toString() );

    // Publikationspflicht
    if ( artikelGuiAVO.publPflicht == null || artikelGuiAVO.publPflicht.equals( "" ) )
    {
      txfPublPflicht.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String kbezPublPflicht = XxDomain.getKbez( XxDomainFactory.PUBL_PFLICHT, new Integer( artikelGuiAVO.publPflicht ).intValue() );
      txfPublPflicht.setText( new ComboBoxObject( artikelGuiAVO.publPflicht, kbezPublPflicht ).toString() );
      String bezPublPflicht = XxDomain.getBez( new Integer( artikelGuiAVO.publPflicht ).intValue(), XxDomainFactory.PUBL_PFLICHT );
      if ( bezPublPflicht != null )
        txfPublPflicht.setToolTipText( bezPublPflicht );
    }

    // Registerauszugs Gruppe (Wert in Kurzbezeichnung gespeichert aufgrund Länge)
    // Datentyp ist int
    String bezRegauszGrp = XxDomain.getBez( Integer.toString( artikelGuiAVO.regauszGrp ), XxDomainFactory.REGAUSZ_GRP );
    txfRegausGrp.setText( new ComboBoxObject( Integer.toString( artikelGuiAVO.regauszGrp ), bezRegauszGrp ).toString() );

    // Statcd3 Unterabschnitt Publikaton
    String bezStatcd3 = XxDomain.getBez( artikelGuiAVO.statcd3, XxDomainFactory.PUBL_KAP );
    txfStatcd3.setText( new ComboBoxObject( artikelGuiAVO.statcd3, bezStatcd3 ).toString() );
    // set position at beginning of textfield
    txfStatcd3.setCaretPosition( 0 );

    // Bonus Code
    if ( artikelGuiAVO.bonusCd == null || artikelGuiAVO.bonusCd.equals( "" ) )
    {
      txfBonusCd.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String kbezBonusCd = XxDomain.getKbez( XxDomainFactory.BONUS_CD, new Integer( artikelGuiAVO.bonusCd ).intValue() );
      txfBonusCd.setText( new ComboBoxObject( artikelGuiAVO.bonusCd, kbezBonusCd ).toString() );
      String bezBonusCd = XxDomain.getBez( new Integer( artikelGuiAVO.bonusCd ).intValue(), XxDomainFactory.BONUS_CD );
      if ( bezBonusCd != null )
        txfBonusCd.setToolTipText( bezBonusCd );
    }

    /** TODO tooltip ? */
    // MARNA3 Auftrag
    if ( artikelGuiAVO.kzMetnot == null || artikelGuiAVO.kzMetnot.equals( "" ) )
    {
      txfKzMetnot.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezKzMetnot = XxDomain.getBez( new Integer( artikelGuiAVO.kzMetnot ).intValue(), XxDomainFactory.KZ_METNOT );
      txfKzMetnot.setText( new ComboBoxObject( artikelGuiAVO.kzMetnot, bezKzMetnot ).toString() );
    }

    // Erfass Prozess
    if ( artikelGuiAVO.erfassProc == null || artikelGuiAVO.erfassProc.equals( "" ) )
    {
      txfErfassProc.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String kbezErfassProc = XxDomain.getKbez( XxDomainFactory.ERFASS_PROC, artikelGuiAVO.erfassProc.intValue() );
      txfErfassProc.setText( new ComboBoxObject( artikelGuiAVO.erfassProc.toString(), kbezErfassProc ).toString() );
      String bezErfassProc = XxDomain.getBez( artikelGuiAVO.erfassProc.intValue(), XxDomainFactory.ERFASS_PROC );
      if ( bezErfassProc != null )
        txfErfassProc.setToolTipText( bezErfassProc );
    }

    // Unterschrift
    if ( artikelGuiAVO.kzUntschr == null || artikelGuiAVO.kzUntschr.equals( "" ) )
    {
      txfKzUntschr.setText( new ComboBoxObject().toString() );
    }
    else
    {
      String bezKzUntschr = XxDomain.getBez( new Integer( artikelGuiAVO.kzUntschr ).intValue(), XxDomainFactory.KZ_UNTSCHR );
      txfKzUntschr.setText( new ComboBoxObject( artikelGuiAVO.kzUntschr, bezKzUntschr ).toString() );
    }

    statusBar.setText( "Daten gelesen !" );
  }

  //********** Ereignisbehandlung zu Menus *******************************

  public void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  /**
   * Artikel erstellen
   * @param e ActionEvent
   */
  protected void mnuNew_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( "Datensatz erfassen" );

    ArtWizardAbsolute med = new ArtWizardAbsolute( (Frame) mainController.getWindow() );
    String artikelNr = med.newArt();

    if ( artikelNr != null )
    {
      artNr = artikelNr;
      refresh();
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Artikel Bearbeiten
   * @param e ActionEvent
   */
  protected void mnuEdit_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( "Datensatz bearbeiten" );
    boolean edit = false;

    AuthorizationProxy authzationProxy = AuthMain.getAuthzProxy();

    // Abfrage auf den Voll-User muss zwingend zuerst erfolgen
    // da MutierenVoll von MutierenLight vererbt ist
    if ( authzationProxy.accessAllowed( "MutierenVoll", "Artikel" ) )
    {
      ArtWizardAbsolute med = new ArtWizardAbsolute( (Frame) mainController.getWindow() );
      edit = med.editArt( artNr );
    }
    else if ( authzationProxy.accessAllowed( "MutierenLight", "Artikel" ) ) // Mediator für Textbearbeitung öffnen
    {
      ArtWizardLimited med = new ArtWizardLimited( (Frame) mainController.getWindow() );
      edit = med.editArt( artNr );
    }

    if ( edit )
    {
      refresh();
      statusBar.setText( "Datensatz gespeichert." );
    }
    else
    {
      statusBar.setText( "Mutieren wurde abgebrochen" );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Artikel duplizieren
   * @param e ActionEvent
   */
  protected void mnuDuplicate_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( "Datensatz duplizieren" );

    ArtWizardAbsolute med = new ArtWizardAbsolute( (Frame) mainController.getWindow() );
    String artikelNr = med.dupliArt( artNr );

    if ( artikelNr != null )
    {
      artNr = artikelNr;
      refresh();
      statusBar.setText( "Datensatz gespeichert" );
    }
    else
    {
      statusBar.setText( "Duplizieren wurde abgebrochen" );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  protected void mnuRefresh_actionPerformed( ActionEvent e )
  {
    refresh();
  }

  protected void mnuPrint_actionPerformed( ActionEvent e )
  {
    print( artNr );
  }

  /**
   * Druckt den aktuellen Artikel via Jippsclient aus
   * @param artNr String Artikel-Nummer
   */
  private void print( String artNr )
  {
    try
    {
      artStammblatt = new ArtStammblatt();
      artStammblatt.print( artNr );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( null, "Das Stammblatt konnte nicht ausgedruckt werden", "Fehlermeldung", JOptionPane.ERROR_MESSAGE );
      statusBar.setText( " " );
    }
  }

  private void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "intro" );
    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "artikel" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "intro" );
    HelpUtil.getInstance().enableHelp( mainPanel, "artikel" );
    HelpUtil.getInstance().enableHelp( pnlBagis1, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( pnlBagis2, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( pnlGrunddaten, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( pnlSouth, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( pnlTexte, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblArtNr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblBezArt, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblAnzKopie, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblBonusCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblDruckModus, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblEinzFaktpos, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblErfassProc, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblFormartCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblFristArt, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblFristDauer, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblFristEinh, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblKondartCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblKzMetnot, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblKzUntschr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblLageinh, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblMinverkMenge, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblOptBestMenge, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblProcessModus, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblProcessNr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblPublPflicht, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblRegauszGrp, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblStatcd1, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblStatcd2, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblStatcd3, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( lblSuchbegrArt, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfArtNr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfBezArt, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfAnzKopie, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfBonusCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfDruckModus, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfEinzFaktpos, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfErfassProc, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfFormartCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfFristArt, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfFristDauer, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfFristEinh, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfKondartCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfKzMetnot, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfKzUntschr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfLageinh, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfMinverkMenge, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfOptBestMenge, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfProcessModus, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfProzessNr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfPublPflicht, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfRegausGrp, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfStatcd1, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfStatcd2, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfStatcd3, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( txfSuchbegrArt, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( tblFolge, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( tblPreise, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( tblTexte, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( ckbAltNrCd, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( ckbKzBesch, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( ckbKzEinschr, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( ckbKzGratis, "artikel.detail" );
    HelpUtil.getInstance().enableHelp( ckbSperrCd, "artikel.detail" );
  }

  //********** Pane-spezifische Methoden ***********************************

  protected void tblTexte_mouseClicked( MouseEvent e )
  {
    // bei Doppelclick Text in einem Dialogfenster anzeigen
    if ( e.getClickCount() == 2 )
    {
      editor.showDlgText( (String) atmArtTexte.getValueAt( tblTexte.getSelectedRow(), 2 ) );
    }
  }

  private void loadStatistik()
  {
    try
    {
      List<ArticleStatisticInfoVO> listVOs = StatistikDelegate.getInstance().getStatisticsForArticle( new Integer( artNr ) );

      if ( listVOs != null && !listVOs.isEmpty() )
      {
        ArticleStatisticInfoVO statisticInfoVO[] = new ArticleStatisticInfoVO[listVOs.size()];
        statisticInfoVO = listVOs.toArray( statisticInfoVO );

        tbpDetail.add( pnlStatistk, "Statistik" );
        atmStatistik.setData( statisticInfoVO );
      }
    }
    catch ( Throwable ex )
    {
      LOG.error( ex );
      String message = "Statistik Informationen nicht verfügbar";
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  //********** Authorization ***************************************************

  public static String[] getAuthzSpecifications()
  {
    return new String[] { "*New    = Erstellen/Artikel", "*Edit   = MutierenLight/Artikel", "*Duplicate = Erstellen/Artikel" };
  }

}
