package ch.ige.art.client.util;

import javax.swing.*;


/**
 * <p>Überschrift: KeySelectionManager</p>
 * <p>Beschreibung: KeySelection Manager für Comboboxen</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Stefan Nydegger
 * @version $Id: ComboKeySelectionManager.java,v 1.4 2006/12/13 10:08:31 ruegsegger Exp $
 */

public class ComboKeySelectionManager implements JComboBox.KeySelectionManager
{
	/**
	 * Gibt den Eintrag zurück, welcher selektiert werden soll<br>
	 * Überschreibt die Methode selectionForKey() des Interfaces KeySelectionManager
	 * @param  key    ein Char, entspricht normalerweise der gedrückten Keyboardtaste
	 * @param  model  ein ComboBoxModel, enthält Liste mit selektierbaren Einträgen
	 * @return Index des gewählten Eintrages<br>
	 *               0: repräsentiert den ersten Eintrag<br>
	 *               -1: es wurde kein Eintrag gefunden
	 */
	public int selectionForKey(char key, ComboBoxModel model)
	{
    int i,c;
    int currentSelection = -1;
		Object[] array = (Object[])model.getSelectedItem();
		String selectedItem = (String)array[0] + (String)array[1];
		String currentItem;
    String v;
    String pattern;

    if ( selectedItem != null )
		{
			selectedItem = selectedItem.toString();

      for ( i=0,c=model.getSize();i<c;i++ )
			{
				array = (Object[])model.getElementAt(i);
				currentItem = (String)array[0] + (String)array[1];
				if ( selectedItem.equals(currentItem))
				{
				  currentSelection  =  i;
          break;
        }
      }
    }
    pattern = ("" + key).toLowerCase();
    key = pattern.charAt(0);

    for ( i = ++currentSelection, c = model.getSize() ; i < c ; i++ )
		{
			array = (Object[])model.getElementAt(i);
			currentItem = (String)array[0] + (String)array[1];
      v = currentItem.toLowerCase();
      if ( v.length() > 0 && v.charAt(0) == key )
			{
        return i;
			}
    }

    for ( i = 0 ; i < currentSelection ; i ++ )
		{
		  array = (Object[])model.getElementAt(i);
			currentItem = (String)array[0] + (String)array[1];
      v = currentItem.toLowerCase();
      if ( v.length() > 0 && v.charAt(0) == key )
			{
        return i;
			}
		}
    return -1;
	}
}
