package ch.ige.art.client.util;

import java.util.StringTokenizer;
import ch.ige.art.xml.*;


/**
 * <p>Überschrift: UserMessage</p>
 * <p>Beschreibung: Hilfsklasse um Fehlermeldung dem Benutzer anzuzeigen</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: UserMessage.java,v 1.5 2006/12/13 10:08:31 ruegsegger Exp $
 */

public class UserMessage
{

  public UserMessage()
  {
  }

  /**
   * gibt die Benutzerinformation zurück
   *
   * @param ex  Exception die eine Fehlerinformation enthält,
   *            die für den Benutzer aussagekräftig ist
   * @return String der dem Benutzer angezeigt werden kann
   */
  public String getUserMessage(Exception ex)
  {
    String message = "";
    if (ex.getMessage() != null)
    {
      StringTokenizer st = new StringTokenizer(ex.getMessage(), "|");

      if (st.countTokens() > 1)
      {
        st.nextToken();
        message = st.nextToken();
      }
      else
      {
        message = "Keine Verbindung zum Server\n\n" +
                  "Starten Sie das Programm neu und versuchen Sie die Aktion nochmals durchzuführen.\n" +
                  "Bitte überprüfen Sie das Logfile\n";
      }
    }
    else
    {
      message = "Eine unerwartete Fehlersituation ist aufgetreten\n" +
                "Bitte überprüfen Sie das Logfile\n";
    }
    return message;
  }
}

