package ch.ige.art.client.util.verifier;

import java.awt.*;
import javax.swing.text.*;

/**
 * <p>Überschrift: </p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author unbekannt
 * @version 1.0
 */

public class RegexDocument extends PlainDocument

{
   private int maxLength = Integer.MAX_VALUE;
   private String regex = null;

  /**
   * Setzt die maximale Länge des Textes.
   * @param maxLength Maximale Anzahl der Zeichen
   */
  public void setMaxLength(int maxLength)
  {
    this.maxLength = maxLength;
  }

  /**
   * Setzt die maximale Länge des Textes.
   * @param maxLength Maximale Anzahl der Zeichen
   */
  public void setRegex(String regex)
  {
    this.regex = regex;
  }

  /**
   * Fügt einen String im Dokument ein
   * @param offset Offset im Dokument >= 0
   * @param str einzufügender String
   * @param a Attribute
   * @see AbstractDocument
   */
  public void insertString(int offset, String str, AttributeSet a) throws BadLocationException
  {
    if (str.length() > 0) // String ist nich leer
    {
      if ( (getLength() + str.length() <= maxLength ) &&  // String ist nicht zu lang
           ( str.matches(regex) ) )
//           ( str.matches( "[0-9;\u002D]" ) ) )            // Erlaubt sind Zahlen, Semikola und Bindestrich
      {
        super.insertString( offset, str, a );
      }
      else
      {
        Toolkit.getDefaultToolkit().beep();
      }
    }
  }
}


