package ch.ige.art.util;

import ch.ige.util.jms.AbstractMessageListener;
import javax.jms.Message;
import javax.jms.TextMessage;

/**
 * MessageListener for Queue QUEUE_DOMAIN_INFORMATION
 * for incoming messages processMessage-Methode is called
 * <p>
 * Copyright (c) 2006, Swiss Federal Institute of Intellectual Property
 * @author A. Rueegsegger
 * @version $Id: DomainMessageListener.java,v 1.3 2006/09/07 16:08:00 ruegsegger Exp $
 */
public class DomainMessageListener extends AbstractMessageListener
{
  private static final String ORIGIN_PROPERTY_NAME = "ORIGIN";
  public final static String ORIGIN_ART = "ART";


  public DomainMessageListener()
  {
    super();
  }


  protected boolean acceptMessage( Message message )
  {
    return super.acceptMessage( message ) && message instanceof TextMessage;
  }

  /**
   * process the textmessage
   * is used only for testing purpose
   * @param message Message
   * @param attempt int
   * @throws Exception
   */
  protected void processMessage( Message message, int attempt ) throws Exception
  {
    TextMessage textMessage = (TextMessage)message;
    String origin = textMessage.getStringProperty( ORIGIN_PROPERTY_NAME );
    System.out.println("origin: " + origin );

    String text = textMessage.getText();
    System.out.println("text: " + text );
  }
}
