package ch.ige.art.util.test;

import java.util.*;

import ch.ige.art.util.*;
import ch.ige.art.vo.test.*;
import ch.ige.art.xml.*;
import ch.ige.util.ServiceLocator;
import ch.ige.util.server.DBHelper;
import junit.framework.*;
import org.apache.log4j.*;

public class DomainJMSSenderTest extends TestCase
{
  private static final Logger LOG = Logger.getLogger( DomainJMSSenderTest.class );
  
  public DomainJMSSenderTest( String s )
  {
    super(s);
    BasicConfigurator.configure();
    
    // init test as standalone client    
    Hashtable hash = ServiceLocator.getRemoteJNDIEnvironment();
       
    Enumeration e = hash.keys();
    while ( e.hasMoreElements())
    {
      String key = (String)e.nextElement(); 
      System.setProperty( key, (String)hash.get(key) ); 
    }    
  }

  public void test()
  {
    List registerList = Testdata.createListArtextVO( "14500", new String[]{"REG"} ) ;
    List publicationList = Testdata.createListArtextVO( "14500",  new String[]{"PBL"} ) ;

    DomainDocument document = new DomainDocument( "14500" );
    document.addPublicationEntry( publicationList );
    document.addRegisterEntry( registerList );

    try
    {
      String s = document.validateAndNormalize();
      
      LOG.info( "start submitting message: \n" + s );
      
      DomainJMSSender.submit(s);
    }
    catch ( Exception ex )
    {      
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
