package ch.ige.art.vo;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * Überschrift:   ArtikelGuiAVO
 * Beschreibung:  Value Object eines kompletten ARtikels
 * Copyright:     Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * Organisation:  IGE
 * @author        Stefan Nydegger
 * @version $Id: ArtikelGuiAVO.java,v 1.10 2008/07/02 07:19:28 heinzer Exp $
 */

public class ArtikelGuiAVO implements Serializable
{
  public String artNr = null;

  public ArtextVO artextVO[];

  public AltArtVO altArtVO[];

  public ArtpreisVO artpreisVO[];

  public String bezArt = null;

  public String altNrCd = "0";

  public String artgrpCd = null;

  public String bonusCd = "1";

  public String kondartCd = null;

  public String kzGratis = "0";

  public String kzHistDesign = null;

  public String kzMetnot = null;

  public String lageinh = "ANZ";

  public BigDecimal minverkMenge = new BigDecimal( 1 );

  public BigDecimal optBestMenge = new BigDecimal( 1 );

  public String provCd = "1";

  public String sperrCd = "0";

  public String statcd1 = null;

  public String statcd2 = null;

  public String statcd3 = null;

  public String suchbegrArt = null;

  public Integer anzKopie = new Integer( 1 );

  public String druckModus = "1";

  public String einzFaktpos = "1";

  public String formartCd = null;

  public String kzEinschr = "0";

  public String kzUntschr = "1";

  public String publPflicht = "0";

  public int regauszGrp = 0;

  public String fristArt = "0";

  public String fristEinh = "0";

  public Integer fristDauer = new Integer( 0 );

  public String kzBesch = "0";

  public Integer erfassProc = null;

  public String processModus = "1";

  public Integer processNr = null;

  public String status = "";

  public String userName = "";

  public String artikelVersion = "!";

  public String artBezVersion = "!";

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();
    StringBuffer tmp = new StringBuffer();

    buf.append( "  artNr            = <" + this.artNr + ">\n" );
    buf.append( "  bezArt           = <" + this.bezArt + ">\n" );
    buf.append( "  altNrCd          = <" + this.altNrCd + ">\n" );
    buf.append( "  artgrpCd         = <" + this.artgrpCd + ">\n" );
    buf.append( "  bonusCd          = <" + this.bonusCd + ">\n" );
    buf.append( "  kondartCd        = <" + this.kondartCd + ">\n" );
    buf.append( "  kzGratis         = <" + this.kzGratis + ">\n" );
    buf.append( "  kzHistDesign         = <" + this.kzHistDesign + ">\n" );
    buf.append( "  kzMetnot         = <" + this.kzMetnot + ">\n" );
    buf.append( "  lageinh          = <" + this.lageinh + ">\n" );
    buf.append( "  minverkMenge     = <" + this.minverkMenge + ">\n" );
    buf.append( "  optBestMenge     = <" + this.optBestMenge + ">\n" );
    buf.append( "  provCd           = <" + this.provCd + ">\n" );
    buf.append( "  sperrCd          = <" + this.sperrCd + ">\n" );
    buf.append( "  statcd1          = <" + this.statcd1 + ">\n" );
    buf.append( "  statcd2          = <" + this.statcd2 + ">\n" );
    buf.append( "  statcd3          = <" + this.statcd3 + ">\n" );
    buf.append( "  suchbegrArt      = <" + this.suchbegrArt + ">\n" );
    buf.append( "  anzKopie         = <" + this.anzKopie + ">\n" );
    buf.append( "  druckModus       = <" + this.druckModus + ">\n" );
    buf.append( "  einzFaktpos      = <" + this.einzFaktpos + ">\n" );
    buf.append( "  formartCd        = <" + this.formartCd + ">\n" );
    buf.append( "  kzEinschr        = <" + this.kzEinschr + ">\n" );
    buf.append( "  kzUntschr        = <" + this.kzUntschr + ">\n" );
    buf.append( "  publPflicht      = <" + this.publPflicht + ">\n" );
    buf.append( "  regauszGrp       = <" + this.regauszGrp + ">\n" );
    buf.append( "  fristArt         = <" + this.fristArt + ">\n" );
    buf.append( "  fristEinh        = <" + this.fristEinh + ">\n" );
    buf.append( "  fristDauer       = <" + this.fristDauer + ">\n" );
    buf.append( "  kzBesch          = <" + this.kzBesch + ">\n" );
    buf.append( "  erfassProc       = <" + this.erfassProc + ">\n" );
    buf.append( "  processModus     = <" + this.processModus + ">\n" );
    buf.append( "  processNr        = <" + this.processNr + ">\n" );
    buf.append( "  status           = <" + this.status + ">\n" );
    buf.append( "  userName         = <" + this.userName + ">\n" );
    buf.append( "  artikelVersion   = <" + this.artikelVersion + ">\n" );
    buf.append( "  artBezVersion    = <" + this.artBezVersion + ">\n" );

    // ArtextVO
    if ( artextVO == null || artextVO.length == 0 )
    {
      buf.append( "  artextVO         = <keine>\n" );
    }
    else
    {
      tmp = new StringBuffer();

      for ( int i = 0; i < artextVO.length; i++ )
      {
        tmp.append( artextVO[i].toString() + "\n" );
      }
      buf.append( "  artextVO         \n" + tmp.toString() );
    }

    // AltArtVO
    if ( altArtVO == null || altArtVO.length == 0 )
    {
      buf.append( "  altArtVO         = <keine>\n" );
    }
    else
    {
      tmp = new StringBuffer();

      for ( int i = 0; i < altArtVO.length; i++ )
      {
        tmp.append( altArtVO[i].toString() + "\n" );
      }
      buf.append( "  altArtVO         \n" + tmp.toString() );
    }

    // ArtpreisVO
    if ( artpreisVO == null || artpreisVO.length == 0 )
    {
      buf.append( "  artpreisVO       = <keine>\n" );
    }
    else
    {
      tmp = new StringBuffer();

      for ( int i = 0; i < artpreisVO.length; i++ )
      {
        tmp.append( artpreisVO[i].toString() + "\n" );
      }
      buf.append( "  artpreisVO       \n" + tmp.toString() );
    }

    return buf.toString();
  }
}
