package ch.ige.art.vo;

/**
 * Beschreibung: ValueObject der Tabelle XxDomain
 * Bei den Wertebreichen gibt es verschiedene Ausprägungen eines XxDomainVOs,
 * je nachdem in welchem Attribute key und value gespeichert werden
 * Type 1: XxDomainKbezVO Key wird in dem Attribute kbez gespeichert value im Attribute bez
 * Type 2: XxDomainLnrVO Key wird in dem Attribute domainLnr gespeichert value im Attribute kbez
 * Type 3: XxDomainBezVO Key wird in dem Attribute domainLnr gespeichert value im Attribute bez
 * Copyright (c) 2005, Institut für Geistiges Eigentum
 * @author A. Rüegsegger
 * @version $Id: XxDomainKbezVO.java,v 1.5 2008/06/25 13:58:04 ruegsegger Exp $
 */

public class XxDomainKbezVO extends XxDomainVO
{

  public XxDomainKbezVO()
  {
  }

  /**
   * Gibt den Schlüssel zurück
   * @return String Key
   */
  @Override
  public String getKey()
  {
    return getKbez();
  }

  /**
   * Gibt den Value zurück
   * @return String Value
   */
  @Override
  public String getText()
  {
    return getBez();
  }
}
