package ch.ige.art.xml.test;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

import ch.ige.art.server.dao.BformartDAO;
import ch.ige.art.util.XxDomain;
import ch.ige.art.vo.BformDruckVO;
import ch.ige.art.vo.BformartVO;
import ch.ige.art.vo.test.Testdata;
import ch.ige.art.xml.FormStammblatt;
import ch.ige.util.server.DBHelper;

/**
 * Beschreibung: Junit-Test der Klasse Formular
 * Copyright (c) 2005, Institut für Geistiges Eigentum
 * @author A. Rüegsegger
 * @version $Id: FormStammblattTest.java,v 1.13 2008/07/03 09:51:15 heinzer Exp $
 */

public class FormStammblattTest extends TestCase
{

  /**
   * The log
   */
  private static final Logger LOG = Logger.getLogger( FormStammblattTest.class );

  static
  {
    // init log4j
    BasicConfigurator.configure();

    // init print client
    System.setProperty( "jippsclient.port", "5000" );

    // user name
    System.setProperty( "user.name", "rue" );

    //init singleton
    try
    {
      XxDomain.init();
    }
    catch ( Exception e )
    {
      LOG.error( "Error: could not initialize XxDomain " + e.getMessage(), e );
    }
  }

  public FormStammblattTest( String s )
  {
    super( s );
  }

  public void test01Print()
  {
    System.out.println( "Test PRINT" );
    FormStammblatt formStammblatt;

    List listFormular = new ArrayList();
    BformDruckVO bformDruckVO = Testdata.createBformDruckVO();

    try
    {
      formStammblatt = new FormStammblatt();

      listFormular.add( bformDruckVO );
      String xml = formStammblatt.getXMLString( listFormular );

      if ( xml == null || xml.equals( "" ) )
      {
        fail( "Kein Inhalt" );
      }

      assertTrue( xml.length() > 0 );
      System.out.println( xml );

      formStammblatt.saveToUTF8File( xml, new File( "c:\\temp\\form.xml" ) );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }

  public void printAllText()
  {
    System.out.println( "Test PRINT" );
    DBHelper.setRunOnServer( false );

    FormStammblatt formStammblatt;
    BformartVO vo;

    BformartVO selKritVO = new BformartVO();
    BformartDAO dao = new BformartDAO();
    List listFormular = new ArrayList();

    selKritVO.bez = "%";

    try
    {
      formStammblatt = new FormStammblatt();
      List list = dao.select( selKritVO.formartCd, selKritVO.bez, selKritVO.druckSystem );
      for ( int i = 0; i < list.size(); i++ )
      {
        vo = (BformartVO) list.get( i );
        listFormular.add( vo.formartCd );
      }

      formStammblatt.print( listFormular );
      this.assertTrue( list.size() > 0 );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }

  }
}
