package ch.ige.epband.clientneu.test;

import java.util.List;
import java.util.Map;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.epband.clientneu.ParseSGML;
import ch.ige.epband.server.EpbandDelegate;
import ch.ige.epband.util.XMLDoc;
import ch.ige.epband.vo.EpbandVO;
import ch.ige.epband.vo.EreignisVO;

/**
 * Junit-Test der Klasse EpbandDelegate
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * 
 * @author A. Rueegsegger
 * @version Id:
 */

public class TestEpbandDelegate extends TestCase
{
  private List<String> blandWork = null;

  /**
   * Initialisierung 
   * @param s
   */
  public TestEpbandDelegate( String s )
  {
    super( s );
    BasicConfigurator.configure();
  }

  @Override
  protected void setUp()
  {
    try
    {
      blandWork = EpbandDelegate.getInstance().getAllBland();
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
      ex.printStackTrace();
    }
  }

  /**
   * Testmethode Holen der Unicode-Map
   *
   */
  public void test00()
  {
    try
    {
      Map<String, String> map = EpbandDelegate.getInstance().getAllMappingUnicode();

      System.out.println( map.size() );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
      ex.printStackTrace();
    }
  }

  /**
   * Testmethode Gesuch erstellen
   *
   */
  public void _testCreateGesuch()
  {
    EpbandVO epbandVO = new EpbandVO();
    String gesuch = CreateTestpatent.createtestgesuch1();

    try
    {
      XMLDoc xml = new XMLDoc( gesuch );

      ParseSGML parsesgml = new ParseSGML( blandWork );
      parsesgml.setData( epbandVO, xml );
      parsesgml.doParseSGML();

      EpbandDelegate.getInstance().createEp( epbandVO );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
      ex.printStackTrace();
    }
  }

  public void testGetLastPatPublDat()
  {
    try
    {
      EpbandVO epbandVO = new EpbandVO();
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }

  }

  /**
   * Testen ob das Publ-Ziel richtig gesetzt wird, wenn das EP nach der Einführung 
   * der E-Publikation publiziert wurde.
   *
   */
  public void testCreateEPErteiltePubli()
  {
    EpbandVO epbandVO = new EpbandVO();
    String gesuch = CreateTestpatent.createtesteperteiltEPubli();

    try
    {
      XMLDoc xml = new XMLDoc( gesuch );

      ParseSGML parsesgml = new ParseSGML( blandWork );
      parsesgml.setData( epbandVO, xml );
      parsesgml.doParseSGML();

    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
      ex.printStackTrace();
    }
    EreignisVO eVO = epbandVO.ereigAL.get( 1 );
    assertEquals( eVO.publZiel, 1 );
  }
}
