package ch.ige.epband.server.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import ch.ige.epband.vo.SchutitEmpfadrVO;
import ch.ige.util.log.LogLevelHelper;
import ch.ige.util.server.DBHelper;

/**
 * <p>Überschrift:  Dataacess Object für SchutitEmpfadr</p>
 * <p>Beschreibung: </p>
 * <p>Copyright:    Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: IGE</p>
 * @author          Martin Trachsel
 * @version         $Id: SchutitEmpfadrDAO.java,v 1.12 2008/03/10 15:57:10 wild Exp $
 */

public class SchutitEmpfadrDAO
{

  /**
   * Kreiert ein schutit_empfadr
   * @param vo Value Object mit den Daten für schutit_empfadr
   * @return int Number of insertet Rows 
   * @throws SQLException
   */
  public int insert( SchutitEmpfadrVO vo ) throws SQLException
  {
    Connection con = null;
    PreparedStatement ps = null;
    String query = null;
    try
    {
      con = DBHelper.getConnection( DBHelper.BAGIS );
      query = "INSERT INTO schutit_empfadr (" + "schutit_key, " + "adr_nr, " + "empf_typ, " + "erfass_ma, " + "erfass_dat) " + "values (?, ?, ?, ?, ?) ";
      ps = con.prepareStatement( query );
      ps.setInt( 1, vo.schutitKey );
      ps.setInt( 2, vo.adrNr );
      ps.setInt( 3, vo.empfTyp );
      if ( vo.erfassMa == null )
      {
        ps.setNull( 4, java.sql.Types.INTEGER );
      }
      else
      {
        ps.setInt( 4, vo.erfassMa.intValue() );
      }
      ps.setDate( 5, new java.sql.Date( System.currentTimeMillis() ) );

      return ps.executeUpdate();
    }
    catch ( SQLException ex )
    {
      LogLevelHelper.log( ex, SchutitEmpfadrDAO.class, query + vo.toString() );
      throw ex;
    }
    finally
    {
      DBHelper.close( ps, con );
    }
  }
}
