package ch.ige.epband.server.dao.test;

import ch.ige.epband.server.dao.EreigTxtDAO;
import ch.ige.epband.server.dao.EreignisDAO;
import ch.ige.epband.server.dao.SchutitDAO;
import ch.ige.epband.vo.EreigTxtVO;
import ch.ige.epband.vo.EreignisVO;
import ch.ige.epband.vo.SchutitVO;
import ch.ige.epband.vo.test.Testdata;

/**
 * Junit-Test Klasse EreigTxtDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: EreigTxtDAOTest.java,v 1.5 2008/05/22 15:54:32 ruegsegger Exp $
 */
public class EreigTxtDAOTest extends DAOTestCase
{
  private SchutitDAO schutitDAO = new SchutitDAO();

  private SchutitVO schutitVO;

  private EreignisDAO ereignisDAO = new EreignisDAO();

  private EreignisVO ereignisVO = new EreignisVO();

  private EreigTxtDAO ereigTxtDAO = new EreigTxtDAO();

  private EreigTxtVO ereigTxtVO;

  public EreigTxtDAOTest( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      schutitDAO.insert( schutitVO );

      ereignisVO = Testdata.createEreignisErsterfassung();
      ereignisDAO.insert( ereignisVO );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    try
    {
      schutitDAO.deleteSchutit( schutitVO.schutitKey );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test00Insert()
  {
    try
    {
      ereigTxtVO = Testdata.createEreigTxt();
      int ret = ereigTxtDAO.insert( ereigTxtVO );
      assertEquals( 1, ret );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }
}
