package ch.ige.epband.server.dao.test;

import java.sql.SQLException;

import ch.ige.epband.server.dao.EreignisDAO;
import ch.ige.epband.server.dao.SchutitDAO;
import ch.ige.epband.vo.EreignisVO;
import ch.ige.epband.vo.SchutitVO;
import ch.ige.epband.vo.test.Testdata;

/**
 * Junit-Test der Klasse EreignisDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: EreignisDAOTest.java,v 1.7 2008/05/22 15:54:32 ruegsegger Exp $
 */
public class EreignisDAOTest extends DAOTestCase
{
  private EreignisDAO ereignisDAO = new EreignisDAO();

  private EreignisVO ereignisVO = Testdata.createEreignisErsterfassung();

  private SchutitDAO schutitDAO = new SchutitDAO();

  private SchutitVO schutitVO;

  public EreignisDAOTest( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      schutitDAO.insert( schutitVO );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    try
    {
      schutitDAO.deleteSchutit( schutitVO.schutitKey );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test00Insert()
  {
    try
    {
      int result = ereignisDAO.insert( ereignisVO );
      assertEquals( 1, result );
    }
    catch ( SQLException ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test01exist()
  {
    try
    {
      // insert erforderlich, da in teardown cascade gelöscht wird
      ereignisDAO.insert( ereignisVO );

      boolean exist = ereignisDAO.existArtNr( ereignisVO.schutitKey, EreignisVO.ERSTERFASSUNG );
      assertTrue( exist );
    }
    catch ( SQLException ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test02EreigIdat()
  {
    try
    {
      // insert erforderlich, da in teardown cascade gelöscht wird
      ereignisDAO.insert( ereignisVO );

      int nextEreigIdat = ereignisDAO.getNextereigIdat( ereignisVO.schutitKey, ereignisVO.ereigIdat );
      assertEquals( ereignisVO.ereigIdat + 5, nextEreigIdat );
    }
    catch ( SQLException ex )
    {
      fail( ex.getMessage() );
    }
  }

}
