package ch.ige.epband.server.dao.test;

import ch.ige.epband.server.dao.EreignisDAO;
import ch.ige.epband.server.dao.SchutitDAO;
import ch.ige.epband.server.dao.SchutitRegadrDAO;
import ch.ige.epband.vo.EreignisVO;
import ch.ige.epband.vo.SchutitRegadrVO;
import ch.ige.epband.vo.SchutitVO;
import ch.ige.epband.vo.test.Testdata;

/**
 * Junit-Test SchutitRegAdr
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: SchutitRegadrDAOTest.java,v 1.7 2008/05/22 15:54:32 ruegsegger Exp $
 */

public class SchutitRegadrDAOTest extends DAOTestCase
{
  private SchutitRegadrDAO schutitRegadrDAO = new SchutitRegadrDAO();

  private SchutitRegadrVO schutitRegadrVO = null;

  private EreignisDAO ereignisDAO = new EreignisDAO();

  private EreignisVO ereignisVO = new EreignisVO();

  private SchutitDAO schutitDAO = new SchutitDAO();

  private SchutitVO schutitVO;

  public SchutitRegadrDAOTest( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      schutitDAO.insert( schutitVO );

      ereignisVO = Testdata.createEreignisErsterfassung();
      ereignisDAO.insert( ereignisVO );

    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    try
    {
      schutitDAO.deleteSchutit( schutitVO.schutitKey );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test00Insert()
  {
    try
    {
      schutitRegadrVO = Testdata.createSchutitRegAdr();
      int result = schutitRegadrDAO.insert( schutitRegadrVO );
      assertEquals( 1, result );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

}
