package ch.ige.epband.util.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.epband.util.XMLExtractor;

/**
 * testcase for class XMLExtractor
 *
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author A.Rueegsegger
 * @version $Id: XMLExtractorTest.java,v 1.1 2008/05/27 07:52:55 ruegsegger Exp $
 */
public class XMLExtractorTest extends TestCase
{
  static
  {
    // init log4j
    BasicConfigurator.configure();
  }

  public XMLExtractorTest( String s )
  {
    super( s );
  }

  public void test00()
  {
    try
    {
      String schutitnr = "1023847";
      String browseLocation = "file:///c:/jp/projects/epband/testfiles";
      String storeLocation = "file:///c:/data/epband/found";
      String regex = "^st360533.*.zip$";

      String[] args = { schutitnr, browseLocation, storeLocation, regex };
      XMLExtractor.main( args );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void test01()
  {
    try
    {
      //1020724 found in a-file and 2 times in b-file
      String schutitnr = "1020724,1023847";
      String browseLocation = "file:///c:/jp/projects/epband/testfiles";
      String storeLocation = "file:///c:/data/epband/found";
      String regex = "^st360533.*.zip$";

      String[] args = { schutitnr, browseLocation, storeLocation, regex };

      XMLExtractor.main( args );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void test02()
  {
    try
    {
      //1020724 found in a-file and 2 times in b-file
      String schutitnr = "1020724,1023847";
      String browseLocation = "file:///c:/data/epband/browse";
      String storeLocation = "file:///c:/data/epband/found";
      String regex = "^.*.txt$";

      String[] args = { schutitnr, browseLocation, storeLocation, regex };
      XMLExtractor.main( args );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
