package ch.ige.image.filter;

import java.awt.image.BufferedImage;

/**
 * Calculates the average brightness from the Y component of the XYZ.
 *
 * <p>Copyright (c) 2009, Swiss Federal Institute of Intellectual Property</p>
 * @author   locher
 * @version  $Id: BrightnessDebugFilter.java,v 1.1 2009/05/06 09:56:12 locher Exp $
 */
public class BrightnessDebugFilter extends AbstractPixelVisitor
{
  private double sumY = 0.0;

  private long area = 1;

  /**
   * Gets the brightnes.
   * @return the average brightness
   */
  public float getAverageBrightness()
  {
    return (float) ( sumY / area );
  }

  // @see ch.ige.image.filter.AbstractPixelVisitor#visit(java.awt.image.BufferedImage)
  @Override
  protected void visit( BufferedImage img )
  {
    this.sumY = 0.0;
    this.area = (long) img.getHeight() * (long) img.getWidth();
    super.visit( img );
  }

  // @see ch.ige.image.filter.AbstractPixelVisitor#visit(int, int, int, float[])
  @Override
  protected void visit( int x, int y, int srgb, float[] xyz )
  {
    sumY += xyz[1]; //extract Y and accumulate
  }

}
