package ch.ige.image.test;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import junit.framework.TestCase;
import ch.ige.image.BufferedImageWrapper;
import ch.ige.image.MetadataBean;

/**
 * Common Infrastructure for Image tests.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * @author    Michael Locher
 * @version   $Id: AbstractImageTester.java,v 1.3 2006/12/05 15:57:01 bandschapp Exp $
 */
public abstract class AbstractImageTester extends TestCase
{

  public AbstractImageTester(String name)
  {
    super(name);
  }

  protected BufferedImageWrapper createDummyImage(int width, int height)
  {
    BufferedImage dummy = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
    Graphics2D g2d = (Graphics2D) dummy.getGraphics();
    g2d.setColor(Color.GREEN);
    g2d.drawOval(0, 0, width, height);
    g2d.dispose();
    return new BufferedImageWrapper(dummy, new MetadataBean(dummy));
  }

}