package ch.ige.imagehandler.rule;

import ch.ige.image.Image;
import ch.ige.image.ImageException;

/**
 * No Operation (NoOP) Rule. Does nothing. 
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * @author    Michael Locher
 * @version   $Id: NoOP.java,v 1.9 2009/04/14 13:28:42 locher Exp $
 */
public class NoOP<I extends Image> extends AbstractRule<I> implements FlowControl<I, I>
{

  /*
   * @see ch.ige.imagehandler.rule.AbstractRule#getRuleName()
   */
  @Override
  protected String getRuleName()
  {
    return "NoOP";
  }

  // @see ch.ige.imagehandler.rule.FlowControl#isConverter()
  public boolean isConverter()
  {
    return true;
  }

  /*
   * @see ch.ige.imagehandler.rule.Checker#checkImage(ch.ige.image.Image)
   */
  public void checkImage( I image ) throws RuleException
  {
    // ignore
  }

  /*
   * @see ch.ige.imagehandler.rule.Converter#convert(ch.ige.image.Image)
   */
  public I convert( I source ) throws RuleException, ImageException
  {
    return source;
  }

}
