package ch.ige.imagehandler.rule.parameter;

/**
 * Single Name/Value pair.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * @author    Michael Locher
 * @version   $Id: SingleBinding.java,v 1.5 2009/03/19 13:26:23 locher Exp $
 */
public class SingleBinding implements Parameter
{

  private String name;
  private String value;

  public SingleBinding()
  {
    super();
  }
  
  public SingleBinding(String name, String value)
  {
    this.name = name;
    this.value = value;
  }

  /*
   * @see ch.ige.imagehandler.rule.parameter.Parameter#getName()
   */
  public String getName()
  {
    return name;
  }

  /**
   * Sets the name of this parameter.
   * 
   * @param name
   *          the name
   */
  public void setName(String name)
  {
    this.name = name;
  }

  /**
   * Gives the value of this parameter.
   * @return the value
   */
  public String getValue()
  {
    return value;
  }

  /**
   * Sets the value of this parameter.
   * @param value
   */
  public void setValue(String value)
  {
    this.value = value;
  }

  @Override
  public String toString()
  {
    return this.name + " = " + this.value;
  }

}
