package ch.ige.ipcloadscheme.client.file;

import java.io.File;
import java.io.FileFilter;

import ch.ige.ipcloadscheme.client.SchemeProperties;

/**
 * Filter für die Bilder (Figures)
 * Bildname muss dem regulären Ausdruck entsprechen, der in den Properties gespeichert wird
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: FigureFilter.java,v 1.5 2008/07/01 06:25:15 lewis_lee Exp $
 */

public class FigureFilter implements FileFilter
{
  private String figureName;

  public FigureFilter()
  {
    figureName = SchemeProperties.getInstance().getProperty( SchemeProperties.IMAGE_FILE_NAME );
  }

  public boolean accept( File f )
  {
    return ( f.getName().toLowerCase().matches( figureName.toLowerCase() ) );
  }
}
