package ch.ige.ipcloadscheme.server.dao.test;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadscheme.server.dao.*;
import ch.ige.ipcloadscheme.vo.*;
import junit.framework.*;
import ch.ige.ipcloadscheme.vo.test.*;
import ch.ige.util.ServiceLocator;
import ch.ige.util.server.DBHelper;


/**
 * Testklasse für IpcBildDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: IpcBildDAOTest.java,v 1.8 2007/01/11 20:24:47 ruegsegger Exp $
 */

public class IpcBildDAOTest extends DAOTestCase
{
  private IpcBildDAO ipcBildDAO = new IpcBildDAO();
  private IpcBildVO vo;

 
  public IpcBildDAOTest( String s )
  {
    super( s );
  }

  public void setUp()
  {
    try
    {
      vo = Testdata.getBildVO();      
    }
    catch ( Exception ex )
    {
      fail(ex.getMessage());
    }
  }

  public void test01Insert()
  {
    System.out.println( "Test INSERT " );

    try
    {
      int anz = ipcBildDAO.insert( vo );
      this.assertEquals( 1, anz );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test02Exists()
  {
    System.out.println( "Test EXIST " );

    try
    {
      boolean exists = ipcBildDAO.exists( vo.bildname );
      assertTrue( exists );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test03Update()
  {
    System.out.println( "Test UPDATE " );

    try
    {
      int anz = ipcBildDAO.update( vo );
      assertEquals( 1, anz );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test04Delete()
  {
    System.out.println( "Test DELETE " );

    try
    {
      int anz = ipcBildDAO.delete( vo.bildname );
      assertEquals( 1, anz );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }
}

