package ch.ige.ipcloadscheme.server.dao.test;


import junit.framework.TestCase;
import ch.ige.ipcloadscheme.vo.IpcKlasseVO;
import ch.ige.ipcloadscheme.server.dao.IpcKlasseDAO;
import java.util.Collection;
import java.util.Iterator;
import java.sql.SQLException;
import java.sql.BatchUpdateException;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadscheme.vo.test.*;
import ch.ige.util.server.DBHelper;


/**
 * Junit-Test der Klasse IpcKlasseDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $ Id: $
 */
public class IpcKlasseDAOTest extends DAOTestCase
{
  private IpcKlasseDAO dao = new IpcKlasseDAO();
  private IpcKlasseVO vo;

  
   
  public IpcKlasseDAOTest(String s)
  {
    super(s);
  }


  public void setUp()
  {
    vo = Testdata.getIpcKlasseVO();
  }


  public void test01Insert()
  {
    System.out.println( "Test INSERT " );

    try
    {
      dao.insert(vo);

      assertTrue( dao.exists(vo.ipcKlasse) );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test02Exist()
  {
    System.out.println( "Test EXIST " );

    try
    {
      boolean exists = dao.exists( vo.ipcKlasse );
      assertTrue( exists );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test03Delete()
  {
    System.out.println( "Test DELETE " );

    try
    {
      int anz = dao.delete( vo.ipcKlasse );
      assertEquals( 1, anz );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }

  }


  public void test04ExecuteInsert()
  {
    System.out.println( "Test EXECUTE INSERT " );
    Collection c = Testdata.getIpcKlasseVOs();

     try
     {
       int[] resultarr = dao.executeInsert(c);

       for (int i = 0; i < resultarr.length; i++)
       {
         assertEquals( 1, resultarr[i]);
       }
     }
     catch ( BatchUpdateException bex )
     {
       int[] updateCounts = bex.getUpdateCounts();
       System.out.println("Anzahl eingefügte Datensätze: " + updateCounts.length + " / " + c.size() );

       Iterator it = c.iterator();
       for ( int i = 0; i < updateCounts.length; i++ )
       {
         IpcKlasseVO vo = ( IpcKlasseVO ) it.next();
         if ( updateCounts[i] == 0 )
         {
           System.out.println("Fehler bei " +  vo.toString() + bex);
         }
       }

       bex.printStackTrace();
       fail( bex.toString() );
     }
     catch ( SQLException e )
     {
       e.printStackTrace();
       fail( e.toString() );
     }
  }


  public void test05ExceuteUpdate()
  {
    System.out.println( "Test EXECUTE UPDATE " );

     try
     {
       Collection c = Testdata.getIpcKlasseVOs();
       int[] resultarr = dao.executeUpdate(c);

       Iterator it = c.iterator();
       for (int i = 0; i < resultarr.length; i++)
       {
         assertEquals( 1, resultarr[i] );

         IpcKlasseVO vo = ( IpcKlasseVO ) it.next();
         dao.delete( vo.ipcKlasse );
       }
     }
     catch ( Exception e )
     {
       e.printStackTrace();
       fail( e.toString() );
     }
  }

}
