package ch.ige.ipcloadscheme.vo;

import java.io.Serializable;
import java.util.*;

/**
 * Value Object der Tabelle IPC_KLASSE
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: IpcKlasseVO.java,v 1.6 2006/12/19 16:19:52 ruegsegger Exp $
 */
public class IpcKlasseVO implements Serializable
{
  public String   ipcKlasse = null;
  public String   ipcBagis  = null;
  public int      dot = 0;
  public String   version = null;
  public String   textD = null;
  public String   textE = null;
  public String   textF = null;
  public String   textI = null;
  public String   elternklasse = null;

  public boolean  bild = false;
  public List     bildnamen = new ArrayList();


  public IpcKlasseVO()
  {
  }


  /**
   * Gibt den Inhalt des ValueObject IpcKlasseVO zurück
   * @return Inhalt von IpcKlasseVO
   */
  public String toString()
  {
    StringBuffer  buf = new StringBuffer();

    buf.append( "  ipcKlasse        = <" + this.ipcKlasse + ">\n" );
    buf.append( "  dot              = <" + this.dot + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );
    buf.append( "  textD            = <" + this.textD + ">\n" );
    buf.append( "  textE            = <" + this.textE + ">\n" );
    buf.append( "  textF            = <" + this.textF + ">\n" );
    buf.append( "  textI            = <" + this.textI + ">\n" );
    buf.append( "  elternklasse     = <" + this.elternklasse + ">\n" );
    buf.append( "  bild             = <" + this.bild + ">\n" );

    for (int i = 0; i < bildnamen.size(); i++)
    {
      buf.append( "  bildnamen        = <" + this.bildnamen.get(i) + ">\n" );
    }

    return buf.toString();
  }
}
