package ch.ige.ipcloadvalidity.client.download.test;


import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadvalidity.client.download.HTTPConnection;
import ch.ige.ipcloadvalidity.util.ValidityProperties;
import ch.ige.ipcloadvalidity.util.test.BasicTestCase;


/**
 * Testcase für Klasse HTTPConnection
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: HTTPConnectionTest.java,v 1.9 2007/01/09 13:11:26 ruegsegger Exp $
 */
public class HTTPConnectionTest extends BasicTestCase
{
  private HTTPConnection con = null;

  public HTTPConnectionTest(String s)
  {
    super(s);
  }

  public void setUp()
  {
    System.setProperty( ValidityProperties.HTTP_PROXY_HOST, "www-proxy.ipip.ch" );
    System.setProperty( ValidityProperties.HTTP_PROXY_PORT, "8080" );
    System.setProperty( ValidityProperties.HTTP_NON_PROXY, "*.ipip.ch|*.ipie.ch");
    System.setProperty( ValidityProperties.HTTP_USER, "chgst01" );
    System.setProperty( ValidityProperties.HTTP_PW, "clobterch" );

    con = new HTTPConnection();
  }


  public void testConnect()
  {
    try
    {
      String url = "http://www.wipo.int/classifications/ipc/en/download_area/20070101/xml/ipcr_validity_20070101_core_2006.zip";
      con.connect( url);
      String contentType = con.getContentType();

      con.checkResponseCode();

      assertTrue( contentType.equals("application/zip") );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }
  }
}
