package ch.ige.ipcloadvalidity.server;

import java.util.Date;

import ch.ige.ipcloadvalidity.vo.IpcVO;
import ch.ige.ipcloadvalidity.vo.TransferVO;
import ch.ige.util.ServiceLocator;


/**
 * Business Delegate für IpcLoadValidity
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rüegsegger
 * @version $Id: IpcValidityDelegate.java,v 1.17 2007/01/09 10:30:32 ruegsegger Exp $
 */

public class IpcValidityDelegate
{

  private static IpcValidityDelegate ipcValidityDelegate;
  private IpcValidityFacade facade;
  private static final Class HOME_CLASS = IpcValidityFacadeHome.class;


  // Singleton
  private IpcValidityDelegate() throws Exception
  {
    /** TODO schlaue meldung zurückgeben */
    IpcValidityFacadeHome home = (IpcValidityFacadeHome)
        ServiceLocator.getInstance().getHome("IpcValidityFacade", HOME_CLASS);
    facade = home.create();
  }

  /**
   * Gibt die einzige Instanz zurück (Singleton)
   * @return EpbandDelegate
   * @throws EpbandException
   */
  public static IpcValidityDelegate getInstance() throws Exception
  {
    if (ipcValidityDelegate == null)
    {
      ipcValidityDelegate = new IpcValidityDelegate();
    }
    return ipcValidityDelegate;
  }


  public TransferVO setIpc( final IpcVO ipcVO, final Date validTo ) throws Exception
  {
    return facade.setIpc( ipcVO, validTo );
  }


  public Integer setValidTo( IpcVO ipcVO ) throws Exception
  {
    return facade.setValidTo( ipcVO );
  }
}
