package ch.ige.ipcloadvalidity.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Statistik der Verarbeitung
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: StatistikVO.java,v 1.10 2007/01/09 10:30:32 ruegsegger Exp $
 */

public class StatistikVO implements Serializable
{
  public int inserts = 0;
  public int updateValidTo = 0;

//  public int terminates = 0;
//  public int exists = 0;

  public List terminatesSuceed = new ArrayList();

  public List insertsSuceed = new ArrayList();
  public List insertsExists = new ArrayList();
  public List insertsFailed = new ArrayList();

  public List updateValidToSuceed = new ArrayList();
  public List updateValidToExists = new ArrayList();
  public List updateValidToFailed = new ArrayList();


  public StatistikVO()
  {
  }


  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "Anzahl einzufügende IPC-Symbole:                   " + inserts        + "\n" );
    buf.append( "  Anzahl erfolgreich eingefügte IPC-Symbole:       " + insertsSuceed.size()        + "\n" );
    buf.append( "  Anzahl schon existierende IPC-Symbole:           " + insertsExists.size()        + "\n" );
    buf.append( "  Anzahl fehlerhafte einzufügende IPC-Symbole:     " + insertsFailed.size()        + "\n\n" );

    buf.append( "Anzahl automatisch beendete IPC-Symbole:           " + terminatesSuceed.size()     + "\n\n" );

    buf.append( "Anzahl abzuschliessende IPC-Symbole:               " + updateValidTo               + "\n" );
    buf.append( "  Anzahl erfolgreich abgesclossene IPC-Symbole:    " + updateValidToSuceed.size()  + "\n" );
    buf.append( "  Anzahl schon abgeschlossene IPC-Symbole:         " + updateValidToExists.size()  + "\n" );
    buf.append( "  Anzahl fehlerhafte abzuschliessende IPC-Symbole: " + updateValidToFailed.size()  + "\n\n" );

    buf.append( "\nFehlerhafte einzufügende IPC-Symbole: \n" );
    for (int i = 0; i < insertsFailed.size(); i++)
    {
      IpcVO vo = ( IpcVO ) insertsFailed.get( i );
      buf.append( vo.toString()  + "\n" );
    }

    buf.append( "\nFehlerhafte abzuschliessende IPC-Symbole: \n" );
    for (int i = 0; i < updateValidToFailed.size(); i++)
    {
      IpcVO vo = ( IpcVO ) updateValidToFailed.get( i );
      buf.append( vo.toString() + "\n" );
    }

    buf.append( "\nErfolgreich eingefügte IPC-Symbole: \n" );
    for (int i = 0; i < insertsSuceed.size(); i++)
    {
      buf.append( "\t" + insertsSuceed.get(i)  + "\n" );
    }

    buf.append( "\nExistierende IPC-Symbole: \n" );
    for (int i = 0; i < insertsExists.size(); i++)
    {
      buf.append( "\t" + insertsExists.get(i)  + "\n" );
    }

    buf.append( "\nAutomatisch beendete IPC-Symbole: \n" );
    for (int i = 0; i < terminatesSuceed.size(); i++)
    {
      buf.append( "\t" + terminatesSuceed.get(i)  + "\n" );
    }

    buf.append( "\nErfolgreich abgesclossene IPC-Symbole: \n" );
    for (int i = 0; i < updateValidToSuceed.size(); i++)
    {
      buf.append( "\t" + updateValidToSuceed.get(i)  + "\n" );
    }

    buf.append( "\nSchon abgeschlossene IPC-Symbole: \n" );
    for (int i = 0; i < updateValidToExists.size(); i++)
    {
      buf.append( "\t" + updateValidToExists.get(i)  + "\n" );
    }


    return buf.toString();
  }
}
