/*
 * Generated by XDoclet - Do not edit!
 */
package ch.ige.jipps;

/**
 * Remote interface for AmvTransactionManager.
 * @wtp generated
 */
public interface AmvTransactionManager
   extends javax.ejb.EJBObject
{
   /**
    * Erzeugt ein Value-Object für den Lauf
    * @param typCd String Typ-Code des Reports ( typCd = amv1 oder amv2 )
    * @return AmvLaufVO Value-Object
    */
   public ch.ige.jipps.vo.AmvLaufVO createAmvLauf( java.lang.String typCd )
      throws java.rmi.RemoteException;

   /**
    * Gibt das Value-Object des Laufes zurück.
    * @param amvLaufId int übergebene Lauf-Id die wiederholt wird
    * @return AmvLaufVO Value-Object
    */
   public ch.ige.jipps.vo.AmvLaufVO selectAMVLaufToId( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Liest die Daten aus der Bagis-Datenbank aus
    * @param amvLaufId int aktuelle AMV-Lauf-Nummer
    * @param typCd String Typ-Code des Reports ( typCd = amv1 oder amv2 )
    * @return List mit allen Daten (inkl. Pot-Zahler) die Verarbeitet werden
    */
   public java.util.List loadBagisDaten( int amvLaufId,java.lang.String typCd )
      throws java.rmi.RemoteException;

   /**
    * Liest die Daten aus der Tabelle AMV, für welche die Verarbeitung wiederholt wird.
    * @param amvLaufId int aktuelle AMV-Lauf-Nummer
    * @return List mit allen Daten (inkl. Pot-Zahler) die Verarbeitet werden
    */
   public java.util.List loadAMVDaten( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Gibt eine Liste mit den Value-Object der AMV-Daten zurück. Diese Methode wird verwendet, wenn ein Lauf wiederholt wird.
    * @param amvLaufId int AMV-Lauf-Nummer für die Wiederverarbeitung
    * @return List Liste mit allen AMV-Daten für die Wiederverarbeitung
    */
   public java.util.List selectAMVToId( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Fügt alle Daten die aus Bagis herausgelesen wurde in die JIPPS_AMV-Tabelle ein. Somit ist sichergestellt, dass alle Daten für die Verarbeitung dieses Laufes vorhanden sind
    * @param amvList List mit allen benötigten Daten für diesen Lauf
    * @return int Status
    */
   public boolean insertAmvDaten( java.util.List amvList )
      throws java.rmi.RemoteException;

   /**
    * Gibt eine List zurück mit allen Bfakt-Id's die in der Tabelle JIPPS_AMV für diesen Lauf enthalten sind. Im der Liste ist eine Bfakt-Id die mehrmals in der Tabelle vorkommt, nur einmal enthalten
    * @param amvLaufId int aktuelle AMV-Lauf-Nummer
    * @return List mit allen Bfakt-Id's die für den Update benötigt werden
    */
   public java.util.List selectAmvLaufBfaktIds( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Führt auf der Bagis-DB ein Update aus für die übergebene Bfakt-Id. Kann der Update nicht ausgeführt werden, wird eine Fehlermeldung in die JIPPS_AMV_ERROR-Tabelle geschrieben.
    * @param bfaktId int Bfakt-Id
    * @param statusDruck String Druck-Status auf BAGIS
    * @throws Exception Unerwarteter Fehler
    */
   public void updateBFakturDruckstatus( int bfaktId,java.lang.String statusDruck )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Im Fehlerfall bei einer AMV-Erinnerung wird die Fehlermeldung in die Tabelle JIPPS_AMV_ERROR geschrieben.
    * @param amvErrorVO AmvErrorVO Value-Object
    */
   public void insertErrorMsg( ch.ige.jipps.vo.AmvErrorVO amvErrorVO )
      throws java.rmi.RemoteException;

   /**
    * Im Fehlerfall bei einer AMV-Erinnerung wird die Fehlermeldung in die Tabelle JIPPS_AMV_ERROR geschrieben.
    * @param amvLaufId int AMV-Lauf-Nummer für die zu löschenden Einträge
    */
   public void deleteErrorMsg( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Updated das übergebene Value-Object auf der Tabelle JIPPS_AMV
    * @param amvVO AmvVO Value-Object
    */
   public void updateAMV( ch.ige.jipps.vo.AmvVO amvVO )
      throws java.rmi.RemoteException;

   /**
    * Updated die AMV-Daten auf der Tabelle JIPPS_AMV mit der übergebenen AMV-Lauf-Nummer.
    * @param amvLaufId int AMV-Lauf-Nummer für die zu updatenden Einträge
    */
   public void updateAMV( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Aktualisiert auf der Tabelle JIPPS_AMV_LAUF die Lauf-Daten und schliesst den ersten Schritt der Verarbeitung ab
    * @param amvLaufVO AmvLaufVO Value-Object
    * @return int Status
    */
   public boolean updateAmvLauf( ch.ige.jipps.vo.AmvLaufVO amvLaufVO )
      throws java.rmi.RemoteException;

   /**
    * Erzeugt den entsprechenden Controller für die Erzeugung des Reports
    * @param reportTyp String Reporttyp
    * @param printJobList List printJobList
    * @return byte[] ArryListe mit dem gerenderten Pdf
    * @throws Exception Unerwarteter Fehler
    */
   public byte[] createControl( java.lang.String reportTyp,java.util.List printJobList )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Überprüft ob der gestartete AMV-Lauf erfolgreich abgeschlossen werden kann.
    * @param amvLaufId int aktuelle AMV-Lauf-Nummer
    * @return boolean Status isLaufOk
    */
   public boolean selectCheckVerarbStat( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Mit dieser Methode wird eine Liste zrückgegeben, die alle AMV-Daten enthält die den Verarbeitungs-Status = 3 haben. Diese Methode wird für den Finish trotz fehlerhaften Reports verwendet.
    * @param amvLaufId int aktuelle AMV-Lauf-Nummer
    * @return List Liste mit allen erfolgreichen AMV-Daten
    */
   public java.util.List selectVerarbStatOk( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Mit dieser Methode wird eine Liste zurückgegeben, die alle AMV-Daten enthält die den Verarbeitungs-Status 0, 1 oder 2 haben. Diese Methode werden die fehlerhaften AMV-Daten ein weiteres mal Aufbereitet. Diese Methode wird für den Restart von fehlerhaften Reports verwendet.
    * @param amvLaufId int aktuelle AMV-Lauf-Nummer
    * @return List Liste mit den fehlerhaften AMV-Daten
    */
   public java.util.List selectVerarbStatNok( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Insert des Reports als PDF-Datei in die Tabelle JIPPS_AMV.
    * @param amvVO Value-Object mit den End-Werten
    */
   public void insertReportPdf( ch.ige.jipps.vo.AmvVO amvVO )
      throws java.rmi.RemoteException;

}
