package ch.ige.jipps;

import java.sql.Date;
import java.util.List;
import java.util.Map;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import ch.ige.jipps.vo.PrintJobVO;

/**
 * PdfStoreBean: Komponente zur Erstellung und Ausführung von IGE- Druckgut.
 * <p>
 * Copyright (c) 2002-2006, Eidgenössisches Institut für Geistiges Eigentum
 * @author    Johannes Lang, Marc Bouquet
 * @version   $Id: PrintJobStoreBean.java,v 1.71 2007/09/19 13:37:15 lang Exp $
 * 
 * @ejb.bean 
 *  name="PrintJobStore"  
 *  description="An EJB named PrintJobStore"
 *  display-name="PrintJobStore"
 *  view-type="local"
 *  jndi-name="PrintJobStore"
 *  type="Stateless"
 *  transaction-type="Container"
 *  local-business-interface="ch.ige.jipps.PrintJobStoreServices"
 * @ejb.home local-class="ch.ige.jipps.PrintJobStoreLocalHome"
 * @ejb.interface local-class="ch.ige.jipps.PrintJobStoreLocal"
 * @ejb.transaction type="RequiresNew"
 */
public class PrintJobStoreBean extends PrintJobStoreServicesImpl implements SessionBean
{
  private SessionContext sessionContext;

  public void ejbCreate()
  {
  }

  public void ejbRemove()
  {
  }

  public void ejbActivate()
  {
  }

  public void ejbPassivate()
  {
  }

  public void setSessionContext( SessionContext sessionContext )
  {
    this.sessionContext = sessionContext;
  }

  /**
   * @ejb.interface-method
   */
  public void insPrintJob( PrintJobVO printJobVO ) throws EJBException
  {
    super.insPrintJob( printJobVO );
  }

  /**
   * @ejb.interface-method
   */
  public PrintJobVO selectPrintJob( int printjob_Id ) throws EJBException
  {
    return super.selectPrintJob( printjob_Id );
  }

  /**
   * @ejb.interface-method
   */
  public void updPrintJob( List listPrintId, int status, int druckerId ) throws EJBException
  {
    super.updPrintJob( listPrintId, status, druckerId );
  }

  /**
   * @ejb.interface-method
   */
  public Integer deleteJobs( Date loeschDate )
  {
    return super.deleteJobs( loeschDate );
  }

  /**
   * @ejb.interface-method
   */
  public void deletePrintJobs( int batchId )
  {
    super.deletePrintJobs( batchId );
  }

  /**
   * TODO who uses this method??
   * @ejb.interface-method
   */
  public void deletePrintJob( int reportId, int batchId )
  {
    super.deletePrintJob( reportId, batchId );
  }

  /**
   * @ejb.interface-method
   */
  public int getNextBatchId() throws EJBException
  {
    return super.getNextBatchId();
  }

  /**
   * @ejb.interface-method
   */
  public int getNextPrintJobId() throws EJBException
  {
    return super.getNextPrintJobId();
  }

  /**
   * @ejb.interface-method
   */
  public List selectPrinter() throws EJBException
  {
    return super.selectPrinter();
  }

}
