package ch.ige.jipps.constants;

/**
 * Contains keys for Properties.
 *
 * <p>Copyright (c) 2006, Swiss Federal Institute of Intellectual Property</p>
 * @author   lewis_lee
 * @version  $Id: PropertyConstants.java,v 1.16 2008/03/26 17:01:59 lewis_lee Exp $
 */
public interface PropertyConstants
{

  /**
   * The system property for finding the temporary directory
   */
  public final static String JAVA_IO_TMPDIR = "java.io.tmpdir";

  /**
   * The system property for getting the operating system.
   */
  public final static String OS_NAME = "os.name";

  /**
   * The path where XSL files for FOP transformation can be found.
   */
  public final static String JIPPS_PATH_XSL = "path_xsl";

  /**
   * The property name for the path where the images which are converted by the ImageConverter are stored.
   */
  public final static String JIPPS_PATH_IMAGE = "path_image";

  /**
   * The property name for the tool to use to convert images, either
   * {@link ch.ige.jipps.imageconv.ImageProcessor#IMAGE_TOOL_IMAGEMAGICK} or
   * {@link ch.ige.jipps.imageconv.ImageProcessor#IMAGE_TOOL_JAI}
   */
  public final static String IMAGE_CONVERTER_TOOL = "image_converter_tool";

  /**
   * The property name for the path from where the tool Imagemagick can be called 
   */
  public final static String IMAGEMAGICK_PATH = "imagemagick_path";

  /**
   * The property name for the path from where the tool Imagemagick can be called 
   */
  public final static String IMAGE_CONVERTER_SERVLET_URL = "image_converter_url";

  /**
   * The property name for who receives the error message by e-mail
   */
  public final static String ERROR_RECEIVER = "error_receiver";

  /**
   * The property name for who receives the error message by e-mail as cc
   */
  public final static String ERROR_RECEIVER_CC = "error_receiverCC";

  /**
   * Part of the property name of who receives an e-mail
   */
  public static final String RECEIVER = "_receiver";

  /**
   * Part of the property name of who receives an e-mail as cc
   */
  public static final String RECEIVER_CC = "_receiverCC";

  /**
   * Part of the property name of a path
   */
  public static final String PATH = "_path";

  /**
   * Part of the property name of a printer
   */
  public static final String PRINTER = "_drucker";

  /**
   * The property name for the printjob delete peri
   */
  public static final String PRINTJOB_DEL_PERI = "printjob_loesch_peri";

  /**
   * The property name for the amv-printjob delete peri
   */
  public static final String PRINTJOB_AMV_DEL_PERI = "printjob_amv_loesch_peri";

  /**
   * If this System Property exists, the mail for the result of a batch
   * job is written into the log instead of being sent as a real mail.
   */
  public final static String BATCH_MAIL_RESULT = "batch_mail_result";

  /**
   * The porperty name for the host where the imagehandler runs
   */
  public final static String IMAGEHANDLER_URL_HOST = "imagehandler_url_host";

  /**
   * The property name for the port where the imagehandler runs
   */
  public final static String IMAGEHANDLER_URL_PORT = "imagehandler_url_port";

}
