package ch.ige.jipps.constants.test;

import junit.framework.TestCase;
import ch.ige.jipps.constants.LetterTypeConstants;

/**
 * Tests {@link ch.ige.jipps.constants.LetterTypeConstants}.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: LetterTypeConstantsTest.java,v 1.8 2008/12/11 15:54:26 bandschapp Exp $
 */
public class LetterTypeConstantsTest extends TestCase
{
  /**
   * The only constructor.
   * @param name The test's name
   */
  public LetterTypeConstantsTest( String name )
  {
    super( name );
  }

  /**
   * Tests {@link ch.ige.jipps.constants.LetterTypeConstants#isTrademarkApplicationConfirmation(String)}.
   */
  public void testIsTrademarkApplicationConfirmation()
  {
    assertTrue( LetterTypeConstants.APPLICATION_CONFIRMATION_422 + " is application confirmation", LetterTypeConstants
        .isTrademarkApplicationConfirmation( LetterTypeConstants.APPLICATION_CONFIRMATION_422 ) );

    assertTrue( LetterTypeConstants.APPLICATION_CONFIRMATION_462 + " is application confirmation", LetterTypeConstants
        .isTrademarkApplicationConfirmation( LetterTypeConstants.APPLICATION_CONFIRMATION_462 ) );

    assertTrue( LetterTypeConstants.APPLICATION_CONFIRMATION_485 + " is application confirmation", LetterTypeConstants
        .isTrademarkApplicationConfirmation( LetterTypeConstants.APPLICATION_CONFIRMATION_485 ) );

    assertTrue( LetterTypeConstants.APPLICATION_CONFIRMATION_441 + " is application confirmation", LetterTypeConstants
        .isTrademarkApplicationConfirmation( LetterTypeConstants.APPLICATION_CONFIRMATION_441 ) );

    String fault = "486";
    assertTrue( fault + " is application confirmation", !LetterTypeConstants.isTrademarkApplicationConfirmation( fault ) );
  }

  /**
   * Tests {@link ch.ige.jipps.constants.LetterTypeConstants#isTrademarkPublicationConfirmation(int)}.
   */
  public void testIsTrademarkPublicationConfirmation()
  {
    assertTrue( LetterTypeConstants.PUBLICATION_CONFIRMATION_416 + " is publication confirmation", LetterTypeConstants
        .isTrademarkPublicationConfirmation( LetterTypeConstants.PUBLICATION_CONFIRMATION_416_INTEGER ) );

    assertTrue( LetterTypeConstants.PUBLICATION_CONFIRMATION_417 + " is publication confirmation", LetterTypeConstants
        .isTrademarkPublicationConfirmation( LetterTypeConstants.PUBLICATION_CONFIRMATION_417_INTEGER ) );

    Integer fault = 486;
    assertTrue( fault + " is application confirmation", !LetterTypeConstants.isTrademarkPublicationConfirmation( fault ) );
  }
}
