package ch.ige.jipps.dao.test;

import java.util.List;

import ch.ige.dbutils.dao.test.BaseDAOTestTemplate;
import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.jipps.dao.PotZahlDAO;

/**
 * Tests {@link ch.ige.jipps.dao.PotZahlDAO}.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: PotZahlDAOTest.java,v 1.2 2007/04/30 15:24:14 lewis_lee Exp $
 */
public class PotZahlDAOTest extends BaseDAOTestTemplate<PotZahlDAO, AbstractVO>
{
  /**
   * The only constructor
   * @param name The test's name
   */
  public PotZahlDAOTest( String name )
  {
    super( name );
  }

  /**
   * Tests {@link ch.ige.jipps.dao.PotZahlDAO#select(int)}.
   * @throws Exception if the test fails
   */
  public void testSelect() throws Exception
  {
    List<Integer> addressNumbers = getDAO().select( 999 );
    assertEquals( "Checking unknown invoice", 0, addressNumbers.size() );

    addressNumbers = getDAO().select( 5474447 );
    assertEquals( "Checking unknown invoice", 1, addressNumbers.size() );
    assertEquals( "Checking known invoice", 500446, addressNumbers.get( 0 ).intValue() );
  }

  // @see ch.ige.dbutils.dao.test.BaseDAOTestTemplate#getDAOClass()
  @Override
  protected Class<PotZahlDAO> getDAOClass()
  {
    return PotZahlDAO.class;
  }

  // @see ch.ige.dbutils.dao.test.BaseDAOTestTemplate#assertVOEqual(ch.ige.dbutils.vo.AbstractVO, ch.ige.dbutils.vo.AbstractVO)
  @Override
  @SuppressWarnings("unused")
  protected boolean assertVOEqual( AbstractVO originalVO, AbstractVO serializedVO )
  {
    // Nothing to do
    return true;
  }

  // @see ch.ige.dbutils.dao.test.BaseDAOTestTemplate#getSerializableVO()
  @Override
  protected AbstractVO getSerializableVO()
  {
    // Nothing to do
    return null;
  }
}
