package ch.ige.jipps.exception;

/**
 * This is used when a printer should be deleted, but is still referenced by another part of the system,
 * for instance in printjobs or in JIPPS properties.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: PrinterReferencedException.java,v 1.1 2007/02/27 14:58:14 lewis_lee Exp $
 */
public class PrinterReferencedException extends RuntimeException
{

  /**
   * @see RuntimeException#RuntimeException()
   */
  public PrinterReferencedException()
  {
    super();
  }

  /**
   * @see RuntimeException#RuntimeException(String)
   */
  public PrinterReferencedException( String message )
  {
    super( message );
  }

  /**
   * @see RuntimeException#RuntimeException(Throwable)
   */
  public PrinterReferencedException( Throwable cause )
  {
    super( cause );
  }

  /**
   * @see RuntimeException#RuntimeException(String, Throwable)
   */
  public PrinterReferencedException( String message, Throwable cause )
  {
    super( message, cause );
  }
}
