package ch.ige.jipps.ftp.web.util;

import ch.ige.dbutils.vo.VO;
import ch.ige.dbutils.vo.ConfigurationTable.SerializableConfiguration;

public class EPAUploadClientConfigWrapper implements VO
{

  private SerializableConfiguration configuration;

  public EPAUploadClientConfigWrapper( SerializableConfiguration table )
  {
    this.configuration = table;
  }

  public String getPathToComfiles()
  {
    return this.configuration.getString( "path_comfiles" );
  }

  public String getFTPServletUrl()
  {
    return this.configuration.getString( "ftp_servlet_url" );
  }

  public String getPathToResultFiles()
  {
    return this.configuration.getString( "path_resultfiles" );
  }

  public String getPathToResultFilesCopy()
  {
    return this.configuration.getString( "path_resultfiles_copy" );
  }

  public String getPathToCleanupData()
  {
    return this.configuration.getString( "path_cleanup" );
  }

  public String getCmdFileExtension()
  {
    return this.configuration.getString( "cmd_file_ext" );
  }

  public String getFTPDestination()
  {
    return this.configuration.getString( "ftp_destination" );
  }

  public String getBatchExecutionPath()
  {
    return this.configuration.getString( "path_execution" );
  }

  public boolean uploadBiblioData()
  {
    return this.configuration.getBoolean( "upload_biblio" );
  }

  public String getMailSender()
  {
    return this.configuration.getString( "mail_sender" );
  }

  public String getMailDestination()
  {
    return this.configuration.getString( "mail_destination" );
  }

  public String getMailDestinationCC()
  {
    return this.configuration.getString( "mail_destinationCC" );
  }

  public String getMailDestinationISO()
  {
    return this.configuration.getString( "mail_destinationISO" );
  }

  public String getMailSenderEPA()
  {
    return this.configuration.getString( "mail_epa_sender" );
  }

  public String getMailDestinationEPA()
  {
    return this.configuration.getString( "mail_epa_destination" );
  }

  public String getMailDestinationEPACC()
  {
    return this.configuration.getString( "mail_epa_destinationCC" );
  }

  public String getMailDestinationEPAISO()
  {
    return this.configuration.getString( "mail_epa_destinationISO" );
  }

  public String getMailServer()
  {
    return this.configuration.getString( "smtp_server" );
  }

  public static EPAUploadClientConfigWrapper fromConfiguration( SerializableConfiguration table )
  {
    return new EPAUploadClientConfigWrapper( table );
  }

}
