package ch.ige.jipps.history;

/**
 * One element (text block) on the history of the report.
 *
 * <p>Copyright (c) 2006, Swiss Federal Institute of Intellectual Property</p>
 * @author    Eric Lewis
 * @version   $Id: HistoryItem.java,v 1.2 2006/07/06 16:26:19 lewis_lee Exp $
 */
public interface HistoryItem
{
  /**
   * Gets the formatted start date.
   * @return The formatted start date in the format <code>dd.MM.yyyy</code>
   */
  public String getStartDate();

  /**
   * Sets the formatted start date.
   * @param startDate The formatted start date in the format <code>dd.MM.yyyy</code>
   */
  public void setStartDate( String startDate );

  /**
   * Gets the label for {@link #getEndDate()}, for instance <code>valid to:</code>.
   * @return The label for the formatted end date
   */
  public String getEndDateLabel();

  /**
   * Sets the label for {@link #getEndDate()}, for instance <code>valid to:</code>.
   * @param endDateLabel The label for the formatted end date
   */
  public void setEndDateLabel( String endDateLabel );

  /**
   * Gets the formatted end date.
   * @return The formatted end date in the format <code>dd.MM.yyyy</code>
   */
  public String getEndDate();

  /**
   * Sets the formatted end date.
   * @param endDate The formatted end date in the format <code>dd.MM.yyyy</code>
   */
  public void setEndDate( String endDate );

  /**
   * Gets the information when this was published.
   * @return The information when this was published
   */
  public String getPublication();

  /**
   * Sets the information when this was published.
   * @param publication The information when this was published
   */
  public void setPublication( String publication );

  /**
   * Gets the remarks, like <code>tentative data</code>.
   * @return The remarks
   */
  public String getRemarks();

  /**
   * Sets the remarks, like <code>tentative data</code>.
   * @param remarks The remarks
   */
  public void setRemarks( String remarks );
}
