package ch.ige.jipps.snapshot;

import java.util.HashMap;
import java.util.Map;

import ch.ige.ipobjects.common.vo.ImageVO;

/**
 * Contains the snapshot for an IP.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: SnapshotVO.java,v 1.3 2007/04/02 16:06:25 lewis_lee Exp $
 */
public class SnapshotVO
{
  /**
   * The snapshot's title
   */
  private String title;
  
  /**
   * The XML snapshot document
   */
  private String xml;
  
  /**
   * The referenced images
   */
  private Map<Integer, ImageVO> images;

  /**
   * Creates this and initializes the <code>Map</code>s
   *
   */
  public SnapshotVO()
  {
    this.images = new HashMap<Integer, ImageVO>();
  }

  /**
   * Gets the title.
   * @return the title
   */
  public String getTitle()
  {
    return this.title;
  }

  /**
   * Sets the title.
   * @param title The title to set
   */
  public void setTitle( String title )
  {
    this.title = title;
  }

  /**
   * Gets the XML snapshot document.
   * @return the XML snapshot document
   */
  public String getXml()
  {
    return this.xml;
  }

  /**
   * Sets the XML snapshot document.
   * @param xml The XML snapshot document
   */
  public void setXml( String xml )
  {
    this.xml = xml;
  }

  /**
   * Gets the images which are referenced in {@link #getXml()}.
   * @return All referenced images, where the image number is the key, and the corresponding images are the value
   */
  public Map<Integer, ImageVO> getImages()
  {
    return this.images;
  }

  /**
   * Sets the images.
   * @param images All referenced images, where the image number is the key, and the corresponding images are the value
   */
  public void setImages( Map<Integer, ImageVO> images )
  {
    this.images = images;
  }
}
