package ch.ige.jipps.test;

import java.util.Random;

import junit.framework.TestCase;
import ch.ige.jipps.LoeschungControl;

/**
 * Tests {@link ch.ige.jipps.LoeschungControl}.
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * 
 * @author Marc Bouquet
 * @author lewis_lee
 * @version $Id: LoeschungControlTest.java,v 1.8 2007/06/06 07:38:12 lewis_lee Exp $
 */
public class LoeschungControlTest extends TestCase
{
  /**
   * The default constructor
   * 
   * @param args Any paramters
   */
  public LoeschungControlTest( String args )
  {
    super( args );
  }

  /**
   * Checks whether the print job is valid.
   */
  public void testIsPrintJobVOValid()
  {
    LoeschungControl loeschungControl = new LoeschungControl();

    assertEquals( "Checking null print job", false, loeschungControl.isPrintJobVOValid( null ) );
    assertEquals( "Checking empty print job", false, loeschungControl.isPrintJobVOValid( new byte[] {} ) );

    Random random = new Random();
    
    byte[] randomBytes = new byte[1];
    randomBytes[0] = 33;
    assertEquals( "Checking with 1 byte", false, loeschungControl.isPrintJobVOValid( randomBytes ) );
    
    randomBytes = new byte[499];
    random.nextBytes( randomBytes );
    assertEquals( "Checking with 499 bytes", false, loeschungControl.isPrintJobVOValid( randomBytes ) );
    
    randomBytes = new byte[500];
    random.nextBytes( randomBytes );
    assertEquals( "Checking with 500 bytes", true, loeschungControl.isPrintJobVOValid( randomBytes ) );
    
    randomBytes = new byte[501];
    random.nextBytes( randomBytes );
    assertEquals( "Checking with 501 bytes", true, loeschungControl.isPrintJobVOValid( randomBytes ) );
  }
}