package ch.ige.jipps.text;

import ch.ige.util.server.replace.P2d2;

/**
 * Contains all used {@link P2d2} tags.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   lewis_lee
 * @version  $Id: P2d2Tags.java,v 1.2 2008/07/21 12:34:25 lewis_lee Exp $
 */
public interface P2d2Tags
{
  /**
   * The letter title.
   */
  public static final String TITEL = P2d2.TAG_PREFIX + "Titel";

  /**
   * The number of &quot;articles&quot;.
   */
  public static final String ANZAHL = P2d2.TAG_PREFIX + "Anzahl";

  /**
   * The IP number.
   */
  public static final String SCHUTIT = P2d2.TAG_PREFIX + "Schutit";

  /**
   * The price of the &quot;article&quot;.
   */
  public static final String PREIS = P2d2.TAG_PREFIX + "Preis";

  /**
   * The value of the line item, {@link #ANZAHL} * {@link #PREIS}.
   */
  public static final String WERT = P2d2.TAG_PREFIX + "Wert";

  /**
   * The total amount to pay for the invoice. 
   */
  public static final String TOTAL = P2d2.TAG_PREFIX + "Total";

  /**
   * The event date.
   */
  public static final String EREIG_DAT = P2d2.TAG_PREFIX + "EreigDat";

  /**
   * The payment due date.
   */
  public static final String FRIST = P2d2.TAG_PREFIX + "Frist";

  /**
   * The IP's owner.
  */
  public static final String INHABER = P2d2.TAG_PREFIX + "Inhaber";

  /**
   * The application number.
   */
  public static final String GESUCH = P2d2.TAG_PREFIX + "Gesuch";

  /**
   * The protection start.
   */
  public static final String SCHUTZB = P2d2.TAG_PREFIX + "Schutzb";

  /**
   * The protection end.
   */
  public static final String SCHUTZENDE = P2d2.TAG_PREFIX + "Schutzende";

  /**
   * The date when the invoice must be paid.
   */
  public static final String VERFALL = P2d2.TAG_PREFIX + "Verfall";

  /**
   * The publication date.
   */
  public static final String PUBL_DAT = P2d2.TAG_PREFIX + "PublDat";

  /**
   * An optional publication text.
   */
  public static final String PUBL_TEXT = P2d2.TAG_PREFIX + "PublText";

  /**
   * Some variable text.
   */
  public static final String TEXT = P2d2.TAG_PREFIX + "Text";

  /**
   * The WDL within the text. 
   */
  public static final String WDL = P2d2.TAG_PREFIX + "WDL";

  /**
   * The end of the WDL within the text. 
   */
  public static final String WDL_END = ConvertText.P2D2_TAG_SUFFIX + "WDL";

  /**
   * An ending text. 
   */
  //TODO Why the #?
  public static final String DIVERS = P2d2.TAG_PREFIX + "Divers" + "#";

  /**
   * The signature that ends the letter.
  */
  public static final String UNTERSCH = P2d2.TAG_PREFIX + "Untersch";
}
