package ch.ige.jipps.text;

/**
 * Contains a report text which can be loaded and inserted back into this.
 *
 * <p>Copyright (c) 2006, Swiss Federal Institute of Intellectual Property</p>
 * @author    Eric Lewis
 * @version   $Id: ReportTextContainer.java,v 1.2 2006/07/06 12:23:29 lewis_lee Exp $
 */
public interface ReportTextContainer
{
  /**
   * Gets the number of the report text to load.
   * @return the number of the report text to load
   */
  public Integer getReportTextNumber();

  /**
   * Sets the report text number.
   * @param reportTextNumber The report text number
   */
  public void setReportTextNumber( Integer reportTextNumber );

  /**
   * Gets the report text.
   * @return The report text
   */
  public String getReportText();

  /**
   * Sets the report text.
   * @param reportText The report text
   */
  public void setReportText( String reportText );
}
