package ch.ige.jipps.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.util.vo.VersadrVO;

/**
 * ValueObject für die Schreiben. Im LetterVO werden alle Value-Objects für die Schreiben zusammengefasst. Somit ist das
 * LetterVO das Master-Value-Object.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * 
 * @author Marc Bouquet
 * @version $Id: LetterVO.java,v 1.36 2008/07/23 15:18:56 lewis_lee Exp $
 */
public class LetterVO extends AbstractVO implements Serializable
{
  public JippsFakturVO jippsFakturVO;

  public VersadrVO versadrVO;

  public List<JippsFaktPosVO> jippsFaktPositionen;

  public List<FormTextVO> formTexte;

  public List<BFormTxtDruckVO> bformTexte;

  public List<BfakTxtVO> bfakTexte;

  public List<BfakTxtVO> bfakTextePotZahl;

  public boolean printIgekopf = false;

  public byte[] bild = null;

  public String bildTyp = "";

  /**
   * Konstruktor
   */
  public LetterVO()
  {
    this.jippsFakturVO = new JippsFakturVO();
    this.jippsFaktPositionen = new ArrayList();
    this.formTexte = new ArrayList();
    this.bformTexte = new ArrayList();
    this.bfakTexte = new ArrayList();
    this.bfakTextePotZahl = new ArrayList();
    this.versadrVO = new VersadrVO();
  }
}
