package ch.ige.jipps.vo;

import java.sql.Date;

import ch.ige.dbutils.vo.AbstractVO;

/**
 * Contains search criteria used to search for print jobs.
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Marc Bouquet
 * @version $Id: PrintjobSearchVO.java,v 1.11 2007/05/01 13:20:37 lewis_lee Exp $
 */
public class PrintjobSearchVO extends AbstractVO
{
  //TODO Rename this to PrintJobSearchVO

  /**
   * When not searching for a print status, use this value.
   */
  public static final int DUMMY_PRINT_STATUS = 99;

  /**
   * When not searching for a batch ID, use this value.
   */
  public static final int DUMMY_BATCH_ID = -1;
  
  /**
   * The unique identifier of a print job.
   */
  public int printjobId = 0;

  /**
   * The unique identifier of a report.
   */
  public int reportId = 0;

  /**
   * The unique identifier of a batch run; use
   * {@link #DUMMY_BATCH_ID} when not searching for a batch ID.
   */
  //TODO Initialize with DUMMY_BATCH_ID, but check the implications!
  public int batchId = 0;

  /**
   * The unique identifier of a printer.
   */
  public int druckerId = 0;

  /**
   * The print status, which can be
   * <ul>
   * <li>{@link #DUMMY_PRINT_STATUS}</li>
   * <li>{@link ch.ige.util.constants.PrintStatusConstants#PREVIEW_PRINT}</li>
   * <li>{@link ch.ige.util.constants.PrintStatusConstants#READY_FOR_PRINTING}</li>
   * <li>{@link ch.ige.util.constants.PrintStatusConstants#PRINTED}</li>
   * </ul>
   */
  //TODO Initialize with DUMMY_PRINT_STATUS, but check the implications!
  public int druckStatus = 0;

  /**
   * The user who created the print job.
   * May also be {@link ch.ige.jipps.vo.PrintJobVO#SYSTEM}.
   */
  public String sender = null;

  /**
   * The print job type. See below for possible values.
   * @see ch.ige.jipps.vo.PrintJobVO#formTyp
   */
  public String formtyp = null;

  /**
   * The creation date of the print job
   */
  public Date erstDat = null;

  /**
   * If this is <code>true</code>, the print job contains a cover page.
   */
  public boolean coverCd = false;
}
