package ch.ige.pctedi.client.wpa.test;

import java.io.FileInputStream;

import ch.ige.pctedi.client.XMLDoc;
import ch.ige.pctedi.client.test.ClientTestCase;
import ch.ige.pctedi.client.wpa.Pat;
import ch.ige.pctedi.vo.PatVO;

/**
 * junit test of class Pat
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: TestPat.java,v 1.10 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class TestPat extends ClientTestCase
{
  private XMLDoc xml;

  private Pat pat = new Pat();

  private String filename = "C:\\jp\\projects\\pctedi\\testfiles\\wpa_GB0403434_17022005.xml";

  public TestPat( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      FileInputStream fi = new FileInputStream( filename );
      xml = new XMLDoc( fi );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void test00()
  {
    try
    {
      PatVO patVO = pat.extract( xml );

      assertEquals( PatVO.CH_EURO_PCT, patVO.patVerfahr );
      assertEquals( "GB2004003434", patVO.pctAnmNr );
      assertEquals( "en", patVO.pctAnmSpra );
      assertEquals( "2005014154", patVO.pctPublNr );
      assertEquals( "en", patVO.pctPublSpra );
      assertEquals( sdf.parse( "20050217" ), patVO.pctPublDat );

      // nicht durch das Programm abgefüllte Attribute (Initialwerte)
      assertEquals( 0, patVO.schutitKey );
      assertNull( patVO.stammgesNr );
      assertNull( patVO.hauptpatNr );
      assertNull( patVO.altpatNr );
      assertNull( patVO.ausstellDat );
      assertNull( patVO.ausstellName );
      assertNull( patVO.iksDat );
      assertNull( patVO.iksBez );
      assertNull( patVO.iksNr );
      assertNull( patVO.spcNr );
      assertNull( patVO.epAnmSpra );
      assertNull( patVO.epApublSpra );
      assertNull( patVO.epApublDat );
      assertNull( patVO.epBpublSpra );
      assertNull( patVO.epBpublDat );
      assertNull( patVO.epStammpatNr );
      assertNull( patVO.indexIpc );
      assertEquals( 0, patVO.version );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

}
