package ch.ige.pctedi.client.wpa.test;

import java.io.FileInputStream;
import java.util.List;

import ch.ige.pctedi.client.XMLDoc;
import ch.ige.pctedi.client.test.ClientTestCase;
import ch.ige.pctedi.client.wpa.PctAdr;
import ch.ige.pctedi.client.wpa.WpaLogFile;
import ch.ige.pctedi.vo.PctAdrVO;

/**
 * junit test of class PctAdr
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: TestPctAdr.java,v 1.12 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class TestPctAdr extends ClientTestCase
{
  private PctAdr pctAdr;

  private XMLDoc xml;

  private String filename = "C:\\jp\\projects\\pctedi\\testfiles\\wpa_parties.xml";

  public TestPctAdr( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      FileInputStream fi = new FileInputStream( filename );
      xml = new XMLDoc( fi );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    WpaLogFile.getInstance().writeMessage();
  }

  public void test00()
  {
    PctAdrVO vo = new PctAdrVO();

    try
    {
      pctAdr = new PctAdr();
      List<PctAdrVO> listPctAdrVO = pctAdr.extract( xml );

      if ( listPctAdrVO.size() > 0 )
      {
        vo = listPctAdrVO.get( 0 );
        assertEquals( 1, vo.pctAdrLnr );
        assertEquals( "GB", vo.blandCd );
        assertEquals( 1, vo.adrRolleCd );
        assertEquals( "LOOTS LIMITED", vo.pctName );
        assertEquals( "PO BOX 293, GRANITE HOUSE, LA GRANDE RUE, ST MARTIN GUERNSEY GY1 3RS", vo.pctAdresse );

        vo = listPctAdrVO.get( 1 );
        assertEquals( 2, vo.pctAdrLnr );
        assertEquals( "GB", vo.blandCd );
        assertEquals( 4, vo.adrRolleCd );
        assertEquals( "LOOTS LIMITED", vo.pctName );
        assertEquals( "PO BOX 293, GRANITE HOUSE, LA GRANDE RUE, ST MARTIN GUERNSEY GY1 3RS", vo.pctAdresse );

        vo = listPctAdrVO.get( 2 );
        assertEquals( 3, vo.pctAdrLnr );
        assertEquals( "GB", vo.blandCd );
        assertEquals( 4, vo.adrRolleCd );
        assertEquals( "O'NEILL, IAN", vo.pctName );
        assertEquals( "5 RED HILL CLOSE, GREAT SHELFORD, CAMBRIDGE Cambridgeshire CB2 5JP", vo.pctAdresse );

        vo = listPctAdrVO.get( 3 );
        assertEquals( 4, vo.pctAdrLnr );
        assertEquals( "CA", vo.blandCd );
        assertEquals( 4, vo.adrRolleCd );
        assertEquals( "YANG, Qu'anmin", vo.pctName );
        assertEquals( "1677 Sir Monty's Drive, Mississauga, Ontario L5N 4R4", vo.pctAdresse );

        vo = listPctAdrVO.get( 4 );
        assertEquals( 5, vo.pctAdrLnr );
        assertEquals( "CA", vo.blandCd );
        assertEquals( 4, vo.adrRolleCd );
        assertEquals( "Markus Wild", vo.pctName );
        assertEquals( "Adresszeile 1 Adresszeile 2 Adresszeile 3 Adresszeile 4 Adresszeile 5 ", vo.pctAdresse );

        vo = listPctAdrVO.get( 5 );
        assertEquals( 6, vo.pctAdrLnr );
        assertEquals( "XX", vo.blandCd );
        assertEquals( 4, vo.adrRolleCd );
        assertEquals( "FRANKLIN, Benjamin", vo.pctName );
        assertEquals( "verstorben", vo.pctAdresse );
      }
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
