package ch.ige.pctedi.client.wpa.test;

import java.io.FileInputStream;

import ch.ige.pctedi.client.XMLDoc;
import ch.ige.pctedi.client.test.ClientTestCase;
import ch.ige.pctedi.client.wpa.Schutit;
import ch.ige.pctedi.client.wpa.WpaLogFile;
import ch.ige.pctedi.vo.SchutitVO;

/**
 * junit test of class Schutit
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: TestSchutit.java,v 1.14 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class TestSchutit extends ClientTestCase
{
  private XMLDoc xml;

  private String filename = "C:\\jp\\projects\\pctedi\\testfiles\\wpa_GB0403434_17022005.xml";

  public TestSchutit( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      FileInputStream fi = new FileInputStream( filename );
      xml = new XMLDoc( fi );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    WpaLogFile.getInstance().writeMessage();
  }

  public void test00()
  {
    Schutit schutit = new Schutit();

    try
    {
      SchutitVO schutitVO = schutit.extract( xml );

      assertEquals( 0, schutitVO.schutitKey );
      assertEquals( 199, schutitVO.maNr.intValue() );

      assertEquals( 3, schutitVO.schutitTyp );
      assertEquals( 4, schutitVO.sprache );
      assertEquals( "GB2004003434", schutitVO.gesuchNr );
      assertEquals( "2005014154", schutitVO.schutitNr );
      assertEquals( 0, schutitVO.registerKz );

      assertEquals( sdf.parse( "20040809" ), schutitVO.schutzBegin );
      assertEquals( sdf.parse( "20240808" ), schutitVO.schutzEnde );
      assertNull( schutitVO.loeschDat );

      assertEquals( "PROCEDE ET D'ISPOSITIF DE SEPARATION de la MATIERE CELLULAIRE DES MATIERES FECALES ET RECIPIENT DE COLLECTE DE MATIERES FECALES",
          schutitVO.beschreibung );
      assertEquals( "PROCEDE ET D'ISPOSITIF DE SEPARATION DE LA MATIERE CELLULAIRE DES MATIERES FECALES ET RECIPIENT DE COLLECTE DE MATIERES FECALES",
          schutitVO.uppBeschreibung );
      assertNull( schutitVO.ihrZeichen );
      assertEquals( 0, schutitVO.dossierBeachten );
      assertNull( schutitVO.internBem );
      assertEquals( 0, schutitVO.kzUeberwach );
      assertEquals( 199, schutitVO.erfassMa );
      assertNull( schutitVO.erfassDat );
      assertNull( schutitVO.mutDat );
      assertEquals( sdf.parse( "20040809" ), schutitVO.erstEreigDat );
      assertNull( schutitVO.mutMa );
      assertEquals( 2300, schutitVO.faelligJahr );
      assertEquals( 0, schutitVO.version );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
