package ch.ige.pctedi.server.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import ch.ige.util.log.LogLevelHelper;
import ch.ige.util.server.DBHelper;

/**
 * DataAccessObject für BLAND
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author Martin Trachsel
 * @version $Id: BlandDAO.java,v 1.10 2008/03/11 14:11:01 ruegsegger Exp $
 */

public class BlandDAO
{
  /**
   * Liest alle BLänder aus BLAND
   *
   * @return  BlandWorkAVO
   * @exception SQLException
   */

  public List<String> getAllBland() throws SQLException
  {
    Connection con = null;
    PreparedStatement ps = null;
    String query = null;
    ResultSet rs = null;
    List<String> blandWork = new ArrayList<String>( 200 );

    try
    {
      con = DBHelper.getConnection( DBHelper.BAGIS );

      query = "SELECT trim(bland_cd) bland_cd " + "FROM bland " + "ORDER BY 1 ";
      ps = con.prepareStatement( query );
      rs = ps.executeQuery();

      while ( rs.next() )
      {
        blandWork.add( rs.getString( "bland_cd" ) );
      }
    }
    catch ( SQLException ex )
    {
      LogLevelHelper.log( ex, BlandDAO.class, query );
      throw ex;
    }
    finally
    {
      DBHelper.close( ps, con );
    }
    return blandWork;
  }
}
