package ch.ige.pctedi.server.dao.test;

import ch.ige.pctedi.server.dao.PatDAO;
import ch.ige.pctedi.server.dao.PctAdrDAO;
import ch.ige.pctedi.server.dao.SchutitDAO;
import ch.ige.pctedi.vo.PatVO;
import ch.ige.pctedi.vo.PctAdrVO;
import ch.ige.pctedi.vo.SchutitVO;
import ch.ige.pctedi.vo.test.Testdata;

/**
 * Junit-Test Klasse PctAdr
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: PctAdrDAOTest.java,v 1.5 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class PctAdrDAOTest extends DAOTestCase
{
  private SchutitDAO schutitDAO = new SchutitDAO();

  private PatDAO patDAO = new PatDAO();

  private SchutitVO schutitVO;

  private PatVO patVO;

  public PctAdrDAOTest( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      patVO = Testdata.createPat();
      schutitDAO.insert( schutitVO );
      patDAO.insert( patVO );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    try
    {
      schutitDAO.deleteSchutit( schutitVO.schutitKey );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void test00Insert()
  {
    PctAdrDAO pctAdrDAO = new PctAdrDAO();
    PctAdrVO vo;

    try
    {
      vo = Testdata.createPctAdr();
      int ret = pctAdrDAO.insert( vo );
      assertEquals( 1, ret );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
