package ch.ige.pctedi.server.dao.test;

import ch.ige.pctedi.server.dao.PrioritaetDAO;
import ch.ige.pctedi.server.dao.SchutitDAO;
import ch.ige.pctedi.vo.PrioritaetVO;
import ch.ige.pctedi.vo.SchutitVO;
import ch.ige.pctedi.vo.test.Testdata;

/**
 * Junit-Test Klasse Prioritaet
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: PrioritaetDAOTest.java,v 1.5 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class PrioritaetDAOTest extends DAOTestCase
{
  private SchutitDAO schutitDAO = new SchutitDAO();

  private SchutitVO schutitVO;

  public PrioritaetDAOTest( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      schutitDAO.insert( schutitVO );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    try
    {
      schutitDAO.deleteSchutit( schutitVO.schutitKey );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void test00Insert()
  {
    PrioritaetDAO prioritaetDAO = new PrioritaetDAO();
    PrioritaetVO vo;

    try
    {
      vo = Testdata.createPrioritaet();
      int ret = prioritaetDAO.insert( vo );
      assertEquals( 1, ret );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
