package ch.ige.pctedi.vo;

import java.io.Serializable;
import java.util.Date;

/**
 * value object for table PAT
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PatVO.java,v 1.8 2008/07/01 07:43:05 kuenzli Exp $
 */
public class PatVO implements Serializable
{
  /**
   * Default id.
   */
  private static final long serialVersionUID = 1L;
  public static final int EURO_PCT = 3;

  public static final int CH_PCT = 4;

  public static final int CH_EURO_PCT = 5;

  public int schutitKey = 0;

  public String stammgesNr = null;

  public String hauptpatNr = null;

  public String altpatNr = null;

  public int patVerfahr = 0;

  public Date ausstellDat = null;

  public String ausstellName = null;

  public Date iksDat = null;

  public String iksBez = null;

  public String iksNr = null;

  public String spcNr = null;

  public String pctAnmNr = null;

  public String pctAnmSpra = null;

  public String pctPublNr = null;

  public String pctPublSpra = null;

  public Date pctPublDat = null;

  public String epAnmSpra = null;

  public String epApublSpra = null;

  public Date epApublDat = null;

  public String epBpublSpra = null;

  public Date epBpublDat = null;

  public String epStammpatNr = null;

  public String indexIpc = null;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject PatVO zurück
   * @return Inhalt von PatVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  stammgesNr       = <" + this.stammgesNr + ">\n" );
    buf.append( "  hauptpatNr       = <" + this.hauptpatNr + ">\n" );
    buf.append( "  altpatNr         = <" + this.altpatNr + ">\n" );
    buf.append( "  patVerfahr       = <" + this.patVerfahr + ">\n" );
    buf.append( "  ausstellDat      = <" + this.ausstellDat + ">\n" );
    buf.append( "  ausstellName     = <" + this.ausstellName + ">\n" );
    buf.append( "  iksDat           = <" + this.iksDat + ">\n" );
    buf.append( "  iksBez           = <" + this.iksBez + ">\n" );
    buf.append( "  iksNr            = <" + this.iksNr + ">\n" );
    buf.append( "  spcNr            = <" + this.spcNr + ">\n" );
    buf.append( "  pctAnmNr         = <" + this.pctAnmNr + ">\n" );
    buf.append( "  pctAnmSpra       = <" + this.pctAnmSpra + ">\n" );
    buf.append( "  pctPublNr        = <" + this.pctPublNr + ">\n" );
    buf.append( "  pctPublSpra      = <" + this.pctPublSpra + ">\n" );
    buf.append( "  pctPublDat       = <" + this.pctPublDat + ">\n" );
    buf.append( "  epAnmSpra        = <" + this.epAnmSpra + ">\n" );
    buf.append( "  epApublSpra      = <" + this.epApublSpra + ">\n" );
    buf.append( "  epApublDat       = <" + this.epApublDat + ">\n" );
    buf.append( "  epBpublSpra      = <" + this.epBpublSpra + ">\n" );
    buf.append( "  epBpublDat       = <" + this.epBpublDat + ">\n" );
    buf.append( "  epStammpatNr     = <" + this.epStammpatNr + ">\n" );
    buf.append( "  indexIpc         = <" + this.indexIpc + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }

}
