package ch.ige.rbbagisexport.server.vo;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;

/**
 * Value object for BAGIS (Search Report) export data.
 * 
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author kuenzli
 * @version $Id: RBExportVO.java,v 1.10 2008/05/06 11:16:29 kuenzli Exp $
 */
public class RBExportVO implements Serializable
{
  private static final long serialVersionUID = 1L;

  private String appNr = null;

  private Date applicationDate = null;

  private Date priorityDate = null;

  private List<String> applicantNames = null;

  private String title = null;

  private List<String> ipcClasses = null;

  private Integer language = null;

  private String investigator = null;

  public Date getApplicationDate()
  {
    return ( this.applicationDate != null ? new Date( this.applicationDate.getTime() ) : null );
  }

  public void setApplicationDate( Date applicationDate )
  {
    this.applicationDate = ( applicationDate != null ? new Date( applicationDate.getTime() ) : null );
  }

  public String getInvestigator()
  {
    return this.investigator;
  }

  public void setInvestigator( String investigator )
  {
    this.investigator = investigator;
  }

  public List<String> getIpcClasses()
  {
    return this.ipcClasses;
  }

  public void setIpcClasses( List<String> ipcClasses )
  {
    this.ipcClasses = ipcClasses;
  }

  public Date getPriorityDate()
  {
    return ( this.priorityDate != null ? new Date( this.priorityDate.getTime() ) : null );
  }

  public void setPriorityDate( Date priorityDate )
  {
    this.priorityDate = ( this.priorityDate != null ? new Date( this.priorityDate.getTime() ) : null );
  }

  public String getTitle()
  {
    return this.title;
  }

  public void setTitle( String title )
  {
    this.title = title;
  }

  public List<String> getApplicantNames()
  {
    return this.applicantNames;
  }

  public void setApplicantNames( List<String> applicantNames )
  {
    this.applicantNames = applicantNames;
  }

  public Integer getLanguage()
  {
    return this.language;
  }

  public void setLanguage( Integer language )
  {
    this.language = language;
  }

  public String getAppNr()
  {
    return this.appNr;
  }

  public void setAppNr( String appNr )
  {
    this.appNr = appNr;
  }

  @Override
  public String toString()
  {
    return ReflectionToStringBuilder.toString( this );
  }

}
