package ch.ige.rbbagisimport.common.vo;

import java.io.Serializable;
import java.util.HashMap;

/**
 * 
 * Daten einer Reihe von Sysparams werden hier gehalten.
 * 
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   wild
 * @version  $Id: XxSysparamsVO.java,v 1.4 2008/05/06 13:54:36 wild Exp $
 */
@SuppressWarnings( "serial" )
public class XxSysparamsVO implements Serializable
{
  /**
   * Mailhost 
   */
  public static final Integer RB_IMPORT_SMTP_HOST_PARAM_ID = Integer.valueOf( 44 );

  /**
   * Mailempfänger Benutzer 
   */
  public static final Integer RB_IMPORT_MAIL_TO_PARAM_ID = Integer.valueOf( 66 );

  /**
   * Mailempfänger ISO 
   */
  public static final Integer RB_IMPORT_MAIL_TO_ISO_PARAM_ID = Integer.valueOf( 67 );

  /**
   * Mail CC 
   */
  public static final Integer RB_IMPORT_MAIL_CC_PARAM_ID = Integer.valueOf( 46 );

  /**
   * Mail From 
   */
  public static final Integer RB_IMPORT_MAIL_FROM_PARAM_ID = Integer.valueOf( 47 );

  /**
   * Basispfad vom Import
   */
  public static final Integer RB_IMPORT_SERVER = Integer.valueOf( 68 );

  /**
   * Basispfad vom Import
   */
  public static final Integer RB_IMPORT_PATH = Integer.valueOf( 60 );

  /**
   * Verzeichnis, wo die Draft-Reports abgelegt sind
   */
  public static final Integer RB_IMPORT_DRAFT_PARAM_ID = Integer.valueOf( 61 );

  /**
   * Verzeichnis, wo die Final-Reports abgelegt sind
   */
  public static final Integer RB_IMPORT_FINAL_PARAM_ID = Integer.valueOf( 62 );

  /**
   * Basispfad der verarbeiteten Reports 
   */
  public static final Integer RB_IMPORT_FOLDER_PROCESSED_PARAM_ID = Integer.valueOf( 63 );

  /**
   * Verzeichnis, wo die Fehler-Reports abgelegt sind
   */
  public static final Integer RB_IMPORT_FOLDER_ERROR_PARAM_ID = Integer.valueOf( 64 );

  /**
   * Verzeichnis, wo die Logs geschrieben werden.
   */
  public static final Integer RB_LOG_FOLDER_PARAM_ID = Integer.valueOf( 65 );

  private HashMap<Integer, String> valueList;

  /**
   * 
   * Füllen der lokalen Daten
   * @param paramId
   * @param value
   */
  public void loadParam( Integer paramId, String value )
  {
    if ( this.valueList == null )
    {
      this.valueList = new HashMap<Integer, String>();
    }
    valueList.put( paramId, value );

  }

  /**
   * Rückgabe des Wertes von einem Parameter
   * 
   * @param paramId
   * @return String Value
   */
  public String getParam( Integer paramId )
  {
    return valueList.get( paramId );
  }

  /**
   * Methode für die Ausgabe aller geladenen Einstellung .
   * 
   * @return String Value
   */
  @Override
  public String toString()
  {
    return valueList.toString();
  }

}
