package ch.ige.rbbagisimport.server.dao.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.dbutils.util.ClientInitializer;
import ch.ige.rbbagisimport.server.dao.SchutitDAO;
import ch.ige.util.server.DBHelper;

/**
 * Junit Testcase for testing Schutit-DAO run on client 
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   wild
 * @version  $Id: TestSchutit.java,v 1.1 2008/05/05 16:14:09 wild Exp $
 */
public class TestSchutit extends TestCase
{
  /**
   * Konstruktor
   * @param s
   */
  public TestSchutit( String s )
  {
    super( s );
  }

  static
  {
    BasicConfigurator.configure();
    DBHelper.setRunOnServer( false );
    ClientInitializer.initStandaloneClient();
  }

  /**
   * Einfacher Test, ob ich Daten erhalte
   */
  public void testGetSchutitKey01()
  {
    String gesuchNr = "0009592";
    int expectedSchutitKey = 9592;
    try
    {
      SchutitDAO stDAO = new SchutitDAO();
      int result = stDAO.selectSchutitKeyByApplNr( gesuchNr );
      assertEquals( expectedSchutitKey, result );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  /**
   * kein Schutit vorhanden
   */
  public void testGetSchutitKey02()
  {
    String gesuchNr = "8880079";
    int expectedSchutitKey = 0;
    try
    {
      SchutitDAO stDAO = new SchutitDAO();
      int result = stDAO.selectSchutitKeyByApplNr( gesuchNr );
      assertEquals( expectedSchutitKey, result );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  /**
   * Formatierung wird ersetzt
   */
  public void testGetSchutitKey03()
  {
    String gesuchNr = "00095-92";
    int expectedSchutitKey = 9592;
    try
    {
      SchutitDAO stDAO = new SchutitDAO();
      int result = stDAO.selectSchutitKeyByApplNr( gesuchNr );
      assertEquals( expectedSchutitKey, result );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
