package ch.ige.st36xmlgenerator.dao;

import java.sql.SQLException;

import org.apache.log4j.Logger;

import ch.ige.dbutils.dao.AbstractBagisDAO;
import ch.ige.dbutils.runner.IGEQueryRunner;
import ch.ige.dbutils.sql.SQL;
import ch.ige.dbutils.sql.SQLStatement;

/**
 * DAO for selecting the configuration of the st36 xml generator
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   fabrizioli
 * @version  $Id: ST36BiblGeneratorConfigDAO.java,v 1.5 2008/09/25 07:29:27 fabrizioli Exp $
 */
public class ST36BiblGeneratorConfigDAO extends AbstractBagisDAO
{
  private static final Logger LOG = Logger.getLogger( ST36BiblGeneratorConfigDAO.class );

  private static final SQLStatement<Integer> UPDATE_STMT = SQL.update( "UPDATE crescendo.ST36XMLGENERATORCONFIG set value = ? where key = ?" );

  /**
   * Update the start time for the lookup of the events
   * @param ereigidat the new start ereigidat
   */
  public void updateStartTime( final int ereigidat )
  {
    this.execute( new SingleDAOUnitOfWork<Void>()
    {
      @SuppressWarnings("synthetic-access")
      public void execute( IGEQueryRunner runner ) throws SQLException
      {
        int count = runner.update( UPDATE_STMT, ereigidat, "start_ereigidat" );
        verifyUpdateCount( count, 1, "update to start_ereigidat failed" );
      }
    } );
  }

}
