package ch.ige.st36xmlgenerator.ejb;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.NamingException;

import ch.ige.st36xmlgenerator.ST36BiblGeneratorImpl;

/**
 * XML Generator EJB Services.
 * 
 * @author fabrizioli
 * @version $Id: ST36BiblGeneratorFacadeBean.java,v 1.6 2008/09/25 07:29:27 fabrizioli Exp $ *
 *          <p>
 * @ejb.bean name="ST36XMLGeneratorFacade" description="ST36XMLGeneratorFacade" display-name="ST36XMLGeneratorFacade"
 *           view-type="remote" jndi-name="ST36XMLGenerator" type="Stateless" transaction-type="Container"
 *           remote-business-interface="ch.ige.st36xmlgenerator.ST36BiblGenerator"
 * @ejb.home remote-class="ch.ige.st36xmlgenerator.ejb.ST36BiblGeneratorFacadeHome"
 * @ejb.interface remote-class="ch.ige.st36xmlgenerator.ejb.ST36BiblGeneratorFacade"
 * @ejb.transaction type="Required"
 * Not available in IGEEAR ejb.ejb-external-ref view-type= "local" type="Session" link="IPObject" ref-name="ejb/IPObjectLocal"
 *                       home="ch.ige.ipobjects.ejb.IPObjectLocalHome" business= "ch.ige.ipobjects.services.Services"
 */
public class ST36BiblGeneratorFacadeBean extends ST36BiblGeneratorImpl implements SessionBean
{

  public void ejbCreate() throws CreateException
  {
    try
    {
      this.initJ2EE();
    }
    catch ( NamingException e )
    {
      this.LOG.error( "could not find dependant components", e );
      throw new RuntimeException( "Can't initialize the ST36BiblGenerator:" + e.getMessage(), e );
    }
  }

  public void ejbRemove()
  {
    this.disposeService();
  }

  public void ejbActivate()
  {
  }

  public void ejbPassivate()
  {
  }

  @SuppressWarnings( "unused" )
  public void setSessionContext( SessionContext sessionContext )
  {
  }

}
