package ch.ige.ses.client.sapinbound;

import org.apache.log4j.*;
import ch.ige.ses.client.saputil.*;
import com.sap.mw.jco.*;

/**
 * SAP Remote Function Module Z_BAPI_ZVL_COMMIT_ANNUAL_FEE
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: RFM_Z_BAPI_ZVL_COMMIT_ANNUAL_FEE.java,v 1.8 2006/12/11 12:43:32 iten Exp $
 */
public class RFM_Z_BAPI_ZVL_COMMIT_ANNUAL_FEE extends RFM
{
  //
  // const
  //
  private static final Logger  LOG = Logger.getLogger(RFM_Z_BAPI_ZVL_COMMIT_ANNUAL_FEE.class);

  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  public RFM_Z_BAPI_ZVL_COMMIT_ANNUAL_FEE(IRepository repository)
  {
    super("Z_BAPI_ZVL_COMMIT_ANNUAL_FEE",repository);
  }

  //---------------------------------------------------------------------------
  // public methods
  //---------------------------------------------------------------------------

  public void addSeqNumber(String jgbLaufNr)
  {
    try
    {
      this.setImportParam(jgbLaufNr);

    }
    catch (Exception ex)
    {
      LOG.error("exception: " + ex.toString());
      throw new RfmException(ex.toString());
    }
  }


  public String toStringSeqNumber()
  {
    JCO.ParameterList in  = this.fJCoFunc.getImportParameterList();
    StringBuffer      buf = new StringBuffer();

    // import params
    buf.append(in.toString());

    return buf.toString();
  }

  //---------------------------------------------------------------------------
  // private methods
  //---------------------------------------------------------------------------

  private void setImportParam(String jgbLaufNr)
  {
    JCO.ParameterList input = this.fJCoFunc.getImportParameterList();

    input.setValue(jgbLaufNr,"ANN_FEE_SEQ_NO");
  }


} // end class


