package ch.ige.ses.client.sapinbound;

import java.util.*;
import java.lang.*;
import java.math.BigDecimal;
import com.sap.mw.jco.*;
import org.apache.log4j.*;
import ch.ige.ses.vo.bagis.*;
import ch.ige.ses.client.saputil.*;

/**
 * SAP Remote Function Module Z_BAPI_ZVL_REJECT_BILLING_REQ
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: RFM_Z_BAPI_ZVL_REJECT_BILLING_REQ.java,v 1.10 2006/12/11 12:43:32 iten Exp $
 */
public class RFM_Z_BAPI_ZVL_REJECT_BILLING_REQ extends RFM
{
  //
  // const
  //
  private static final Logger  LOG = Logger.getLogger(RFM_Z_BAPI_ZVL_REJECT_BILLING_REQ.class);

  //
  // fields
  //
  private boolean fImportParamIsSet  = false;

  public  String  fNextStep          = "";        // next step in process (trave info)

  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------
  public RFM_Z_BAPI_ZVL_REJECT_BILLING_REQ (IRepository repository)
  {
    super("Z_BAPI_ZVL_REJECT_BILLING_REQ",repository);
  }

  //---------------------------------------------------------------------------
  // public methods
  //---------------------------------------------------------------------------

  public void addAnnullation(SAPRechnungAnnullationVO vo)
  {
    try
    {
      if (! this.fImportParamIsSet)                 // set only once per call
        this.setImportParam();

      this.setReject(vo);
    }
    catch (Exception ex)
    {
      LOG.error("exception: " + ex.toString());
      LOG.error("hint (next step): " + fNextStep);
      throw new RfmException(ex.toString());
    }
  }


  public String toStringAnnullation()
  {
    JCO.ParameterList in  = this.fJCoFunc.getImportParameterList();
    JCO.Table         tbl = this.fJCoFunc.getTableParameterList().getTable("REJECT");
    StringBuffer      buf = new StringBuffer();

    // import params
    buf.append(in.toString());

    // table reject
    buf.append(tbl.toString());

    return buf.toString();
  }

  //---------------------------------------------------------------------------
  // private methods
  //---------------------------------------------------------------------------

  private void setImportParam()
  {
    JCO.ParameterList input = this.fJCoFunc.getImportParameterList();

    fNextStep = "setImportParam - TESTRUN";
    input.setValue(" ",       "TESTRUN");

    fNextStep = "setImportParam - COMMIT";
    input.setValue("X",       "COMMIT");

    this.fImportParamIsSet = true;
  }


  private void setReject(SAPRechnungAnnullationVO vo)
  {
    JCO.Table tbl = this.fJCoFunc.getTableParameterList().getTable("REJECT");

    tbl.appendRow();

    fNextStep = "setReject - DOC_NUMBER / vo.bfakt_id";

    tbl.setValue(Convert.toSapDocNumber(vo.bfakt_id),    "DOC_NUMBER");

    fNextStep = "setImportParam - REASON_REJ / vo.absageGrund";
    tbl.setValue(Convert.toSapReasonRej(vo.absageGrund), "REASON_REJ");
  }

} // end class


