package ch.ige.ses.server.bagisoutbound;

import javax.ejb.EJBException;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.apache.log4j.Logger;

/**
 * Helper class for Bean Interface Lookup within other EJB's.
 * <p>
 * Copyright (c) 2007, Eidgenössisches Institut für Geistiges Eigentum
 * 
 * @author T. Iten
 * @version $Id: SESFacadeLookup.java,v 1.1 2007/01/03 14:28:28 iten Exp $
 */
public class SESFacadeLookup
{
  //
  // const
  //
  private static final Logger LOG = Logger.getLogger( SESFacadeLookup.class );

  //
  // fields
  //
  private SESFacadeLocalHome localHomeInterface = null;
  private SESFacadeLocal localInterface = null;

  // ---------------------------------------------------------------------------
  // constructors
  // ---------------------------------------------------------------------------

  /**
   * create instance
   */
  public SESFacadeLookup()
  {
    // lazy bone
  }

  // ---------------------------------------------------------------------------
  // methods
  // ---------------------------------------------------------------------------

  /**
   * get local interface with lazy loading
   * 
   * @return SESFacadeLocal
   */
  public SESFacadeLocal getLocalInterface()
  {
    try
    {
      if ( localInterface == null )
      {
        Context ctx = new InitialContext();
        Object ref = ctx.lookup( SESFacadeLocalHome.COMP_NAME );

        localHomeInterface = (SESFacadeLocalHome) ref;
        localInterface = localHomeInterface.create();
      }

      return localInterface;
    }
    catch ( Exception ex )
    {
      localHomeInterface = null;
      localInterface = null;

      LOG.error( "getLocalInterface - Exception: " + ex.getMessage() );
      throw new EJBException( ex );
    }
  }

} // end class

