package ch.ige.ses.server.bagisoutbound;

import javax.ejb.*;
import javax.naming.*;
import org.apache.log4j.*;

/**
 * Helper Class for Bean Interface Lookup within other EJB's.
 * Note: Do NOT use this class witin any client Application, since it uses the
 *       server side logging mecanism.
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: SESRechnungLookup.java,v 1.7 2006/12/13 14:54:56 iten Exp $
 */
public class SESRechnungLookup
{
  //
  // const
  //
  private static final Logger   LOG       = Logger.getLogger(SESRechnungLookup.class);

  //
  // fields
  //
  private SESRechnungLocalHome  localHomeInterface  = null;
  private SESRechnungLocal      localInterface      = null;


  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  public SESRechnungLookup()
  {
    // lazy bone
  }


  //---------------------------------------------------------------------------
  //  methods
  //---------------------------------------------------------------------------

  /**
   * get local interface with lazy loading
   *
   * @return SESRechnungLocal
   */
  public SESRechnungLocal getLocalInterface()
  {
    try
    {
      if (localInterface == null)
      {
        Context ctx = new InitialContext();
        Object  ref = ctx.lookup(SESRechnungLocalHome.COMP_NAME);

        localHomeInterface = (SESRechnungLocalHome) ref;
        localInterface     = localHomeInterface.create();
      }

      return localInterface;
    }
    catch (Exception ex)
    {
      localHomeInterface  = null;
      localInterface      = null;

      LOG.error("getLocalInterface - Exception: " + ex.getMessage());
      throw new EJBException(ex);
    }
  }


} // end class

