package ch.ige.ses.server.dao.ses.test;

import java.sql.*;


import ch.ige.ses.server.dao.ses.*;
import ch.ige.ses.vo.ses.*;
import junit.framework.*;


/**
 * Test der Klasse StatistikDAO
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Anita Rueegsegger
 * @version $Id: StatistikDAOTest.java,v 1.9 2007/07/11 14:07:55 lang Exp $
 */

public class StatistikDAOTest extends SesTestCase
{
  private static  Connection conJDBC;
  private final   String URL = "jdbc:oracle:thin:@ipiesa1030.ipie.ch:1521:EIGE";

  //---------------------------------------------------------------------------
  // constructor
  //---------------------------------------------------------------------------

  public StatistikDAOTest(String s)
  {
    super(s);

    try
    {
      if (conJDBC == null)
      {
        //Treiberklasse laden
        Class.forName("oracle.jdbc.driver.OracleDriver");
        System.out.println("Treiber erfolgreich geladen");

        // DB-Verbindung aufbauen
        conJDBC = DriverManager.getConnection(URL, "ses_user01", "schnittstelle01");
        System.out.println("Db-Connection erfolgreich durchgeführt");
      }
    }
    catch (SQLException sqlex)
    {
      System.out.println("Db-Connection kann nicht durchgeführt werden: " + sqlex.getMessage() );
    }
    catch (Exception ex)
    {
      System.out.println("Es kann keine Datenbankverbindung hergestellt werden. Message: " + ex.getMessage() );
    }
  }


  //---------------------------------------------------------------------------
  // init / clean-up
  //---------------------------------------------------------------------------

  public static Test suite()
  {
     return new TestSuite(StatistikDAOTest.class);
  }

  protected void setUp()
  {
    // lazy bone
  }


  protected void tearDown()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // tests
  //---------------------------------------------------------------------------

  public void testDummy()
  {
    /** TODO junit - testfälle junit tauglich machen */
    assertEquals(true,true);
  }


  public void _testInsert()
  {
    try
    {
      System.out.println("Test INSERT STATISTIKVO");

      StatistikDAO statistikDAO = new StatistikDAO();
      StatistikVO statistikVO = new StatistikVO();
      StatistikVO statistikVO1 = new StatistikVO();

      statistikVO.jgbLaufId = selectMaxLaufId();
      statistikVO.data = "Testcase";

      System.out.println(statistikVO.toString());
      statistikDAO.insert(statistikVO);

      System.out.println("Test SELECT STATISTIKVO");
      // testen ob Datensatz eingefügt wurde
      statistikVO1 = statistikDAO.select(statistikVO.jgbLaufId);
      if (statistikVO1 == null)
      {
        System.out.println("Kein Datensatz mit jgb_lauf_id: " + statistikVO.jgbLaufId + " vorhanden");
      }
      else
      {
        System.out.println(statistikVO1.toString());
      }

      assertEquals(statistikVO.jgbLaufId, statistikVO1.jgbLaufId);
      assertEquals(statistikVO.data, statistikVO1.data);
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }

  //---------------------------------------------------------------------------
  // private methods
  //---------------------------------------------------------------------------

  public int selectMaxLaufId()
  {
     PreparedStatement ps   = null;
     ResultSet         rs   = null;
     int               maxLaufId = 0;

     try
     {
       ps = conJDBC.prepareStatement
           ( "select MAX (jgb_lauf_id) as jgb_lauf_id from jgb_lauf" );

       rs = ps.executeQuery();

       if( rs.next() )
       {
         maxLaufId = rs.getInt("jgb_lauf_id");
       }
     }
     catch (Exception ex)
     {
       System.out.println("Message: " + ex.getMessage() );
     }
     finally
     {
       try
       {
         if (ps != null) ps.close();
       }
       catch (Exception ex)
       {
         System.out.println("Message: " + ex.getMessage() );
       }
     }
    return maxLaufId;
  }

} // end class


