package ch.ige.ses.server.sapctrl.test;

import org.apache.log4j.BasicConfigurator;

import junit.framework.*;

import ch.ige.ses.server.sapctrl.*;
import ch.ige.ses.vo.ses.*;

/**
 * JUnit Test Class
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: SapDelegateOutboundTest.java,v 1.8 2007/01/10 08:57:41 iten Exp $
 */
public class SapDelegateOutboundTest extends TestCase
{
  //
  // fields
  //
  private SapDelegateOutbound   delegate = null;



  //---------------------------------------------------------------------------
  // constructor
  //---------------------------------------------------------------------------

  public SapDelegateOutboundTest(String s) throws Exception
  {
    super(s);
    BasicConfigurator.configure();
    delegate = SapDelegateOutbound.getInstance();
  }

  //---------------------------------------------------------------------------
  // init / clean-up
  //---------------------------------------------------------------------------

  public static Test suite()
  {
     return new TestSuite(SapDelegateOutboundTest.class);
  }

  protected void setUp()
  {
    // lazy bone
  }


  protected void tearDown()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // tests
  //---------------------------------------------------------------------------

  public void _testReceiveError() throws Exception
  {
    ErrorVO vo = new ErrorVO();

    try
    {
      vo.source          = "JUnit Runner";
      vo.employeeId      = null;
      vo.employeeNotify  = ErrorVO.EMPL_NOTIFY_KEINE;
      vo.employeeMsgType = ErrorVO.EMPL_MSG_TYPE_DEFAULT;
      vo.description     = "JUnit Test - SapDelegateOutboundTest.testReceiveError";
      vo.dataTypeCd      = ErrorVO.DATA_TYPE_CD_STRING;
      vo.data            = "SapDelegateOutboundTest.testReceiveError";
      vo.errorStat       = ErrorVO.ERROR_STAT_ANNULIERT;

      delegate.receiveError(vo);
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
      fail(ex.toString());
    }
  }


  public void testReceivePing() throws Exception
  {
    String msg = "hello from test";
    String ret = null;
    try
    {
      ret = delegate.receivePing(msg);
      assertNotNull(ret);
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
      fail(ex.toString());
    }
  }


  public void _testReceiveTrace() throws Exception
  {
    TraceVO vo = new TraceVO();

    try
    {
      vo.process     = "JUnit Runner";
      vo.processNr   = "1234";
      vo.action      = "JUnit Test - SapDelegateOutboundTest.testReceiveTrace";
      vo.data        = "SapDelegateOutboundTest.testReceiveTrace";

      delegate.receiveTrace(vo);
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
      fail(ex.toString());
    }
  }

} // end class

