package ch.ige.ses.util;


/**
 * <p>Darstellungsobjekt für einen Combobox-Eintrag</p>
 * <p>Wird angewendet, sofern der ComboBox-Eintrag aus zwei Werten zusammengesetzt wird
 * und die Werte einzeln angesprochen werden können müssen</p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author T.Iten, A.Rueegsegger
 * @version $Id: ComboBoxObject.java,v 1.6 2006/12/13 14:54:56 iten Exp $
 */


public class ComboBoxObject extends Object
{

  public String key = null;
  public String value = null;


  public ComboBoxObject()
  {
    // lazy bone
  }


  /**
   * Konstruktor
   * @param key     Datenbank-Wert
   * @param value   Definiton des Datenbank-Wertes
   */
  public ComboBoxObject(String key, String value)
  {
    this.key = key;
    this.value = value;
  }


  /**
   * Gibt die Werte der Variablen key und value mit Komma abgetrennt zurück
   * @return gibt die Werte der Variablen key und value kommagetrennt zurück
   */
  public String toString()
  {

    if (key == null || value == null)
    {
      return (key == null ? "" : key) + (value == null ? "" : value);
    }
    else
    {
      return key + ", " + value;
    }
  }


  /**
   * Vergleicht den Inhalt der Instazvariablen beider Objekte miteinander
   * @param object Objekt das auf Gleichheit mit diesem Objekt überprüft werden soll
   * @return true sofern Werte der Instazvariablen des übergebene Objekt mit diesem übereinstimmen
   */
  public boolean equals(Object object)
  {
    if(object instanceof ComboBoxObject)
    {
      ComboBoxObject combo = (ComboBoxObject)object;
      return this.toString().equals(combo.toString());
    }
    else
    {
      return false;
    }
  }
}


