package ch.ige.ses.util.test;

import junit.framework.*;
import ch.ige.ses.server.dao.ses.PropertyDAO;
import ch.ige.ses.util.MailSender;

/**
 * <p>Überschrift: MailSenderTest</p>
 * <p>Beschreibung:Test der Klasse MailSender</p>
 * <p>Copyright: Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author Stefan Nydegger
 * @version $Id: MailSenderTest.java,v 1.11 2006/12/11 12:43:32 iten Exp $
 */

public class MailSenderTest extends TestCase
{
  public MailSenderTest(String parName)
  {
    super (parName);
  }

  /**
   * suite überschreibt Klassenmethode. Gibt die eigene Klasse als Testsuite zurück
   * @return new TestSuite()
   */
  public static Test suite()
  {
    return new TestSuite(MailSenderTest.class);
  }
  /**
   * Main-Methode der Testklasse MailSenderTest
   * @param   args    Übergebene Parameter
   */
  public static void main (String[] args)
  {
    junit.textui.TestRunner.run(suite());
  }

  public void testDummy()
  {
    /** TODO junit - testfälle junit tauglich machen (umschreiben, damit dieser auch ohne JMS läuft) */
  }

  /**
   * Testen des Senden eines Emailes. Der SMTP-Server wird aus der SES-Tabelle
   * PROPERTY gelesen.
   *
   * Achtung: Läuft nur falls JMS Conneton nicht refused wird. Dies ist nur bei
   * einer produktiven AppServer Lizenz der Fall!
   */
  public void _testSendMail()
  {
    try
    {
      //SMTP-Server aus SES-Tabelle Property holen
      String smtpServer = new PropertyDAO().select("mail.smtpserver").value;
      String to = "stefan.nydegger@ipi.ch";
      String cc = "stefan.nydegger@ipi.ch";
      String from = "stefan.nydegger@ipi.ch";
      String subject = "Test der Klasse MailSender";
      String body = "Mal schauen, ob das Ding funktioniert.\n vielleicht auch " +
                    "mit einer neuen Zeile\n\n. Und wie sieht das aus mit "+
                    "ö, ä, ü ??, und mit den Ä, Ö, Ü ?? \n et pour les amis romands: " +
                    "é, à us";

      // Mail schicken mit CC
      System.out.println("Test SendMail with CC");
      MailSender.sendMail(smtpServer, to, cc, from, subject, body);
      // Mail schicken ohne CC
      System.out.println("Test SendMail without CC");
      MailSender.sendMail(smtpServer, to, from, subject, body);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.getMessage());
    }
  }
}

