package ch.ige.ses.vo.ses;

/**
 * Statistik Calculations Rechnungsempfänger
 * Das Value Object beinhaltet die für die Satistik relevanten Daten
 * eines Rechnungsempfängers.
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author Thomas Iten
 * @version $Id: StatistikCalcReVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */
public class StatistikCalcReVO
{
  //
  // fields
  //
  public  int     bfaktId   = 0;
  public  int     adrNr     = 0;
  public  String  listenArt = null;

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public StatistikCalcReVO()
  {
    // lazy bone
  }

  public StatistikCalcReVO(int bfaktId, int adrNr, String listenArt)
  {
    this.bfaktId   = bfaktId;
    this.adrNr     = adrNr;
    this.listenArt = listenArt;
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  bfaktId   =  " + bfaktId    + "\n");
    buf.append("  adrNr     =  " + adrNr      + "\n");
    buf.append("  listenArt =  " + listenArt  + "\n");

    return buf.toString();
  }

  public String toStringRow()
  {
    return (bfaktId + " " + adrNr + " " + listenArt);
  }

} // end class

