package ch.ige.ses.vo.ses;

import java.io.Serializable;
import java.sql.Date;


/**
 * SES Value Object für die Tabelle TRACE
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: TraceVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */
public class TraceVO implements Serializable
{
  //
  // const
  //
  public static final String PROCESS_SAP_INBOUND  = "SapInbound";
  public static final String PROCESS_SAP_OUTBOUND = "SapOutbound";

  public static final String ACTION_OK            = "OK ";
  public static final String ACTION_NOK           = "NOK";
  public static final String ACTION_SEP           = " - ";

  //
  // fields
  //
  public int      traceId     = 0;        // not used for insert (autoincrement)
  public String   process     = null;     // SapInbound or SapOutbound
  public String   processNr   = null;     // SapInbound ProgramId or SapOutbound ServerNr
  public String   action      = null;     // Action performed
  public String   data        = null;     // Data used
  public Date     createdDat  = null;     // not used for insert (default value)

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public TraceVO()
  {
    // lazy bone
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  traceId       =  " + traceId      + "\n");
    buf.append("  process       =  " + process      + "\n");
    buf.append("  processNr     =  " + processNr    + "\n");
    buf.append("  action        =  " + action       + "\n");
    buf.append("  data          =  " + data         + "\n");
    buf.append("  createdDat    =  " + createdDat   + "\n");

    return buf.toString();
  }

} // end class

