package ch.ige.wdltool.exception;

/**
 * Wraps a {@link RuntimeException}, in order to show to the caller
 * that this is <strong>not</strong> a system error.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   lewis_lee
 * @version  $Id: WrappedRuntimeException.java,v 1.1 2008/01/18 12:08:09 lewis_lee Exp $
 */
public class WrappedRuntimeException extends Exception
{
  /**
   * Creates this only with a message.
   * @param message The error message
   */
  public WrappedRuntimeException( String message )
  {
    super( message );
  }

  /**
   * Creates this only with a cause.
   * @param cause The cause of this
   */
  public WrappedRuntimeException( Throwable cause )
  {
    super( cause );
  }

  /**
   * Creates this with everything.
   * @param message The error message
   * @param cause The cause of this
   */
  public WrappedRuntimeException( String message, Throwable cause )
  {
    super( message, cause );
  }
}