package ch.ige.wdltool.validator;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;
import java.lang.annotation.RetentionPolicy;

import org.hibernate.validator.ValidatorClass;

/**
 * Checks for valid languages (Locales).
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: Language.java,v 1.1 2007/08/08 12:52:59 lewis_lee Exp $
 */
@ValidatorClass( LanguageValidator.class )
@Target( ElementType.METHOD )
@Retention( RetentionPolicy.RUNTIME )
@Documented
public @interface Language
{
  /**
   * The allowed comma-separated ISO language codes, for instance
   * <code>de,fr,it</code>
   */
  String isoCodes();
  
  /**
   * The error message to show
   */
  String message() default "{validator.language}";
}
