package ch.ige.wdltool.validator;

import org.hibernate.validator.Validator;

import ch.ige.wdlutil.text.CharacterChecker;

/**
 * Validates a search term.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: SearchTermValidator.java,v 1.5 2008/05/07 12:44:14 lewis_lee Exp $
 */
public class SearchTermValidator implements Validator<SearchTerm>
{
  // @see org.hibernate.validator.Validator#initialize(java.lang.annotation.Annotation)
  @SuppressWarnings( "unused" )
  public void initialize( SearchTerm parameters )
  {
    // Nothing to do
  }

  //part of the property constraint contract
  public boolean isValid( Object value )
  {
    if ( value == null )
    {
      return true;
    }
    if ( !( value instanceof String ) )
    {
      return false;
    }
    String searchTerm = (String) value;
    if ( searchTerm.startsWith( " " ) )
    {
      return false;
    }
    if ( searchTerm.endsWith( " " ) )
    {
      return false;
    }
    return CharacterChecker.checkSearchTerm( searchTerm ).isEmpty();
  }
}
