package ch.ige.wdltool.vo;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.dbutils.vo.IdentifiableVO;

/**
 * Contains a key/value pair (configuration entry).
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author heinzer
 * @version  $Id: ConfigurationVO.java,v 1.4 2007/06/25 11:49:21 heinzer Exp $
 */
public class ConfigurationVO extends AbstractVO implements IdentifiableVO<Integer>
{
  /**
   * The unique ID
   */
  private Integer configurationId;

  /**
   * The key
   */
  private String key;

  /**
   * The value
   */
  private String value;

  // @see ch.ige.dbutils.vo.IdentifiableVO#getIdentifier()
  public Integer getIdentifier()
  {
    return this.configurationId;
  }

  // @see ch.ige.dbutils.vo.IdentifiableVO#setIdentifier(java.io.Serializable)
  public void setIdentifier( Integer id )
  {
    this.configurationId = id;
  }

  /**
   * Gets the key.
   * @return the key
   */
  public String getKey()
  {
    return this.key;
  }

  /**
   * Sets the key.
   * @param key The key to set
   */
  public void setKey( String key )
  {
    this.key = key;
  }

  /**
   * Gets the actual value.
   * @return the value
   */
  public String getValue()
  {
    return this.value;
  }

  /**
   * Sets the actual value.
   * @param value The value to set
   */
  public void setValue( String value )
  {
    this.value = value;
  }
  
  /**
   * Sets key/value for actual configuration entry.
   * @param key The key to set
   * @param value The value to set
   */
  public void set(String key, String value) {
    setKey(key);
    setValue(value);
  }  
}
