package ch.ige.wdltool.vo;

import org.hibernate.validator.Range;

/**
 * Contains the data for an IPI term group.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Esther Bandschapp
 * @version  $Id: IpiTermGroupVO.java,v 1.9 2008/02/14 16:03:26 lewis_lee Exp $
 */
public class IpiTermGroupVO extends TermGroupVO
{
  /**
   * The empty constructor
   */
  public IpiTermGroupVO()
  {
    super();
  }

  /**
   * Sets the IPI term number.
   * @param ipiTermNumber The IPI term number to set
   */
  public void setIpiTermNumber( Integer ipiTermNumber )
  {
    this.ipiTermNumber = ipiTermNumber;
  }

  /**
   * Gets the IPI term number.
   * @return the IPI term number
   */
  @Range( min = 1000000, max = 9999999 )
  public Integer getIpiTermNumber()
  {
    return this.ipiTermNumber;
  }
}
