package ch.ige.wdltool.vo;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.dbutils.vo.IdentifiableVO;

/**
 * A term group provides an ID and a term group name, according to which the WDL  
 * terms can be grouped together. <br/>
 * A term group can always only have as text: Either a name from the standard WDL,
 * an IPI term number or a Nice term number.  
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Esther Bandschapp
 * @version  $Id: TermGroupVO.java,v 1.5 2007/08/10 09:21:35 lewis_lee Exp $
 */
public abstract class TermGroupVO extends AbstractVO implements IdentifiableVO<Integer>
{
  /**
   * The unique ID for the term group
   */
  private Integer termGroupId;

  /**
   * The name of the term group
   */
  protected String name;

  /**
   * The Nice term number
   */
  protected Integer niceTermNumber;

  /**
   * The IPI term number
   */
  protected Integer ipiTermNumber;

  
  // @see ch.ige.dbutils.vo.IdentifiableVO#getIdentifier()
  public Integer getIdentifier()
  {
    return this.termGroupId;
  }

  // @see ch.ige.dbutils.vo.IdentifiableVO#setIdentifier(java.io.Serializable)
  public void setIdentifier( Integer id )
  {
    this.termGroupId = id;
  }
  
}
